---------------------------------------------------------------------------------------------------------
v0.14.9.0
---------------------------------------------------------------------------------------------------------

Changes:
- If multiple turrets have been linked to the same loader, the turrets can't be swapped individually (both need to be swapped at the same time to prevent turrets from getting linked to an incorrect type of loader).
- Emergency lights don't cast shadows by default (they have such a short range that disabling the shadows usually doesn't make a difference visually, but improves the performance of the subs).
- Allow closing the submarine previews with esc.
- Made ballast pumps in Kastrull's drone indestructible (because they're impossible to access without breaking the walls/floors).
- Made exploding coilgun ammo more expensive and increased the capacity of the ammo boxes a bit.
- Made pirate subs immune to ballast flora.
- Security's stun guns spawn fully loaded.
- Reduced escort missions' base commonness. Doesn't have an effect in the campaign because the commonness is defined in the mission events, but fixes escort missions being much more common than other mission types in mission mode.
- Destroying a reactor with explosives depletes the fuel rods.
- Hide the equipment slots and character portait in wiring mode.
- Added platforms behind Remora Drone's hatches.

Fixes:
- Fixed enemies sometimes not spawning at all during a mission. Happened when the game selected the "stowaway" event to occur during the mission.
- Fixed pirate and escort missions not being available from late-game outposts.
- Fixed occasional "unauthorized multithreaded access to RandSync.Server" errors when starting a pirate mission in multiplayer.
- Fixed crashing with a "E_INVALIDARG" SharpDXException if an ice spire happens to generate on a very short level wall edge.
- Fixed crashing when trying to spawn inventory items for a character who left before respawning during the previous round.
- Fixed batteries always recharging at "full speed" when not full, regardless of how much power is being drawn from the battery. E.g. a battery that's only connected to a lamp drawing 5 kW of power would always recharge at the full 500 kWmin.
- Fixed traitor items sometimes spawning in non-interactable or hidden containers.
- Fixed turret rotation limit widgets working unreliably in the sub editor.
- Fixed barrels being misaligned on scaled turrets in the sub preview.
- Stores don't offer/request sealed supply crates as daily specials.
- Fixed campaign settings (radiation enabled, max missions) resetting when reopening the campaign settings menu.
- Fixed hitscan projectiles not hitting structures outside hulls when the turret itself is inside a hull.
- Fixed inability to swap items between the character's inventory and a container in some situations in multiplayer (when the container was right at the edge of the character's interaction range).
- Fixed bots being unable to repair the pump in Typhon's bottom airlock.
- Fixed crashing when repairing or fabricating something as a husk (or some other character with no CharacterInfo).
- Fixed crashing when reviving someone using CPR as a character with no CharacterInfo (e.g. husk).
- Fixed upgrades using the original value from a previous item when swapping to a new one (e.g. swapping a railgun to a coilgun sets the power consumption to the railgun's power consumption). More specifically, this happened when the campaign was saved and reloaded after purchasing the upgrade, and the item was swapped after that.
- Fixed wrecks sometimes being positioned right side of the exit position.
- Fixed characters not getting knocked down at the last stage of husk infection if they have the Vigor buff.
- Fixed discharge coil triggering when trying to rewire it.
- Fixed some ActionTypes having the same value (e.g. OnFire == OnDamaged). Caused wrong type of status effects triggering in some cases, for example OnDamage effects when an indestructible thalamus organ is on fire.
- Fixed items that are set to be hidden in-game being visible in the sub preview.
- Fixed bots being unable to weld leaks that are too high above them, even if they're actually in reach. Happened because the distance to the leak was calculated relative to the character's position, even though the range of the welding tool is relative to the character's shoulder.
- Fixed cargo mission rewards being displayed incorrectly when there's multiple cargo missions selected and not enough capacity for all the cargo.
- Fixed caret getting misplaced when clicking on a textbox with padding.
- Fixed headset only being able to send signals to each wifi component once.
- Fixed bots sometimes ignoring broken devices. Happened when another bot had selected the device as their repair target, even if the bot was currently repairing something else.
- Fixed nav terminal labels sometimes being draw under linked status monitor HUDs.
- Fixed bots sometimes not fixing airlock doors/hatches. More specifically, doors whose center point was outside a hull.
- Fixed medic bots grabbing the target and never letting go when there's no suitable treatments available anywhere in the sub, or when they're in an outpost and not carrying any suitable treatments.
- Fixed bots suffocating when they run out of oxygen tanks if ordered to wait wearing a suit.
- Fixed ability to select other items when operating periscopes. Didn't cause problems in vanilla subs, but in custom subs where the turret was placed close to the periscope and other interactable items, it was possible to accidentally select something else when trying to fire.
- Made nav terminal's "velocity_in" input change the target velocity, not just the steering input, making it possible to adjust the velocity with signals when using autopilot.
- Fixed text fields in a component's editing menu not refreshing until you've interacted with another component.
- Fixed ruins sometimes overlapping with level walls (when they happen to spawn next to a very large cell).
- Fixed ability to "partially open" the health interface in the sub editor, causing the inventory layout to get messed up when clicking on the character portrait even though the health interface isn't drawn.
- Fixed ability to keep dragging an item from a stunned/ragdolled character's inventory after they get back up.
- Fixed nuclear weapons not damaging ballast flora.
- Fixed normal uniforms deflecting projectiles even though they shouldn't.
- Fixed clients who've opted to spawn with reaper's tax getting a new character if the round ends before the client respawns.
- Fixed occasional crash with the error message "collection was modified; enumeration operation may not execute" when loading mods on startup.
- Fixed ability to keep dragging the previously equipped wire in the sub editor after you equip another wire with the wire hotkeys.
- Fixed characters' sprite depth changing during the "autowalk" towards a bed or chair.
- Require the sub to move a bit faster to crush characters between the sub and a wall. Previously essentially any non-zero velocity was enough to crush a character, even if the sub didn't appear to move.
- Fixed nests sometimes getting placed outside caves. Happened when the game tried to position the nest above an opening at the bottom of the cave.
- Fixed inability to use the health interface on the escorted characters.
- Fixed 1st client (usually the host) always spawning at the same spawnpoint in multiplayer even if there's multiple suitable ones available.
- Fixed stacked partially used items (e.g. stacked explosives that have been damaged) dropping from character inventories at the start of a round.
- Fixed occasional freezing when replacing lost shuttles after purchasing submarine upgrades.
- Adjusted Endworm's colliders so that you can't hit the tail between the armor segments before first breaking the armor (making it less easy to cut the worm in half).
- Fixed hull properties not carrying over when copying hulls in the sub editor.
- Fixed occasional "collection was modified" exception in CargoMission.DetermineCargo. Happened if the client received an updated campaign save while trying to load the sub between rounds.
- Fixed a broken waypoint in Berilia's cargo bay.
- Fixed seeds sometimes vanishing when trying to plant them in MP. 
- Fixed planter boxes displaying the "uproot" message when empty.
- Fixed depth charges going through doors and hatches.
- Fixed ability to dock docking hatches to ports and vice versa.
- Fixed camera being able to focus on a turret when a periscope's "position_out" connection is wired to a turret's "power_in" connection.
- Fixed water detectors not detecting very small (water depth < 1px) amounts of water in hulls.
- Fixed duffel bags not spawning at the end of a round if the character hasn't despawned/respawned yet (i.e. if the character's corpse is still present in the sub).
- Fixed wrecked Dugong's distress signal being impossible to receive due to "allow cross-team communication" being set to false on the wifi component sending the signal.
- Fixed fabricator being unable to stack empty items in the output slots, preventing empty tanks from being fabricated when the output slots are occupied even if additional tanks could be stacked on them.
- Fixed messed up "Shuttle Shell A Glass A" sprite.
- Fixed delay components not working if the delay is set to 0.
- Fixed loaders getting slightly misaligned when swapping an empty hardpoint with some weapon.
- Fixed pumps placed in the sub editor being off by default.
- Fixed weapon skill increases not being capped according to the max vitality of the target. Resulted in enormous weapon skill gains when doing massive amounts of damage (more than the target's max vitality), e.g. by shooting a hammerhead matriarch in the egg sack with a nuke.
- Fixed ability to delete vanilla beacon stations and pirate subs in the sub editor.
- Fixed pirate subs sometimes spawning in side paths that are too narrow for the sub to pass through.
- Fixed an exploit that allowed creating game-crashing infinite signal loops using wifi components.
- Fixed a typo in the abyss diving suit description (100,000 m -> 10,000 m).
- Fixed several vanilla sub docking hatches requiring a welding tool instead of a wrench to repair them.
- Fixed "Operate Weapons" order being available when interacting with a turret directly, leading to a crash when trying to do so.
- Fixed missions disappearing from abandoned outposts after finishing the campaign.
- Fixed canister shells refilling automatically between rounds.
- Fixed turrets working with incorrect loader types (e.g. coilgun being able to fire laser bolts when linked to a pulse laser loader).
- Fixed "exterior pressure exceeds diving suit capabilities" hint popping up when carrying a diving suit.
- Fixed biome noise loops still playing after the round ends.
- Fixed detonator rapidly draining condition from flash powder and incendium instead of exploding them immediately (potentially resulting in partially used items).
- Fixed exploit in plastiseal crafting recipe (plastiseal deconstructing to 1 bandage even though 1 bandage can be used to craft 2 plastiseal).
- Fixed RepairTools applying their effects multiple times to items whose bodies consist of multiple fixtures. Caused minerals to get deattached 3 times faster than they should.
- Fixed AFK kicks when staying in any of the campaign UIs (store, etc) or other input-blocking menus for too long.
- Fixed monsters sometimes targeting owners of targeted items although the owner is ignored.
- Fixed some items held in the left hand rendering in front of the character's thigh.
- Fixed characters being focusable through UI elements (e.g. item interfaces), causing accidental interactions when the NPC interaction key is bind to LMB.

Modding:
- Added support for "additive" event sets which get added on top of another normal event set, allowing mods to spawn additional types of monsters without having to touch the vanilla event sets. See the "transitevents" event set in OutpostEvents.xml for an usage example.
- Fixed subs appearing to disappear after being published in the Workshop, because the content package the sub gets moved to wasn't automatically selected.
- Fixed MaxTargetsToHit not working on hitscan projectiles.
- Fixed offsets not being taken into account when positioning contained items, causing status effects to happen at the position of the container instead of the position of the contained item. Didn't have a noticeable effect in the vanilla game because most contained items are positioned close to the container's origin.
- Fixed spawnpoint's job restrictions being ignored when spawning pirates and escortees.
- It's now possible to use multiple equipped WifiComponents at the same time: instead of finding the first equipped item and seeing if it can receive/transmit, the game now goes through the items until it finds one that can.
- Fixed crashing when trying to pick an item that can't be put in any type of inventory slot from a container. Doesn't happen in the vanilla game because there are no such items in any container.
- Fixed crashing during wreck generation if there's any thalamus organs outside hulls.
- Fixed crashing if a wall whose max health is set to 0 in the sub editor takes damage.
- Fixed crashing if a reactor's maximum output is set to 0 and it's set to be on by default.
- Fixed a crashing due to a null reference exception if a status effect uses "target" instead of "targets" or "targettypes" in the definition.
- Fixed shuttles docked to a wreck undocking during level generation.

---------------------------------------------------------------------------------------------------------
v0.14.6.0
---------------------------------------------------------------------------------------------------------

- Fixed "entity not found" errors when receiving attack data for a character that's been removed (most often a terminal cell).
- Fixed occasional "mission equality check failed" errors when starting a round with multiple missions selected.
- Fixed outpost events not triggering in levels with a difficulty between 40-41.
- Fixed hunting grounds missions only spawning endworms.
- Fixed 2nd part of the Jacov Subra event chain not triggering.

---------------------------------------------------------------------------------------------------------
v0.14.5.0
---------------------------------------------------------------------------------------------------------

- Fixed deconstructing chaingun/laser ammo boxes not giving back aluminium.
- Fixes certain particles (e.g. flare) "dragging behind" inside moving subs.
- Fixed Typhon 2's railgun not being connected to the loader.
- Fixed occasional "failed to read event for xxx" errors when syncing a pirate's AI state in multiplayer.
- Fixed atan components working unreliably when using the separate x/y inputs.
- Fixed missing prisoner outfit sprite.
- Crates pre-placed into a submarine's cargo containers or ULD's aren't taken into account when calculating the cargo capacity to display in the submarine preview.
- Fixed limbs getting automatically deselected in the health interface when receiving a new affliction (most noticeable when trying to heal an affliction that's being continuously applied on the character, e.g. burns caused by radiation).
- Added a missing hull to beacon station's airlock room.
- Fixed inventory toggle button being rendered in the top-left corner of the screen when grabbing a character with a 0-capacity inventory (such as a hatchling).
- Fixed an exploit that allowed crashing the game using certain looping circuits that involve trigonometric function components.
- Removed underwater explosion particle effect when vomiting underwater.
- Fixed screen noise effect cutting from white to black with no blending when the oxygen low affliction kicks in while the white noise effect (e.g. radiation sickness) is active.
- Fixed ability to set the reactor's turbine output or fission rate outside the allowed range of 0-100 using the "set_fissionrate" and "set_turbineoutput" inputs.
- Fixed crashing when opening the weapon customization menu when there's non-swappable turrets in the sub.
- Fixed misaligned light sprites on nav terminal and status monitor.

Modding:
- Fixed crashing when trying to create a thalamus when there's no wreck AI configs available in the selected content packages.

---------------------------------------------------------------------------------------------------------
v0.14.4.0
---------------------------------------------------------------------------------------------------------

Changes:
- Submarine weapons can be swapped in the outposts.
- Added Pulse Laser and Chaingun.
- Added Canister Shells (a reloadable burst-type munition for the railgun).
- Added escort missions.
- Added pirate missions.
- Option to choose multiple missions per level.
- Made it possible to sell items on the sub through a new store tab in singleplayer.
- Cargo now spawns in crate shelves and "Unit Load Devices" (large containers mostly used in cargo subs). The amount of cargo you can transport depends on the number of the shelves/ULDs, and the cargo mission rewards scale according to the cargo capacity. If there's no shelves or ULDs, you can still transport a small number of crates on the cargo room's floor like before.
- Made upgrades affect all submarines. Old purchased submarines will have their upgrades overridden by the currently loaded submarine's upgrades.
- The previous music track continues playing when the game switches back from the "intensity tracks" to normal music.
- Made it possible to carry diving suits and toolbelts in hands. We could use some feedback on the way this works: is it intuitive, should there be a separate key for picking them up...?
- The ice shards and exploding mushrooms in caves can be destroyed with weapons and explosives.
- Added tracer particles to raycast projectiles (hitscan).
- Increased sonar beacon range.
- Color character names according to the team when using the Health Scanner HUD.
- Allow combining elastin.
- Character orders and ignore orders now persist between rounds and saved sessions.
- Added indicators for the tasks the bots are currently doing when they are not following the orders.
- Revisited the random (monster) events: more Watchers and Tigerthreshers, less Crawlers. Fixed a number of issues. Feedback appreciated. (WIP)
- Numerous fixes and improvements on particle effects.
- Changed how autonomous steering objective works. Captains now idle near the helm instead of standing next to the nav terminal.
- Only show the "Save and Quit" button when the game can be saved. Renamed the button in the lobby to "Quit". Saving in multiplayer is done like in single player: on level transitions and on exit from an outpost.
- Updated sounds for Endworm and the electrical discharger.
- Increased the stun of smg rounds from 0.125 to 0.15 to give it a bit more stopping power.
- Lowered Husks' health regeneration and bleeding reduction. Crawler Husks now regenerate too. Lowered their health a bit to compensate it.
- Hammerhead and Golden Hammerhead: Increased health, added some protection on claws and the tail end. Slightly increase the slow swimming speed and animations. The claws don't break anymore when shot with coilgun.
- Hammerheads and Husks don't avoid gun fire anymore. Pets now avoid gun fire. 
- Removed Endworm's weak point in the mouth.
- Most outpost events no longer trigger automatically, but require interacting with a specific item/character.
- Taking items that contain stolen items counts as stealing, so you can't for example put a toolbox inside an outpost cabinet, load it full of items and then take it.
- Added a button for resetting in-game hints to the settings.
- Mention diving suits' depth limits in their descriptions.
- Modified the locked path tooltips to mention the officer in the outpost.
- Reset reactor fission rate, turbine output and temperature to optimal levels at the start of a round. Prevents the reactor from catching fire at the start of a round if it was being operated at a high fission rate at the end of the previous round.
- Removed ability to drag and drop seeds into planters.
- Added ability to load .sub, .xml, .png and .jpeg files in sub editor by dragging and dropping them onto the game window.
- Added new biome-specific background noise tracks.
- Improved the command interface minimap view by adding connector lines between icons and item positions to better visualize which item each icon is linked to.
- Projectiles go through severed limbs.
- Docking ports can't be rewired in outpost levels because it can be abused to force to submarine to depart from the outpost.
- Allow clicking on the main menu buttons when the credits are open.
- Option to adjust motion sensor's update interval in the sub editor.

Fixes:
- Fixed clients timing out at the start of a multiplayer round if loading the campaign save takes more than 30 seconds.
- Fixed previous missions still being available in outposts that have become abandoned due to radiation.
- Fixed eggs sometimes spawning partially inside walls in abandoned outpost missions.
- Fixed thalamus walls' colliders still being present even if the wreck doesn't contain a thalamus, preventing entering the sub from places where thalamus walls used to be.
- Fixed minerals sometimes not being mineable in outposts.
- Fixed small characters being unable to avoid the edges of the hulls when idling.
- Save submarine and characters' inventories when saving and quitting an mp campaign round in an outpost.
- Marked "control" console command as a cheat.
- Fixed items sometimes disappearing client-side when the server corrects their position from outside to inside.
- The traitor mission to sabotage the engine doesn't require sabotaging shuttle engines.
- Stacks of seeds can't be put into planters.
- Fixed non-repeatable events (e.g. mission events) no longer appearing after completing the campaign.
- Fixed security officers using head set batteries when their stun batons are out of batteries, causing them to be unable to hear or receive orders (#5681).
- Fixed security officers often handcuffing you after one hit with stun baton (#5649).
- Fixed ignore orders not being properly synced when joining a multiplayer game mid-round.
- Fixed abyss monsters not spawning if there's any player sub (including the respawn shuttle) above the abyss.
- Fixed "are you sure you want to depart without a mission" prompt popping up even if there's no missions available.
- Fixed health bars showing up through walls.
- Fixed horizontal docking ports sometimes docking from the wrong side in mirrored subs.
- Fixed mouse wheel zooming the nav terminal view when the server log (or any other UI element) is blocking it.
- Fixed campaign's initial text popup getting stuck if the sub automatically undocks at the start of a round.
- Non-empty items (ammo boxes, fuel rods, etc) can't be recycled.
- Made airlock door assembly behave a bit more reliably. The circuit in the assembly simply toggles the state of both doors, meaning that one of the doors needs to always be closed and the other open for the logic to work correctly. If using the assembly in a respawn shuttle, it'd break when the shuttle leaves and it's doors are forced to close.
- Fixed inability to go through docking ports when the door/hatch at the other side is broken.
- Fixed other entities' sprites disappearing when reloading a sprite in the sub editor.
- Fixed Remora drone's docking hatch being repairable with a welding tool instead of a wrench.
- Fixed some of Remora drone's walls being transparent.
- Fixed rotation of mirrored items getting messed up when saving and reloading a sub.
- Fixed inability to detach items attached outside the sub.
- Fixed items that are inside a hull being difficult to target from outside the sub (docking ports/hatches in particular).
- Fixed crashing when trying to load a campaign save that contains pets that can't be found (e.g. if you've saved while using a mod that adds custom pets and try to load the save in the vanilla game).
- Fixed crashing when trying to change a location's type to a type that can't be found (e.g. if a mod includes custom location types which are configured incorrectly).
- Fixed "Ignore This" order affecting all NPCs. It should only affect the bots in a player team.
- Fixed "Ignore This" order restricting player access to doors.
- Fixed bots targeting same targets when fixing/repairing.
- Fixed monsters sometimes getting stuck "dancing" near the submarine because they try to avoid and target it at the same time.
- Monster events: Fixed many higher difficulty subsets spawning multiple monster events when they should spawn only one.
- Fixed items taken from abandoned outposts sometimes reappearing when returning to the outpost.
- Fixed highlighting items sometimes breaking after dropping a metal crate or some other container whose inventory is always visible when the item is equipped.
- Fixed bots putting minerals in the closest locker instead of preferring those that have been tagged with the "mineralcontainer" tag
- Fixed bots not respecting the access restrictions when choosing a where to put items into.
- Fixed bots being able to take items from secure cabinets if the item is inside another container inside the cabinet.
- Fixes to hull generation between docking ports. Should fix tiny gaps between the hulls that caused characters to briefly teleport outside the sub when passing through the port, and hulls generating incorrectly when the main submarine has hulls at both sides of the docking port.
- Fixed captain's pipe, harmonica and pipe tobacco not spawning in crates when purchased.
- Fixed console errors when trying to overwrite an existing item assembly in the sub editor.
- Fixed the margin calculations that in some cases made it impossible for Bonethreshers (and possibly other monsters) to reach a moving target.
- Fixed abyss monsters sometimes being unable to hit the sub and just keep pushing the sub.
- Define "tool", "weapon", and "provocative" targeting params to be ignored if the creature is not in the same sub as the target. Fixes some odd cases where the monsters e.g. target some item inside the sub when they are outside.
- Fixed occasional excessive camera shake when a large monster is lodged between the sub and the level.
- Fixed ballast flora not getting cleared from respawn shuttles when the shuttle despawns.
- Fixed ability to switch back to a sub you've left behind using the outpost terminals.
- Fixed doors without integrated buttons getting instantly opened by clicking on them when you have access to the button.
- Fixed ability to switch control to the hostages with Z and X keys during hostage missions.
- Fixed abyss and combat suits not getting autofilled with oxygen tanks when placing the initial supplies to a sub.
- Fixed inability to type in the "max players" field in the "host server" tab.
- Fixed item sell quantity sometimes appearing "maxed out" at a quantity less than what the player is actually selling.
- Fixed crashing when the team id argument for the "spawn" console command is formatted incorrectly, mention the argument in the command's help text.
- Fixed bots trying to clean up seeds and put items into bags that were moved to somewhere the bot can't access them, causing the bot to be stuck trying to reach the target.
- Fixed missions sometimes unlocking in paths leading to an irradiated location even if there's a more suitable path available.
- Fixed white rectangle around selected items in the sub editor being slightly off if the item's position/size is not a whole number.
- Fixed "incorrect password" text overlapping with the buttons in the password prompt.
- Fixed z-fighting in Medium Weapons Display Case.
- Fixed inability to drop through broken hatches.
- Fixed sprite bleed in IC-4 block's inventory icon.
- Fixed healthbar and affliction area being clickable even if there's an UI element in front of them, and even if there's no afflictions in the affliction area. Most noticeable when editing an electrical components properties.
- Fixed some incorrect room names in the beacon stations.
- Fixed propeller damage area triggering very inaccurately, particularly on shuttle engines.
- Fixed hull indicators fading in when loading a sub in the editor (they should only get hidden and fade in when editing the ambient light value).
- Fixed gaps sometimes getting linked incorrectly to the hulls between docking hatches, preventing water from flowing down from the lower hull in mirrored subs. Happened in mirrored Kastrull for example.
- Fixed fires in hulls between docking ports never going out client-side.
- Fixed nav terminal's, sonar monitor's and status monitor's selection rectangles being offset from the sprite in the sub editor.
- Fixed mirrored pumps emitting particles from the wrong side of the pump.

Modding:
- Made it possible to use StatusHUD components in non-equippable items like turrets.
- Fixed scripted event's StatusEffectAction not being able to target ItemComponents.
- Added support for making missions trigger scripted events.
- Option to configure the color of an explosion's flash.
- Option to configure the number of gates between biomes (see MapGenerationParameters.xml).
- Turret's barrel and rail sprites are shown in the sprite editor.
- Made SecondaryUse status effects work with melee and ranged weapons.
- Renamed "Inflitrate" to "CanOpenDoors" and rewrote the tooltip.
- Added "scalemultiplier" (Vector2) for particle emitters so that the effects can be scaled just in one axis instead of both.
- Fixed overriding nav terminals with a mod resetting the changes to the custom interface buttons.
- Fixed status effect conditionals that check a parent container's tags checking the container's components, not just the item itself. Resulted in tag inequality checks always succeeding, because the components don't have any tags.
- Fixed crashing if a scripted event tries to spawn a human prefab that can't be found (i.e. if a mod uses a non-existent human prefab identifier).
- RemoveItemAction can be used to remove tagged items directly, not just items in a tagged character's inventory.
- Replaced "spawnprobability" attribute in monster events with a generic "probability" attribute that can be used for any type of event.
- Option to spawn particles across the ray cast from a hitscan projectile (see "pulselaserbolt").
- Fixed linked subs included in outpost modules being positioned incorrectly.
- Added "swapidentifier" to SwappableItem definitions. Can be used to restrict which items in a given category can be swapped with each other (e.g. if you want to add custom upgradeable turrets but not make them swappable with the vanilla turrets).
- Made SecondaryUse status effects work with ranged weapons.
- Added "equal" targeting tag to enemy AI. Makes it possible to define how monsters react to monsters with the same combat strength.
- TagAction can be used to tag characters based on the human prefab identifier.
- Fixed a crash in the character editor that happened when a humanoid character had an elbow joint but didn't (yet) have a wrist joint.
- The "avoid gun fire" parameter now defaults to false.

---------------------------------------------------------------------------------------------------------
v0.13.3.11
---------------------------------------------------------------------------------------------------------

Changes:
- Adjusted autopilot logic to make it better at keeping the sub afloat when there's extra water on board. The maximum velocity of the autopilot is limited, which previously prevented it from emptying the ballast fully. Now it's only limited if the submarine is heading in the correct direction with enough speed, so if the sub starts sinking due to extra water, the autopilot can compensate and fully empty the ballast.
- Made large monsters immune to sufforin.

Fixes:
- Fixes to issues that prevented mods installed from the Workshop from getting automatically updated and caused errors when trying to join modded servers.
- Fixed an issue in the voice chat that caused audio crackling when multiple people were speaking at the same time.
- Fixed inability to drag players who've ragdolled themselves with space bar.
- Fixed "failed to send message to remote peer" error spam when a client's internet connection goes down.
- Fixed certain submarines spawning with a non-neutral ballast level (Kastrull seems to have been the only affected vanilla submarine). Happened because the game would determine the neutral ballast level from the first nav terminal it finds in the sub, without checking whether that terminal controls a shuttle or the sub itself.
- Fixed explosions using wall damage value instead of level wall damage when the explosion happens outside a level wall.
- Fixed inability to place oxygenite tanks in oxygen tank shelves.
- Fixed crashing when a bot tries to find a diving suit inside ruins.
- Fixed minor wall draw order issue in Orca's top deck.
- Fixed bots trying to treat nausea even though the only cure for it is to wait it out.
- Fixed status monitor being messed up on mirrored subs that contain shuttles.
- Fixed railgun payloads not exploding.
- Fixed server sometimes assigning players who haven't set any job preferences as the captain, even if someone else wants to be the captain.
- Fixed ancient weapon propelling the character in an incorrect direction when using it underwater.
- Fixed sonar beacons not appearing on the sonar in the sub editor's test mode.
- Fixed "easterbunny" traitor mission failing after the mudraptor hatches.
- Fixed "changes to your character will be applied after the round ends" texts getting drawn behind the tab menu elements.
- Fixed "IsToggle" setting not working on periscopes.
- Fixed "Praise the Honkmother" mission being impossible to complete because it required more items to be delivered than the crate contains.
- Fixed humanhusk's inventory not being visible while controlling one.
- Fixed sub editor's entity list getting cleared when changing the entity category while a container/cabinet is selected.
- Fixed items that have been edited in the sub editor (e.g. recolored clothing) reverting back to default when starting a new campaign round while the item is in a character's inventory.
- Fixed clicking on command interface nodes crashing the game if the key is rebound to primary mouse button.
- Fixed tiling issues in some of the legacy background wall sprites.
- Fixed Spinelings attacking Leucocytes. Spinelings should avoid Leucocytes if they get close.
- Fixed bots being unable to stand on the platform below Humpback's docking hatch, preventing them from repairing the hatch.
- Fixed "beacon station" text and "generating preview..." in the submarine preview window not being translated when playing in a language other than English.

Modding:
- Fixed console errors when a character with no gender tries to wear clothing that only has separate male and female sprites.
- Fixed crashing if the current style doesn't define a saving indicator.
- Fixed inability to load ragdoll/animation definitions from mods that override a character.
- Fixed ClearTagAction not properly clearing all the tags assigned by a scripted event.
- Fixed crashing if a mod's version number is incorrectly formatted in filelist.xml.

---------------------------------------------------------------------------------------------------------
v0.13.0.11
---------------------------------------------------------------------------------------------------------

Campaign changes:
- Replaced "Lair" locations with "hunting grounds" in the connections between levels. Inhabited locations next to hunting grounds have a chance of getting abandoned and habitation can't spread through those levels to adjacent locations. The hunting grounds can be cleared by killing a boss monster in the level.
- Beacon stations are shown on the campaign map.
- Visual changes to the map to make it a bit more intuitive.
- When you enter a level with a beacon station, you always get an optional side objective to restore it even if you haven't selected a beacon mission.
- Added radiation on the campaign map: the intensity of the radiation around Jupiter is slowly increasing, which is forcing Europans to delve deeper under the ice. In practice, the radiation gradually destroys the outposts starting from the left side of the map, making it more dangerous and costly to stay in these areas. The intention behind this is to prevent players from farming resources indefinitely in the low-difficulty areas of the game before proceeding further. 
- Gating progress between biomes: you need a certain amount of money or reputation before you can enter the next biome.
- Reworked exit points at uninhabited locations: there's a hole/tunnel above the start/end of the level the sub needs to enter to leave.

Abyss:
- Reintroduced Endworm and Charybdis.
- Added floating islands that contain caves and rare minerals to the Abyss.

New player experience:
- Added in-game hints, designed to help with new player onboarding. Can be disabled in the settings.
- Added text highlighting to mission descriptions.
- Player-controlled characters get automatically assigned an appropriate order when the game starts to guide the player on what they should do and to make it easier to find the relevant device(s).
- Changed the camera animation at the start of the campaign to show the entire outpost.
- Display mission difficulty in the available missions list, the info tab, and the round summary.
- Show an indicator when the campaign is saved.

Changes and additions:
- Added abandoned outposts.
- New mission types for abandoned outposts: destroying the outpost, clearing a nest, hostage rescue and assassination.
- Added entity subcategories to the submarine editor.
- Added interactive submarine previews to the server lobby and "New Game" screen.
- Added respawning mid-round in the multiplayer campaign mode. Respawning gives you an affliction that can be healed for a cost at outposts. You can also choose not to respawn mid-round, and instead wait for the next round to spawn normally without the affliction, just like before.
- Reworked the impacts to the sub when it's hit by monsters. Increased the screen shake and stunning. There's now a 30 second cooldown for getting knocked down. Fixed the impact not triggering if the colliding limb is not big enough.
- Reworked attacks and effects for the following creatures: Moloch, Black Moloch, Hammerhead, Hammerhead Matriarch, and Golden Hammerhead. They now have a bigger impact on the sub when they hit it. Black Moloch's emp damage is halved.
- Added Abyss Diving Suits which slows down your movement speed but offers more protection against pressure and consumes oxygen more slowly than the normal suits.
- Added Combat Diving Suits which slow you down less than normal suits and offer more protection against damage.
- Added black moloch mission variants.
- Moloch's shell now always breaks when shot with a railgun.
- Increased the audio ranges for Watcher and Hammerhead Matriarch.
- Overhauled tab menu: improved layout, added submarine and reputation tabs, current funds are displayed in the campaign mode.
- Recreated waypoints for the vanilla subs.
- Bots can now be renamed through the outpost crew management interface.
- Certain large monsters' (endworm, charybdis, boss variants of molochs and hammerheads) health bars become visible at the top of the screen when you damage them.
- Added EMP effect to nuclear shells. Increased the damage a bit.
- Added a right click context menu option to copy debug console errors to clipboard.
- Railgun shells now explode instead of piercing armor. Physicorium shells still go through armor. Make all railgun ammunition slightly more likely to break limb joints.
- Added multiple current orders: you can assign up to three simultaneous orders for characters and drag the icons to change their priority.
- NPCs (non-bots) speak report related lines less than they used to.
- The bleeding particles are now emitted from the last matching limb instead of the first. Readjusted particle emit frequency and scale.
- Reduced Moloch's bleeding reductions.
- Trying to pick up a diving suit when you're already wearing one swaps the suits.
- Made monster eggs glow to make them easier to spot in caves and abandoned outposts.
- Exploding oxygen/fuel tanks don't make other tanks explode.
- Added a delay to oxygen/fuel tank explosions.
- Disconnect wires from beacon stations instead of deleting the wires completely.
- The probability of disconnected wires in beacon stations is relative to the level's difficulty, and no wires are removed if the difficulty is less than 20.
- Improved server filters: instead of only being able to search for servers that have a certain setting enabled/disabled, the filter can be set to "Any" (thanks someone972!).
- Show whether a server is player-hosted or dedicated in the server list.
- Show whether a server is public or private in the server lobby.
- Added a server setting for locking all default wiring in subs.
- Added favorite button to the server lobby.
- Banning a player who's using Steam Family Sharing will now also ban the owner's account, solving ban evasion using this method.
- Disabled NPC conversations in sub editor test mode.
- Beacon stations' reactors don't deteriorate or consume fuel to prevent the station from going back down when the player is travelling out from the level.
- The output length of all signal components is now restricted to 200 characters by default to prevent performance and networking issues if the output is set to an excessively long value (such as the entire dialog of the Bee Movie). The limit can be increased in the sub editor.
- Stunning still works on friendly characters even if friendly fire has been disabled on a server.
- Made radiation sickness's icon appear before it starts causing burns (instead of working the other way around).
- Made radiation sickness cause nausea.
- Added a screen distortion effect for radiation sickness.
- Added a checkbox to color component that toggles between RGBA and HSV input.
- Fabricators now display remaining time when fabricating.
- Revisited husk animations, movement speeds, and general balance. Husks regenerate a lot and are a bit tougher than they used to be. Human husks can and will easily rise again, unless properly killed.
- Adjustments and fixes on the thresher attacks.
- Revisit mudraptors' attacks. Fixes unarmored mudraptors and mudraptor hatchlings acting weird when attacking characters in water.
- Lower the overall damage of all the hatchlings.
- Added a link to the wiki to the main menu.
- Drop empty/used oxygen tank from diving suit when trying to swap in a new one when the inventory is full.
- When using an equipped item from a stack (e.g. a medical item), another item from the same stack is automatically equipped.
- The mid-round mission messages (e.g. "the monster is dead, navigate out...") are shown in the tab menu's mission tab.
- Make characters grabbable and the inventories accessible after a half a second delay. Fixes abusing the toy hammer to access NPC inventories.
- Allow fabricating fresh fuel rods, welding fuel and coilgun ammunition using depleted ones.
- Restrict the length of the text that can be entered as a sonar beacon's sonar label.

Fixes:
- Major improvements to the voice chat: higher audio quality, less intrusive radio effect, fixed clicks/distortion.
- Attempt to fix crashes with the error message "failed to generate OpenAL/stream buffer" on Mac.
- Fixed crashing on startup with the error message "unable to load shared library 'freetype6' or one of its dependencies" on some Linux systems.
- Removed outdated steamclient.so file from the dedicated server (no longer needed because it's automatically installed by Steamworks). Should fix inability to host dedicated servers on Linux.
- Fixed clients' job preferences not being respected in all cases where they should, resulting in some clients getting a job that should be give to another client.
- Items can't be stacked in the equip slots (e.g. you can't hold and throw a stack of grenades).
- Trying to pick up a stack of items with a full inventory doesn't pick up the item in both hand slots.
- Fixes/improvements to item position syncing. When trying to pick up an item whose position has gotten desynced, the server should correct the item's position immediately.
- Fixed turrets getting cropped by the "wikiimage" console command.
- Fixed items with nothing but a holdable component (e.g. medical items) being hidden when hiding wires in the sub editor.
- Fixed ban list not displaying ban reasons or the duration of the ban.
- Fixed items appearing misplaced when switching to the sub editor mid-round with console commands.
- Fixed shuttles spawning undocked in certain custom subs (e.g. DOMA Prototype Mk 8).
- Fixed "tried to add a dead character to CrewManager" console error when reviving a character who died of high pressure.
- Fixed skill levels not getting updated in the "my character" tab mid-round.
- Fixed clients not calculating eventmanager intensity, preventing any high-intensity tracks from playing in multiplayer.
- Fixed campaign map being closed with RMB even if the user has inverted their mouse buttons.
- Fixed damage sometimes desyncing when the sub hits walls/spires: happened because damage was also applied client-side, which sometimes caused the clients to damage walls that weren't actually hit server-side.
- Fixed physics bodies between docking ports not getting mirrored in mirrored subs, sometimes causing impassable areas in spots where the docking port used to be.
- Fixed status monitor in a docked shuttle sometimes not displaying the main sub.
- Fixed campaign stores sometimes displaying prices for a previous location.
- Fixed various scaling issues on higher resolutions.
- Fixed monsters fluttering while pursuing other creatures. Only happened while swimming and was not notable on all monsters).
- Fixed mouse cursor being switched to hand even when the spritesheet is not shown in the character editor.
- Fixed monsters with low head/torso torques moving backwards when they try to turn around 180 degrees.
- Fixed regular Moloch not bleeding correctly.
- Fixed Workshop mod download prompt looping and freezing when there's a hash mismatch after a mod has already been installed.
- Fixed ability to walk through the heavy doors in mining outposts.
- Fixed nav terminal ignoring velocity_in signals when the terminal hasn't been operated by anyone during the round.
- Fixed one of the engineer variants having too many items in the toolbelt.
- Fixed "hide incompatible" checkbox in the server browser.
- Fixed characters getting impact damage from collisions with sensors. Caused characters to get stunned when they're thrown around by a monster while touching a level trigger (for instance, the branches in forest caves).
- Fixed bioluminescent cave's hallucination effect never going fully away and made it treatable with haloperidol.
- Fixed bots treating radiation sickness too eagerly (leading to wasted antirad).
- Added missing platforms to abandoned outpost modules.
- Fixed non-interactable items being counted as owned in the store interface.
- Fixed husk's mouth tentacles rendering on top of the left hand. Also fixed a minor texture bleeding on the waist.
- Fixed possible desync when multiple players use the crew management interface simultaneously.
- Fixed a crash when no valid limb was found for an affliction. Probably only happened with characters that already had some limbs severed.
- Fixed non-multiplied damage to limbs effectively always being clamped to 100, which means that no attack could do more than 100 damage per hit unless there's some damage modifier defined on the target limb.
- Monsters now stop targeting characters that are far enough behind level geometry. Fixes them getting stuck while trying to reach targets that are not easily reachable.
- Fixed players getting prompted to download subs when the server has disabled file transfers.
- Fixed command-spawned characters not getting the "job" tag on their id cards.
- Fixed coilguns consuming ammo faster than they should when linked to multiple loaders.
- Fixed wiring interface labels overlapping when using a high text scale.
- Allow engine propellers to do damage inside the sub.
- Fixed new lights being displayed as off in the sub editor until you toggle the lighting.
- Fixed non-ruin artifacts sometimes spawning on top of the sub.
- Fixed terminal's welcome message getting cleared when using the test mode in the sub editor.
- Fixed fabricator displaying the "not enough room in the input inventory" error even if the items fit in the input inventory by stacking.
- Fixed signal check components being unable to output whitespace.
- Fixed inability to edit smoke detector's parameters in-game.
- Fixed smoke detectors outputting empty signals.
- Fixed "engineers are special" outpost event not giving a price discount.
- Fixed clients being unable to vote for subs they don't have.
- Fixed a bunch of non-suitable items (such as devices that can't be deattached) being displayed in the "extra cargo" menu in the server lobby.
- Fixed crashing if you try to press the server log button in the lobby when connection to the server has been lost.
- Fixed item disappearing from the character's hand when you combine it with an item in a container in a way that doesn't fully deplete/remove it.
- Fixed gaps in the "backwall pipes" sprite.
- Fixed dedicated servers restricting player count to 1 less than the MaxPlayer setting.
- Fixed Kastrull's drone airlock not flooding correctly.
- Replaced legacy small pumps with the new ones in Orca.
- Fixed monsters sometimes spawning very close (or even inside) the respawn shuttle.
- Fixed "attempted to set SoundRange to NaN" error when a reactor's maximum power output is 0.
- Fixed wall damage particles sometimes spawning at an incorrect position.
- Fixed black moloch doing only 62.5% of the structure damage compared to the regular moloch.
- Fixes to R-29: fixed top docking port's control circuit, adjustments to pre-placed supplies, adjusted discharge coil power consumption, minor visual fixes.
- Reduced the amount of clown gear in the "Praise the Honkmother" mission to fit everything in the crate.
- Fixed non-repeatable outpost events starting to repeat once all of them have been triggered.
- Fixed inconsistency in the way vertical velocity in/out signals are handled by the nav terminals. Previously "velocity_in" would interpret positive y as upwards, even though "velocity_y_out" outputs a negative value when going up. Now positive is always down (= corresponds with the "descent velocity" value displayed on the terminal).
- Fixed Hammerhead Spawns not targeting decoys.
- Fixed the abyss monsters not targeting "provocative" items, like flares, glowsticks, scooters etc.
- Fixed Hammerhead Matriarch constantly fleeing from divers. It's intentional that the matriarch avoids the divers, but not as much. Now they should flee briefly only when shot by the player, making it possible for the divers to reach it (#5449).
- Fixed camera shaking/vibrating when moving at high speed.
- Fixed monsters being able to attack through ruin walls.
- Fixed overlapping vending machine and light switch in CrewModule_02.
- Fixed respawn shuttle maintaining an incorrect position after getting dispatched.
- Fixed inventory tooltip not changing when the cursor is hovered on the slot and the condition of the item changes.
- Fixed waypoints not being able to find hulls that have been added since the sub was last saved in the sub editor, causing them to appear blue.
- Fixed resizable outpost hallway modules not having waypoints and thus causing navigation issues.
- Fixed water particle effects not showing up when water flows between certain rooms in Remora.
- Addressed the lag spikes occasionally caused by Spineling's spikes when they hit/get stuck to something.
- Fixed logbooks being empty in the wreck salvage missions.

Bots:
- Bots now warn when you are running low / out of oxygen or welding fuel tanks, turret ammunition, or reactor fuel.
- Bots no longer report dead monsters on the sonar.
- Disabled the dialogue lines about not finding any targets for the given order, since they don't really improve the feedback. Instead they can give a wrong impression that the bot is not following the order when they actually are.
- Bots no longer speak about not being able to reach the diving suit when they fail to get it because it was taken by someone else. They will target another suit like they used to.
- Bots don't extinguish fires when there's ballast flora in the hull.
- Bots only speak about getting attacked when attacked by players. Fixes security bots throwing ultimatums on other bots that accidentally damage them (e.g. while welding).
- Bots that operate an item (reactor/turret) now drop the empty items on the floor instead of placing them back to a container. This saves time and the empty items should be taken care of by the idle bots.
- Fixed bots not seeking more oxygen before the remaining oxygen level drops to zero when they already have diving gear equipped and when they are staying stationary, leading to suffocation when the bot is repairing/operating while already wearing the diving gear and running out of oxygen tanks.
- Fixed bots trying to swap the oxygen tank too early when they are outside of the sub, which in some cases might lead to bugs where they try to get back inside the submarine.
- Improved the feedback by adding dialogues for swapping the oxygen and for not being able to find more oxygen.
- Fixed bots trying to return the diving suit when it's not a reasonable thing to do, but when they actually don't need it.
- Fixed bots failing to swap an oxygen tank from a diving mask to a diving suit when both items are equipped.
- Fixed bots getting confused when they have a mask without a valid oxygen tank inside it and when there's not enough oxygen in the room to be without the mask.
- Bots now react faster in general to all enemies.
- Bots now automatically attack enemies outside of the main sub, if they have a weapon. While docked to an enemy outpost or submarine, the "fight intruders" order now acts as an offensive order to attack the enemies on the connected submarine/outpost.
- Fixed bots following the player when the player is controlling a monster.
- You can now escape from NPCs by going far enough from them while they are pursuing you.
- Fixed bots reacting to attackers that are outside of the submarine.
- Fixed the "reportrange" parameter not working when the character is attacked. In practice only has effect on NPCs.
- Fixed report icons being shown also for other teams instead of just one's own team.
- Bots now target the closest limb instead of the main collider when they aim with the turret. With small creatures, this should now make any difference. With long creatures, it allows the bots to target the extremities of the body instead of always shooting at the main body.
- Fixed non-security bots fleeing the enemy (in defensive combat state) even when they are ordered to fight intruders.
- Bots no longer automatically unequip weapons after combat if they are outside of a friendly submarine.
- Fixed bots having difficulties in leaving the ruins via gaps.
- Allow bots to use gaps also to exit the sub, but only when following a player character.
- Fixed bots always trying to reach the closest item even when it's unreachable.
- Make bots find items faster.
- Fixed bots sometimes continuing their movement (e.g. walking towards a wall) when they fail to find the diving gear they need to continue with the go to objective (e.g. follow).
- Fixed security officers standing idle next to the stunned target and doing nothing when they don't have handcuffs. Only happened while trying to arrest the target.
- Fixed multiple bots occasionally trying to operate the reactor at the same time.
- Fixed bots "stealing" stuff while cleaning up. Happened when the objective changed (= they decided or were ordered to do something else while cleaning up). Idle bots are no longer allowed to take items from purchased containers.
- Fixed bots running headlessly around while trying to find the container for items while following the clean up order. Now they should walk around instead and only run when the target container is found.
- Fixes and adjustments to security officer reactions for damage done by friendlies.
- Fixed bots sometimes yelling that they can't enter an airlock when the sub is docked.
- Fixed bots taking items from fabricators and deconstructors.
- Fixed bots saying "Can't reach target [name]".

Modding:
- Fixed custom loading screen tips not showing up if the vanilla content package is enabled.
- Fixed crashing when loading a save where a stack contains more items than the maximum stack size for the item/container.
- The hit impact of a monster's attack can now be adjusted with the new "submarineimpactmultiplier" defined in the attack block. Note that this is a multiplier to the actual impact, hence also the force applied on the attacking monster affects the final impact.
- Explosions now have three new parameters: ignorecover, onlyinside, and onlyoutside.
- Fixed crashing/disconnects when preloading content at the start of a round if random events contain character variants. In practice, mods that used character variants in random events occasionally prevented rounds from starting.
- Fixed crashing when attempting to play a music clip that isn't a valid ogg file or if the file is not found.
- Fixed crashing when trying to spawn a character variant with custom inventory contents.
- Renamed the ai parameter "Threshold" as "DamageThreshold".
- Replaced "spawndeep" with "abyss" spawn type (defined in random events).
- New parameters StayInAbyss and StayInsideLevel that define the area where the creature tries to keep inside while not attacking.
- The creature disable distance, which totally disables the creature, is now exposed in the character parameters. The distance for triggering simple physics, which disables all the limbs and keeps only the main collider updated, is half of this distance. Increased the default from 22 000 to 25 000 (pixels).
- New attack pattern: Circle (around the target). Used by the abyss creatures.
- The aim speed and accuracy of NPC characters can now be adjusted in the npc (spawn) definition. The Aim speed also affects melee attack speed.
- Fixed OnSevered status effects launching also on the limb that the severed limb was attached to.
- Added "bleedingnonstop" affliction, which is just the same as normal bleeding but it never wears off.
- Added and option to target the last matching limb instead of the first (StatusEffect.TargetType.Limb). Implemented targeting other limbs even when the status effect is triggered from the limb, which was previously only implemented for status effects that targeted character. See Endworm for an example.
- Fixed hidden limbs not being ignored in many cases where they should, which potentially could cause issues with some custom monsters.
- Added "bleedparticlemultiplier" parameter in character definition, which can be used to increase/decrease the general amount of bleeding for the character in question.
- Added an option to always ignore an ai target if it's not inside the same sub as the character.
- Attacks can now "blink" limbs when they attack (Endworm). Blinking is a generic way to rotate limbs so that they "animate" (see Watcher's eye).
- Added AITrigger that can be used to trigger an ai state using the status effects (See Charybdis).
- Turned IsTraitor into a property so it can be accessed by status effects.
- Changed husk affliction's type to "alieninfection" because using "huskinfection" as both the identifier and type makes it impossible to add custom husk infections and reference just the custom one in conditionals or statuseffects.
- Fixed affliction statuseffects targeting NearbyItems or NearbyCharacters causing a crash.
- Corpses don't spawn in wrecks that contain no waypoints/spawnpoints.
- Monster events don't spawn monsters in wrecks that don't contain enemy spawnpoints.
- Fixed afflictions caused by status effects being multiplied by deltatime even when setvalue="true". The only vanilla statuseffect affected by this was incremental stun, which would stun the player for 1 frame instead of 1 second, but this may have affected some mods as well.
- Fixed errors when trying to load a beacon station with no reactor.
- Fixed level editor crashing when it tries to place a wreck that contains linked subs in the level.
- Added "onlyplayertriggered" condition for status effects. Currently only implemented for OnDamaged.
- Fixed crashing if you try to create a decal with incorrect casing.
- Fixed affliction's periodic effects being unable to reference afflictions defined later in the affliction xml.
- Fixed crashing if you save a campaign with a large map and try to load it with map generation parameters where the map is smaller.
- Fixed explosions not damaging level walls if their structure damage is set to 0.
- Fixed inability to load more than 5 wires per connection even if the connection is set to allow more.
- Allow to define afflictions (types or identifiers) to trigger the OnDamaged status effects only from certain afflictions and not all that do the damage. If the afflictions property is not defined, no restrictions are used (works as it used to).

---------------------------------------------------------------------------------------------------------
v0.12.0.3
---------------------------------------------------------------------------------------------------------

- Fixed inability to permanently ban players who are currently in the server.
- Fixed scrap items failing to load in saves done prior to v0.12.
- Fixed bandage/plastiseal crafting exploit.
- Fixed crashing if a bot tries to operate a turret that's linked to some other item than a loader.

---------------------------------------------------------------------------------------------------------
v0.12.0.2
---------------------------------------------------------------------------------------------------------

- Fixed console errors when hatchlings spawn.
- Fixed beds causing injuries instead of healing them.
- Fixed diving suit holder not filling up oxygen tanks.
- Fixed messed up frozen seed display sprite.

---------------------------------------------------------------------------------------------------------
v0.12.0.1
---------------------------------------------------------------------------------------------------------

- Adjustments and balancing to monster spawns.
- Modifed meds, buffs and poisons fabrication times.
- Potential fix to occasional disconnects with an "index was outside the bounds of the array (ENTITY_POSITION)" error message. Happened when lots of items and characters were being created and removed in rapid succession, for example when using turrets against large numbers of enemies.
- Fixed a rare crash caused by an "index out of range" exception in Hull.Update after loading or mirroring certain custom submarines.
- Fixed submarine class not affecting the depth at which a submarine starts taking pressure damage.
- Linked subs inherit the submarine class of the parent sub. Fixes drones/shuttles on deep diver subs getting crushed in the late game levels.
- Fixed nav terminal displaying pressure warnings when the sub is past the crush depth of a non-upgraded sub.
- Fixed character variants not having inventories.
- Fixed monsters sometimes spawning inside floating ice chunks.
- Logbooks now longer spawn in secure steel cabinets in wreck missions.
- Crystal and rock caves can appear in cold caverns.
- Show cave entrance markers on the sonar during mineral missions.
- Allow using some the new client-side console commands without command permissions in multiplayer.
- Fixed empty container indicators being animated on nearly all item.
- Fixed incorrect contained state indicator on flashlights.
- Display target item name in the tooltip for orders which have no options but have target item icons.
- Decreased the amount of burn on first patient in medic tutorial.
- Removed the deals groups from the store interface when there are no deals set for the current location.
- Fixed wrecks sometimes blocking cave entrances.
- Fixed Kastrull drone flooding when undocking using the button next to the hatch.
- Fixed wire/component placement grid having a too high opacity.
- Fixed bots being unable to shoot ice spires if the point on the spire that's closest to the turret is outside the turret's rotation limits.
- Fixed ancient weapon being sometimes unable to damage ruin walls.

---------------------------------------------------------------------------------------------------------
v0.12.0.0
---------------------------------------------------------------------------------------------------------

Cave improvements:
- New cave types and improvements to cave sprites.
- New cave hazards: exploding mushrooms, gas vents that drain oxygen and fuel tanks, sharp crystals that inflict bleeding and lacerations, hallucination-inducing plants.
- Made the caves more narrow.
- Position caves and ruins closer to the main path so the players won't have to swim hundreds of meters just to get to the entrance.
- Completing a nest mission turns adjacent empty locations to "Explored".
- Monster spawns are delayed up to a certain limit when most of the human players are exploring a ruin, wreck or a cave.
- Show a sonar marker at the cave's entrance in nest missions.
- Added some nest-specific level objects.

Additions and changes:
- Implemented stacking small items.
- Decreased toolbelt capacity to 6 slots.
- Rebalanced level events to have a better difficulty curve.
- Further improvements and balancing to the way locations change to other types of locations.
- The owner of a duffel bag is shown when hovering the cursor over one.
- Increased vanilla drones' range to 400 m.
- Nerfed stunning. The effect is now incremental: for example, a few hits from a stun baton only slows the target down, but a full stun requires several hits.
- Allow laying on beds.
- Added mudraptor, thresher and crawler hatchlings.
- Removed vision obstructing effects from diving mask and diving suit.
- Added "quickstart" console command.
- Added "setfreecamspeed" console command.
- Zoom more slowly when holding Ctrl in freecam. The speed can be adjusted with the "camerasettings" command.
- Added "CauseSpeechImpediment" attribute to afflictions that stops huskaffliction from causing a speech impediment when set to false.
- Added "sendmessages" attribute to affliction prefabs. When set to false it prevents husk affliction from sending messages on the screen.
- Increased the steps in the aim assist slider to make it possible to set it more precisely (there's a big difference between 0% and 10%).
- Show a "waiting for the campaign to start" text for clients without campaign management permissions in the game mode panel when campaign is being set up.
- Disable all the non-campaign-related elements in the server lobby when a campaign or campaign setup is active.
- Added some diving suits to outpost modules.
- Made engine's propeller damage indicator in the sub editor match the damage radius.
- Invert nav terminal velocity_x output and applied engine force for flipped subs. This should make it so that the sub will go forward when the engine is in "forward" state, instead of going to the right which is the default forward direction.
- Made cabinets waterproof.
- Nav terminals display a warning then the autopilot detects an ice spire.
- Modified oxygen tank, welding fuel tank, underwater scooter and duffel bag densities (they don't sink or ascend as quickly as they used to).
- Reduced skill requirements for rewiring.
- Restrict Concat Component's output length.
- Welding tools can now be used to destroy ballast flora.
- Made floating ice chunks easier to destroy.
- Ballast flora can be damaged by explosions and tools even when it's submerged.
- Select the items/structures in an assembly when placing one in the sub editor.
- Fertilizer no longer increases water consumption on plants.
- Replaced fuel rods for uranium in fertilizer recipes.
- Allow adjusting sound volumes at 1% increments.
- Allow opening Command Interface's manual assignment when using hotkeys or "clickless" mode. Can be done by holding Shift (same key used to open the contextual interface) when navigating to the assignment phase.
- Added new editable property "NonPlayerTeamInteractable" for Items. Prevents players or the bots in their crew from interacting with the item, but still allows outpost NPCs to interact with it.
- Made outpost reactors non-interactable for player team characters.
- Monsters can spawn at both sides of the level during PvP missions, as opposed to always spawning near the sub on the left.
- Disable trying to edit human heads in the character editor, because it would break.
- Monsters can now use doors for fleeing and they should be able to break doors that are in the way to the escape target. However, if the target they are fleeing from is in the same room, they still "panic" and just try to run away from the target.
- Previously the swimming speed of monsters was halved. Now it's clamped. This fixes slow monsters like husk swimming really slow inside the submarine, but it also affects the others.
- Added a diving knife in one of the security item sets, so that the security officers always have a lethal weapon and won't have to keep bashing the creatures with a stun baton.
- Added a medic crate for medical items that are bought from an outpost. Previously the medical items were spawned inside a chemical crate.
- Changed the sounds heard in psychosis depending on whether the character is inside or outside of a submarine.
- Husks can now operate doors and hatches. They can also climb ladders and break doors, which they can't open.
- Added ability to set custom background images in sub editor.
- Added a checkbox to skip localization to item labels.
- Made changes to ignore icon visibility: they can now be seen from further and won't fade out when you move close to them.
- Made item selling prices adjust based on the store balance: as the store balance decreases, the store will offer less for the items you are selling.
- Added "wikiimage_character" command, which generates an isolated image of the currently controlled character.
- Added "wikiimage_sub" command, which generates an isolated image of the currently loaded submarine.
- Renamed memory component's "signal_store" input as "lock_state".
- Added visual snap grid into submarine editor and "togglegrid" console command to toggle it.
- Relay's toggle input ignores "0" signals.
- Only allow attaching one wire to a reactor's power_out connection, because more leads to power issues.
- Made motion sensor's IgnoreDead, Offset and Target properties editable in-game.
- Entering the sub while docked to an outpost doesn't make the music switch from an outpost track to a normal one.
- Restricted pet name tag to 32 characters.
- Instead of a static starting wallet of 2500 marks, the players get 8500 minus the price of the starting sub.
- Replaced existing skill progression feedback with skill increase popups.
- Added new music track, "Extraterrestrial Broadcast".
- Fruits now float on water.
- Added a HSV color picker in sub editor that can be accessed by clicking the small color preview rectangle in the property editor.
- Ctrl+V keybind in sub editor now pastes on the position of your cursor instead of at the center of the screen.
- Holding Alt and dragging the mouse now brings up a measuring tape in sub editor.
- Added "bindkey", "unbindkey" and "savebinds" console commands that can be used to assign console commands to keys.
- Disabled hotbar slot keybinds when holding the Windows Key on Linux.
- Allow banning players who've left the server by clicking on their name in the crew list or server log.
- Husks now ignore incapacitated characters. They also know how to crouch to reach stunned/ragdolled characters lying on the floor.
- Improved the waypoint generator.
- Added store-specific Daily Specials and Requested Goods that change as the game progresses: Daily Specials are cheaper to buy and Requested Goods are more profitable to sell.
- Added store-specific price variance: every store has its own small price factor that affects all item prices.
- Hammerhead spawns are no longer afraid of being shot with sub's turrets. They also try to get in more aggressively.
- Readjusted the flame particle positions on the welding tool and the plasma cutter.
- Lowered the electrical skill required for wiring oxygen tank shelves and diving suit lockers.
- Mission cargo items are now marked with the red hand item. Taking them is considered stealing.
- Added glowsticks.
- Added an option to change the text scale.

Bots:
- Bots report ballast flora when they see it.
- Bots operating turrets now report what they see. They also call "firing" a bit less frequently.
- Bots using a coilgun/railgun report which kind of enemies they see.
- Fixed medics sometimes not letting go of the character they're treating after running out of medical items.
- Fixed medics not ignoring targets that they can't heal, because they don't have the items for it, which caused the medics to be trapped in a looping behavior.
- Outpost NPCs can arrest or kill players who try to cause leaks in the outpost.
- Changes to how the bots operate repair tools, so that they won't fail so easily when the water forces kick in.
- Bots (only the crew) now tolerate a bit more damage from repair tools before reacting.
- Bots should now properly respect ignored targets also when they are already targeting the item when you tell them to ignore it.
- Fixed bots not equipping diving gear when the oxygen level is low and there is no leaks/water in the hull, causing them to suffocate.
- Fixed bots "forgetting" autonomous operate (operate reactor or steer) orders if the objectives happen to fail.
- Fixed bots sometimes incorrectly abandoning a movement objective, when the path requires a diving gear. 
- Bots should now know how to get back inside through gaps in the hull.
- Fixed NPCs not being able to repower the reactor if the player somehow manages to unpower it.
- Bots now run when they are ordered to clean up things.
- Bots now ignore mudraptor eggs (to not foil your evil plans by cleaning them up).
- AI Pathing: Fixed a huge penalty given to stairs causing characters to choose weird paths to avoid stairs.
- Fixed bots running towards a door when they can't find a path while following a target, which was not the intended behavior. The bots should now stop moving and wait in place instead.
- Fixed docking port not always being properly connected to a door, causing a missing link between the waypoints and making it impossible for the bots to access the port on some subs. The accepted distance is now relative to the docking port's sprite's height so that all doors inside the sprite should be treated as close enough. Additionally you can manually link a door to a docking port in the sub editor.
- Fixed bots thinking that they need a diving suit to access certain drones/airlocks on subs that the creator haven't manually removed the waypoints on the ladders outside the airlock door. There's no need to remove those waypoints anymore, although it shouldn't matter if you do.
- Bots should now always heal players when ordered to. They still use a threshold for targeting other bots, but it's now slightly higher (90 instead of 85). This only applies when the bots are ordered, not when they act on their own.
- Bots now speak about not having any targets after a 3 sec delay. Fixes bots sometimes complaining that there's no targets even when there are.
- Fixed bots not properly ignoring non-interactable containers.
- Fixed bots dropping off from ladders when they first try to go up using a ladder and then down using another ladder right next to the first ladder. Happened especially in Kastrull.
- Fixed bots taking items from mission cargo containers (e.g. clean up or rescue).
- Fixed bots not properly checking the line of sight while trying to extinguish fires.
- Bots don't anymore drop empty oxygen tanks in the sea, if they have room in the inventory.
- Bots should now take oxygen tanks with less than 80% either to an oxygen generator or an oxygen tank shelf. Secondary places for non-empty tanks are the diving and the supply cabinets.
- Bots should now take battery cells with less than 80% to a battery or charging dock (added "batterycellrecharger" tag for these items).
- Bots don't yell anymore that they need more oxygen when they are running out of oxygen and have a non-empty oxygen tank(s) in their inventory.
- Fixed bots not respecting the Wait order inside ruins.
- Bots now shoot ice spires when the sub is moving towards them or if they are very close to the turret.
- Bots steering the sub now report ice spires they spot on the sonar.
- Bots now switch batteries when operating scooters. They also unequip the scooter if they run out of batteries, instead of just swimming with it.
- Bots now know how to switch batteries to the stun baton.
- Bots don't drop empty welding tanks or ammunition in the sea anymore, if they have room in the inventory.
- Fixed bots not shooting through turrets that block the line of sight.

Modding:
- Fixed mods not being sorted correctly until changing the order through the settings.
- Fixed mod load order not being restored correctly when leaving a server.
- Status effect definition attributes are now case insensitive.
- TriggerEvent in StatusEffects now supports inline events and the event tags have been renamed to "statuseffecttarget" and "statuseffectentity".
- Added support for defining a contextual name for an order (e.g. "Wait" and "Wait Here").
- Added support for IntegerInput elements (with "min" and "max" attributes) for the CustomInterface component.
- Option to define character variants that override some parts of another character. See the "Content/Characters/Variants" folder for some usage examples.
- Fixed a number of crashes in custom repair tools, especially if they operate on their own without requiring a user.
- Added "needsair" attribute to husk affliction, when set to true it disables low oxygen resistance granted by husk affliction.
- Fixed crashing when a StatusEffect targets a removed limb.
- Fixed conditional "And" comparisons not always working correctly when targeting items (the conditional needed to be true on the item and all it's components).
- Added support for overriding textures on character variants. Only supports overriding the entire texture, not separate textures per limb.
- Added support for overriding animations on character variants.
- Added min and max conditions (in percentages) for preferred containers.
- Added support for randomized deconstruction output: Deconstruct elements now support "chooserandom" and "amount" attributes, Item elements support "commonness" attribute.
- Added ClearTagAction that removes the specified tag from the event.
- Added CheckAfflictionAction that can be used to check if a character has an affliction.
- Added "InWater" property to characters.
- Planter component now triggers "OnPicked" status effects when interacted with.
- Allow items with a kinematic physics body to have a connection panel component.
- Fixed HasStatusTag conditionals only checking the first active status effect.
- Fixed multiple characters spawning when a character infected with multiple different types of husk afflictions dies.

Bugfixes:
- Fixed desync when entering a new level when there's a logbook with a very long message in the sub or in someone's inventory in the multiplayer campaign.
- Fixed very large numbers of submarines in the "Submarines/Downloaded/" folder causing excessive loading times, freezes and high memory usage.
- Delete submarines from Submarines/Downloaded when launching the game and hide downloaded subs from menus. The folder is now essentially a temporary folder for storing a server's submarines during a game session, not a place for persistent storage.
- Fixed crashing when trying to "select matching items" when right-clicking a linked sub in the sub editor.
- Fixed filename case issues and using backslashes instead of forward slashes in mod file paths causing errors on Linux and Mac.
- Fixed crashing when trying to respawn a bot in the multiplayer campaign.
- Fixed server list only showing up to 50 servers.
- Fixed connections that have the same start and end location sometimes getting generated on the campaign map, leading to a crash when trying to load the campaign save.
- Number input boxes don't clamp the value until the input box loses focus or enter is pressed. Fixes clamped values being very difficult to edit.
- Fixed a crash in GetDisguisedSprites.
- Mission events unlock the mission even if the conversation gets interrupted.
- Fixed lights on turrets rotating around the origin of the item, not the origin of the barrel.
- Fixed nav terminal's "velocity_in" input doing nothing.
- Fixed newly placed coilguns and searchlights not rotating the light sprite in sub editor.
- Fixed R-29 cargo lights not toggling on.
- Fixed missing waypoints in Berilia.
- Fixed docking ports' DockingDistance not being affected by the scale of the item.
- Fixed KarmaManager's MaxStructureDamageKarmaDecreasePerSecond not working as intended, allowing karma to decrease more than it should when doing lots of structure damage in a short time (e.g. when using explosives).
- Fixed engine's propeller hitbox not being moved or scaled when the engine is rescaled.
- Fixed holes in walls becoming non-see-through when starting a new round in the campaign.
- Fixed corrupted/invalid content packages whose xml file can't be loaded being added to the list of content packages, leading to a crash.
- Fixed devices failing to receive power if connected directly to a docking port's power connection without a junction box or relay in between.
- Fixed "disallowed upgrades" field not being taken into account in the upgrade UI when using prefab identifiers.
- Fixed level generation sometimes failing to generate the complete path to the destination.
- Fixes to docked subs being placed on the wrong side of the docking target in some cases (namely, when neither of the ports is connected to a door). Also added "ForceDockingDirection" setting to docking ports to enforce the direction if the automatic logic still fails due to some weird port setup.
- Fixed "velocity invalid" error if a monster that's indoors eats a corpse that's outdoors or vice versa (e.g. if you drag a corpse through the airlock while a monster is eating it).
- Fixed diving suit not giving any protection for radiation sickness.
- Fixed conversation prompts not disappearing if the controlled character dies when executing subactions (for instance, when the clowns are approaching the players at the beginning of the "clown relations" event).
- Fixed crashing when taking control of a black moloch with console commands.
- Fixed character editor creating tiny limbs if the mouse cursor goes outside of the sprite sheet area when the user is drawing a new limb. Drawing new limbs is no longer restricted to the sprite sheet area (it still works in display screen space!).
- Fixed husks and humanhusks targeting turrets when they are inside the submarine.
- Fixed monsters sometimes choosing weird paths when the hulls are flooding.
- Fixed assignment tooltip sometimes being displayed on command interface when it shouldn't be.
- Fixed ability to open manual assignment for orders targeting all characters.
- Fixed player characters' orders not being reset in between multiplayer rounds.
- Fixed "unignore" icons being displayed in multiplayer.
- Fixed crew list background blocking mouse input.
- Fixed order icons being always displayed over container when the order target is contained.
- Fixed CustomInterface component's UI text not reflecting the actual signal when changed by another player in multiplayer.
- Fixed inconsistencies in meds when fired from a syringe gun.
- Fixed thalamus spawning too many leucocytes in wrecks (particularly on higher difficulties).
- Fixed ability to choose a campaign save filename that's illegal on Windows when hosting a server on Linux or Mac, preventing Windows players from joining the server.
- Fixed workshop item download prompt not fitting on the screen when trying to join a server that has a large number of mods installed.
- Fixed being able to hear ready check ticking when the popup wasn't visible.
- Fixed an occasional lag following a crash when there's Spinelings present in the game (#4453).
- Fixed autopilot trying to steer away from connected subs that aren't directly docked to the main sub (e.g. drone docked to a drone docked to the main sub).
- Fixed a crash in the character editor when editing a limb's source with "adjust collider" enabled and if the source rect's size is zero or negative.
- Fixed docking ports not locking client-side if hulls fail to generate between the ports (e.g. if the thing docking to the sub doesn't have hulls).
- Fixed subs with a tall shuttle docked on top sometimes spawning partially inside the level's top wall.
- Fixed melee weapons being able to hit through walls/doors as long as the origin of the item is on the same side of the wall/door as the user.
- Fixed ballast flora jamming doors permanently if it dies while trying to drown a player in the ballast tank.
- Fixed pets not spawning at the position of the owner.
- Fixed rare "failed to generate a wall (not enough vertices)" error when generating a level.
- Fixed ability to see inside secure steel crates without appropriate access by swapping them with a normal crate.
- Fixed welded doors staying stuck and nav terminal not getting reset when redispatching a shuttle.
- Fixed mudraptor shells spawning outside the mudraptor's inventory.
- Fixed recovered shuttles disappearing if you quit during the round immediately after purchasing shuttle recovery in multiplayer campaign.
- Fixed logbooks always spawning in the same cabinet in a given wreck.
- Fixed items with a physics body disappearing when they are outside hulls during saving.
- Fixed items attached to walls (e.g. signal components) deattaching when resetting them to prefab values in the sub editor.
- Fixed characters that have been turned invisible by psychosis staying invisible when you switch to them.
- Fixed crashing when selecting a client who's controlling a monster in the tab menu.
- Fixed "where no man has gone before" achievement being impossible to unlock due to the depth being calculated incorrectly.
- Fixed submarine switching deleting all upgrades in multiplayer.
- Fixed Hammerhead Matriarch often not being able to break the sub's walls when hitting it.
- Fixed Hammerhead Matriarch's head deforming incorrectly (this fix may affect any modded content using conditional sprites with deformations).
- Fixed crash in sub editor when copying a linked submarine that you lacked the original file to.
- Fixed turrets and searchlights having incorrect light rotation when minimum rotation limit was the same as maximum rotation limit.
- Fixed popup messages preventing you from steering on the navigation terminal.
- Fixed inability to start a server when there's a very large number of subs installed.
- Fixed XP messages flying away when inside a moving sub.

---------------------------------------------------------------------------------------------------------
v0.11.0.10
---------------------------------------------------------------------------------------------------------

- Fixed monster missions causing a disconnect in multiplayer mission mode.
- Fixed bots getting removed from the crew when starting a multiplayer campaign, returning to the lobby during the first round and then reloading the campaign.
- Fixed crashing when entering a new level in the campaign when an inactive pump has been infected with ballast flora.
- Fixed ballast flora branches respawning instantly if they're destroyed while they're growing towards a target.
- Fixed crashing when attempting to place components outside of the submarine in test mode.
- Fixed inability to rewire beacon stations when rewiring is disabled on the server. 
- Fixed repair tools that aren't held causing a crash upon use (only affects modded items).
- Fixed raycast weapons (revolvers, shotguns, SMGs) sometimes not hitting monsters in specific areas outside the sub.
- Fixed submarine's price field being difficult to edit in the sub editor due to the value getting clamped above the minimum price while typing in the box.
- Potential fix to certain projectiles (e.g. harpoons, spineling's spikes) sometimes causing erratic physics behavior and errors (ragdolls going crazy, submarine getting launched off at a high velocity...) when they stick to the submarine or to characters.
- Fixed occasional crashes when swapping to another character's ID card with a mask or diving suit on.

---------------------------------------------------------------------------------------------------------
v0.11.0.9
---------------------------------------------------------------------------------------------------------

- Fixed operating a pump manually causing a disconnect in multiplayer.
- Fixed ruins sometimes spawning partially inside level walls.
- Fixed the game occasionally failing to generate a crash report when it crashes.

---------------------------------------------------------------------------------------------------------
v0.11.0.8
---------------------------------------------------------------------------------------------------------

- Fixed monsters being hard to hit with ranged weapons when far from the players in multiplayer (e.g. when operating a drone far away from the sub).
- Fixed occasional console errors when loading a submarine with a ballast flora infection.
- Fixed ambient lighting not affecting the submarine's outer walls.
- Fixed wire nodes getting messed up between campaign rounds if the wire was mirrored horizontally while placing it.
- Fixed ruins sometimes spawning with some of the wires disconnected.
- Fixed ice spires sometimes spawning too close to the start/end of the level.
- Render egg sprites in front of minerals.
- Fixed dancing coilguns.

---------------------------------------------------------------------------------------------------------
v0.11.0.7
---------------------------------------------------------------------------------------------------------

Environment overhaul:
- Remade textures.
- Branching level paths.
- More varied level layouts.
- Added small explorable caves alongside the main path.
- Made the floating ice chunks destructible.
- The areas outside the traversable path are solid instead of hollow, so it's no longer possible for monsters to spawn "outside the level" or for the sub to get lost at the wrong side of the level walls.
- Ice spires: tall, protrusions that cut holes in the submarine if you hit them.
- Piezo crystals: environmental objects that drain power from the submarine when you get too close to them.
- The biomes further on the campaign map are deeper down in the ocean, meaning that crush depth starts higher up in the level. The biomes near the end of the map require hull upgrades to traverse safely.
- Improved resource (minerals and plants) spawning: resources now spawn in clusters which can contain multiple instances of the same resource.
- Made thermal artifacts a bit more manageable: they now start a fires periodically, not continuously.

New missions:
- Nest missions where you need to enter a cave to destroy a monster nest.
- Beacon missions where you have to repair and power up a "beacon station".
- Mineral collection missions where you have to locate and mine a mineral cluster.

Additions and changes:
- Added ballast flora, a plant-like organism that can infect the submarine and leech power from junction boxes and batteries. A ballast flora infection may be contracted by passing through a colony of ballast flora spores (which are faintly visible on the sonar).
- Added a new monster, "Spineling".
- Adjustments and balancing to the way locations change to other types of locations: habitation now spreads faster as the player explores the campaign map further.
- Added new military outpost music track.
- Submarine hull upgrades increase the submarine's tolerance to pressure, allowing it to dive deeper without getting crushed by pressure.
- Deep Diver subs can dive 20% deeper than other subs without getting crushed.
- Added mineral scanning functionality for sonars: enabled by default for handheld sonars, can be enabled for other sonar devices in the Sub Editor with Sonar component's "HasMineralScanner" property
- Added concatenation component (a signal component that joins two inputs together).
- Added a ready check that can be used to check if everyone is ready to depart from an outpost in multiplayer.
- Added "ignore" order that can be used to prevent bots from using/repairing/taking specific items or devices.
- Discharge coil's range can be visualized by holding space while one is selected in the sub editor.
- Level difficulty affects the way outpost events are chosen (the more difficult events don't occur until later in the campaign).
- Non-wiring-related items become transparent in the sub editor's wiring mode.
- Improved turret range visualization in the sub editor.
- Made skill checks in outpost events probability-based: a low skill doesn't mean you'll always fail, just that you're less likely to succeed.
- Reworked bonethresher's behavior and attacks. Tigerthreshers now protect Bonethreshers with a low priority. Minor tweaks to the ragdolls and animations.
- Added water percentage output to water detector.
- Reduced scrap spawn rates in wrecks.
- Removed the explosive cargo mission variant where one of the explosives spontaneously explodes.
- Split combat missions into a separate game mode.
- Added a toggle for transparent wiring mode.
- The "Leaving Start Location" track isn't played at outposts.
- Increased default KillDisconnectTime to 5 minutes.
- Added pet food item.
- Added support for defining sonar icon colors in XML.
- Neutralize ballasts in submarine test level.
- Items can be attached to level walls.
- Fixed watcher's gaze causing severe effects inside the submarine.
- UI: Moved the navigation controls to the right side of the sonar view and readjusted the layout.
- Moved the cleanup order to the last in the maintenance category.
- Flagged certain parts of the nose and tail of the vanilla submarines as non-targetable, because the monsters tended to go inside the nose/tail parts too often.
- Increased the sound ranges for Tigerthresher, Leucocyte, Terminal cell, Mudraptor, and Crawler (should make them more audible).
- Crawlers, Tigerthershers, and Spinelings now avoid being killed by the engine (more or less).
- Adjusted the avoiding behavior for monsters.

Bots:
- Bots don't anymore clean up other diving suits when they have one equipped already.
- Bots don't anymore take diving suits off inside outposts (unless they have to).
- Fixed bots getting stuck on ladders when their body is near the floor.
- Fixed bots equipping diving gear too eagerly when the oxygen level drops in the room.
- Fixed all npcs and bots using the "Passive" idle behavior. Changed the guard idling so that they now more and prefer longer distances. Also other crew members should now move slightly more than previously.
- Increase combat priority of some tools so that the bots prefer those to toy hammer.
- More descriptive bot dialog when they can't find items they're looking for.
- Diving suits the bots have dropped in an outpost are automatically moved to the cargo bay when departing from the outpost.
- Outpost security allows "stealing" diving masks and suits if the outpost is flooding.
- Bots keep more distance to the player while following underwater and outside the sub.
- Fixed a rare crash in AIObjectiveIdle.Wander method.
- Bots now defend themselves (if possible) also when they are being attacked outside of the submarine.
- Bots should no longer hoard fuel rods.
- Fixed bots getting stuck while swimming near the submarine, because they kept switching between different steering modes.
- Fixed bots not avoiding other submarines connected to the submarine they are heading to while swimming around the submarine using waypoints.
- Fixed broken walls near hatches/doors sometimes preventing characters from entering the sub/outpost through the hatch/door.
- Fixed security or bots that have been ordered to fight enemies first fleeing from the enemies.
- Fixed bots sometimes failing to put out fires in multi-hull rooms.
- Fixed bots not being able to clean up items that occupy both hands (like the fire extinguisher).
- Fixed bots having issues with empty items while operating the reactor or the turrets, causing them e.g. to not knowing how to load the target item.
- Fixed outpost NPCs sometimes "cleaning up" the spawned toolbox in the event "clownrelations1".
- Fixed bots loading more rods to the reactor when the load is too high, even if the current amount of fuel is already enough to maximize the output.

Modding:
- Added "IgnoreWhileInside" and "IgnoreWhileOutside" parameters on character targeting parameters.
- Added ranged projectile attacks for monsters. See Spineling for an example. Note that there are five different rotation modes for the projectile aiming: Fixed, Target, Limb, MainLimb, and Collider.
- Added a "sweep attack", which makes the creature sinuate while closing to the target instead of moving straight towards it. Used on Spineling.
- Added limb hiding (permanent or temporary) with status effects. Used on Spineling.
- Added limb breaking with status effects.
- Allow characters to move full speed after attacking, when the cooldown is active. The property is found in the attack definition.
- Allow to use the idle behavior (wandering) after attacking, during the cooldown.
- Added "OnlyOutside" and "OnlyInside" attributes for status effects. Affects only the targets of the effect.
- Fixed particle's "LoopAnim" property doing nothing.

Bugfixes:
- Fixed occasional "missing entity" errors caused by the server failing to write an ID card's data in a network message.
- Fixed a bug that sometimes caused power to desync in multiplayer: when connecting the second end of a wire to a device other than a junction box, the server would sometimes not register the wire as being connected.
- Fixed previous messages disappearing from terminals and logbooks when transitioning to a new level in the campaign.
- Fixed sprite depths in dockingmodule 2, should prevent z-fighting.
- Fixed crashing when a bot abandons AIObjectiveCombat due to the target being in a different sub (e.g. if a character the outpost security is chasing moves from the outpost to the sub).
- Fixed undocking enabling all disabled nodes instead of just those that were connected to the docking port in question.
- Fixed EventManager to always choosing the same events from identical event sets in a given level. Meaning that if a level for example had 3 monster spawns that spawn either a crawler or a mudraptor, and the first event spawned a crawler, the rest would as well. In practice this lead to there being less variation in monster spawns than intended.
- Kastrull: Added more waypoints around the drone so that bots know how to get around it when it's docked to the main sub. Also fixed the airlock waypoints not being linked to the doors, causing the bots not being able to operate them.
- Fixed Health Scanner HUD showing a disguised character's true identity.
- Fixed health interface showing the original face and occupation of disguised characters.
- Fixed changelog layout getting messed up in the main menu after changing the resolution.
- Fixed some structures turning into wrecked versions when reloading the core content package with the "reloadcorepackage" console command.
- Fixed vent output being calculated incorrectly in multi-hull rooms.
- Fixed switch state being toggled when selecting them in the sub editor's wiring mode.
- Fixed engine not being affected by low power unless the voltage is low enough to turn it off completely (in practice meaning that there's not benefit to supplying the engine more than 50% of it's power consumption).
- Fixed characters getting healed between campaign rounds in single player.
- Fixed atan component output being inconsistent: the output was only correct if the y input was received after the x input during the same frame.
- Fixed crashing if a character's hands get severed while repairing something.
- Fixed stored non-shadow-casting lights being subtracted from the shadow-casting light count in the sub editor.
- Fixed autocalculated submarine price not being saved if the player doesn't touch the price field in the sub editor's save dialog.
- Fixed OnContained/OnNotContained StatusEffects not running if the itemcomponent is not active. In practice prevented oxygenite shards from supplying power until someone moves them. May have caused some other issues as well.
- Fixed console error when deconstruction Bufotoxin.
- Fixed reputation loss when "stealing" fire extinguishers from outposts when there's a fire.
- Fixed periscopes outputting rotation values incorrectly when connected to something else than a turret (e.g. camera).
- Fixed resetting game settings reloading content packages, causing items to disappear if the settings are reset when a round is running.
- Fixed pet's hunger/happiness values and inventories not getting saved between rounds.
- Fixed pet name tags disappearing client-side between rounds.
- Fixed empty oxygen tank not triggering the warning sound of a diving suit's oxygen supply.
- Fixed StatusEffects targeting "NearbyItems" only being able to target the Item instance, not the ItemComponents.
- Fixed "deceased" text wrapping in the health interface on small resolutions.
- Fixed open subinventories remaining visible on screen when using a railgun, coilgun or periscope.
- Fixed zoom getting stuck whenever exiting a railgun, coilgun or periscope and instantly hovering on an inventory slot.
- Fixed turret range upgrades not increasing the range of the turret's spotlight.
- Fixed all monsters spawned by the same monster event having the same sets of items.
- Fixed disconnected, hanging wires sometimes appearing at the wrong end of the wire.
- Fixed progress bar saying "welding" instead of "cutting" when cutting open a welded door.
- Fixed explosion damage to items not being diminished if there are obstacles between the explosion and the item.
- Fixes to flamer particles going through walls.
- Fixed items that are included in multiple categories (e.g. oxygen tanks, battery cells) not appearing in the sub editor's entity list unless using the search bar.
- Fixed psychosis sounds affecting all players.
- Fixed fabricators and deconstructors deteriorating even if they're not running.
- Fixed crashing when selecting a fabricator linked to a deconstructor or vice versa.
- Fixed "hide offensive server names" tickbox working the wrong way around in the server browser.
- Fixed console errors when setting an engine's max force to 0.
- Fixed in ability to damage huskified crew members if friendly fire is disabled.
- Fixed prototype steam cannon particles going through walls.
- Fixed "engineers are special" outpost event not giving XP when successfully helping the NPC.
- Fixed "propaganda" and "clown outbreak" outpost events not triggering.
- Fixed wires not appearing in some item assemblies placed in the sub editor until the sub is saved.
- Fixed decorative sprites being positioned incorrectly on mirrored items (such as pumps and fabricators).
- Fixed rotation limits being incorrect on turrets that have been mirrored before saving the sub.
- Fixed crashing when a bot is left to idle inside ruins.
- Fixed deconstructing an SMG magazine causing an SMG round to drop on the ground.
- Fixed empty SMG magazines not deconstructing to plastic.
- Fixed SMG magazines in character's inventories spawning SMG rounds at the start of a round (again).
- Fixed console errors in StatusEffect.GetPosition when applying a delayed status effect on a removed character.
- Fixed the latching behavior on Crawlers.
- Fixed latched creatures not releasing the sub when the submarine moves fast enough (defined in the latching behavior definition).
- Fixed outpost events sometimes triggering on dead/unconscious players.
- Fixed wifi component accepting input from chat regardless of the "link to chat" setting (the setting only determined if the component outputs the messages to the chat of the player holding the item, making it only useful for headsets).
- Fixed an issue that caused freezes when opening the server browser.
- Fixed "there is not enough room in the input inventory" error when placing a legacy medical fabricator in the sub editor.
- Fixed picking up a captain's pipe selecting it, preventing aiming until the item is deselected.
- Fixed hitscan projectiles briefly dropping out of the weapon client-side when fired.
- Fixed inability to play the campaign from the same local network when hosting with the dedicated server.
- Fixed crashing when clicking "spectate" in the server lobby after connection has been lost.
- Fixed occasional "too much data in network event" error messages.
- Fixed clients assigning different initial location reputations than the server, causing the round summary to display random reputation loss/gain when leaving the first outpost.
- Fixed "No AI Target" property not working properly.
- Fixed a rare crash when crawlers latch to a submarine.
- Fixed the vanilla submarines not always having any wrenches, which causes the bots not being able to fix mechanical items if they don't have a wrench in their inventory. Also made sure that all engineers have a wrench when they spawn.
- Fixed recovering and repairing a shuttle not removing the wall damage client-side.
- Fixed crashing when a hull smaller than 16x16px is painted or becomes dirty.
- Fixed characters not being visible when viewing an area far away from the player with a drone in multiplayer.

---------------------------------------------------------------------------------------------------------
v0.10.6.2
---------------------------------------------------------------------------------------------------------

- Adjusted pets' item production rates and hunger/happiness thresholds.
- Fixed inability to pick up chitin chunks.
- Fixed event manager considering pets to be enemies, leading to monster spawns being delayed or disabled altogether when there are pets inside the sub.
- Fixed bots having difficulties in entering/exiting the airlocks.
- Fixed doors not obstructing waypoints after docking.
- Fixes to pet syncing.
- Fixes to pets disappearing when transitioning between levels.
- Removed small crawler egg (was only intended for testing).
- Kastrull: Fixed the airlock waypoints not being linked to the doors, causing the bots not being able to operate them.

---------------------------------------------------------------------------------------------------------
v0.10.6.1
---------------------------------------------------------------------------------------------------------

- Added sounds for pets.
- Most fruits can be fed to pets.
- Increased the time it takes for pets to get hungry.
- Decreased pets' item production rate.
- The number of monsters now increases the event intensity more than previously, which should spawn monsters less frequently.
- Added some unarmored mudraptors to low-difficulty levels.
- Fixed crashing when a character takes damage from something else than another character attacking them (e.g. volcanoes).
- Fixed some steering issues where bots would return to the last waypoint instead of continuing with their current path when they should.
- Fixed occasional "velocity invalid" error messages when a character gets hit by a very fast projectile (e.g. coilgun bolt).
- Fixed severed tiger thresher heads doing the "death wiggle" animation.
- Fixed water flow sounds not disappearing over time.
- Fixed throwing an item that has no status effects (such as a flare) causing a crash.
- Fixed chitin helmet spawning in armory cabinets.
- Fixed event intensity going down immediately when the situation gets less intense instead of gradually returning to normal. Should make it happen less that more monsters are spawned soon after the player survives the previous wave of monsters.
- Fixed monsters using the Escape state when they should use the Flee state.
- Fixed Threshers not dying after being beheaded.
- Fixed heads or other extruding limbs being severed also when their root body takes damage.
- Fixed bots trying to get inside outposts (from outside) that they can't and shouldn't be able to enter to.
- Fixed very small creatures getting stuck on waypoints.
- Test changing the assignment logic for maintenance/operate orders: if the player doesn't specify the target character, use the bot who already is following the same order. The intention is to make it easier to change the target item of the order. The draw back is that ordering multiple bots to man the turrets now requires an extra step: specify the target character.

---------------------------------------------------------------------------------------------------------
v0.10.6.0
---------------------------------------------------------------------------------------------------------

Changes and additions:
- Reworked Watcher.
- Added pets (can be obtained by buying eggs from outposts). The pets produce items that can be used for crafting if they're kept happy and well-fed.
- Added a new AI behaviors: Observe, Follow and Freeze.
- Added toolbelt (a wearable container with a capacity of 12 and it's own dedicated slot) as a replacement for the toolbox.
- Improvements to the effects caused by psychosis: the affliction icon is not visible to the psychotic character, the fake fires and floods are a bit more convincing, the affliction plays random sounds and can cause other characters to become invisible.
- Added capture group support to RegEx component.
- Added black and white paint.
- Added optional "forbidden word filter" to the server browser. The filter is off by default. The list of forbidden words can be modified by editing the file "Data/forbiddenwordlist.txt" in the game folder.
- Increased the damage of 40mm grenades.
- Misc improvements to the tutorials.
- Added undo and redo functionality to the submarine editor.
- Added animations and lights to pump, fabricator, deconstructor and engines.
- All explosions now inflict explosion damage instead or in addition to lacerations.
- Nerfed the mudraptor slightly: the head and the tail armor should now break more easily; increased the cooldown of some attacks.
- Mudraptor's armor now explodes when destroyed.
- Added an unarmored variation of mudraptor.
- Bonethresher's head is now vulnerable to gunshotwounds and lacerations.
- Adjusted the appropriate jobs for bots.
- Changed the automatic crew selection logic for orders.
- Only show either electrical or mechanical repair order for the contextual selection, depending on which skills the item requires.
- Previous order icons of the same type are no more created, no matter if the target was different than the current.
- Tigerthreshers can now attack inner walls of the submarine. They still need help to get inside.
- Changes to the Tigertherthresher's main collider that should improve the overall movement.
- Option to make particle emitters modify the color of the particles.
- Set a limit to how many bots you can hire in the campaign (currently 16).
- Explosions caused by sodium, potassium, magnesium and lithium being exposed to water don't trigger additional explosions (e.g. oxygen tanks don't explode if they happen to be next to a sodium explosion).
- Pumps and relays placed in the sub editor are on by default.
- Added sounds for the nausea affliction.
- Nausea now inflicts a minor stun and internal damage when the character throws up.
- Monsters now stop fleeing after a while, if they are not being chased and can't perceive the target anymore.
- Implement spread, speed, and rotation for the spawn item status effects.
- Minor damage (less than 1 hp) doesn't spawn particles anymore.
- Rebalanced upgrade parameters, allowing for more noticable benefits.
- Allow closing the splash screens with esc.
- Added more copper to chalcopyrite and bornite deconstruct recipe.
- More calcium for aragonite, adjusted prices.
- Made large monsters immune to paralyzant (mudraptor is the largest affected monster).
- Use player name instead of server name for the server owner when hosting a server.
- Don't draw turret range indicators in the sub editor when the turret isn't selected.
- Adjusted Hammerhead's posture.
- Minor adjustments to Mudraptor's animations.

Modding:
- Added Scale and Offset to Light Sprite's parameters.
- Fixed the Constant Torque parameter not working right.
- Allow to enable/disable tail angles per limb. Previously the angle was only applied to the first limb of type Tail.
- Added per limb multipliers for sine animations (fish tail movement).
- Exposed the fleeing and avoiding times on the monster AI parameters.
- The Light Sources on characters can now be defined with conditionals.
- Added HealthMultiplier parameter that can be used in StatusEffects like SpeedMultiplier.

Character Editor:
- Fixed a number of issues with the joint limit widgets. Also allowed to set a joint to rotate clockwise, which inverses the widget direction. Useful for heads or other limbs that extrude right from the main body.
- The colliders of the hidden limbs are now hidden in the game view.
- Changed the hotkey for toggling the parameter editor from "Tab" to "F1" and fix the inability to toggle the editor when a text field is selected.
- Fixed load and save interfaces being broken on lower resolutions.

Sounds:
- Added 2 new background music tracks
- Added a new, separate sounds for opening and closing the alien doors
- Added a new sound for medium-sized fires
- Added new heartbeat sound for suffering from low oxygen
- Added new sounds for the hull creaking
- Added a new sound for a broken pump
- Added a new sound for tinnitus after an explosion
- Added a new sound for alien artifacts
- Added a new sound for electrocution
- Added a new sound for husk footsteps
- Added new misc. UI sounds
- Added a new variations for some existing sounds
- Improved some existing sounds
- Exposed GUI sound definitions in the sounds.xml file

AI improvements and fixes:
- Added a new AI behavior and order: cleanup items.
- Fixed severe performance hit when damaging outpost NPCs with a weapon that does continuous damage (for example a flamer).
- Reworked the contextual "Wait" order: the order now targets a position instead of an entity.
- Bots are now allowed to more things even they are not inside the player sub. For example they can be told to extinguish fires in the outpost or rescue crew members inside a wreck (when they are at the same place). WIP.
- Bots now try to put oxygen tanks to oxygen tank containers, before the oxygen generator or supplycab.
- Bots now re-equip hats, helmets, and other clothing that they have unequipped for being able to wear diving gear.
- Bots now use the underwater scooter when they have one in the inventory.
- Bots should now be slightly smarter when putting off fires.
- Bots don't anymore retaliate if they are being shot while there is an enemy around. Fixes #3840.
- Fixed a number of cases where bots would get stuck or fail to fix a leak.
- Fixed bots with steering order targeting the shuttle nav terminal instead of the main nav terminal.
- Fixed NPCs getting aggroed by certain drugs (e.g. anaparalyzant).
- Fixed bots not prioritizing the wall mounts for containing the extinguishers.
- Fixed monsters targeting inner doors when they shouldn't (#3891).
- Fixed outpost guards attacking the player for defending themselves against the aggressors on the event "mediator".
- Fixed NPCs not reacting when the player is attacked.
- Fixed AI considering characters on the opposing combat mission team as friendly.

Misc fixes:
- Fixed clients always getting the generic "could not connect" error message when connecting to a server fails, even if there's a specific reason to the connection failing (e.g. disallowed symbols in the player's name, mismatching content packages or game version).
- Fixed yet another cause for "missing entity" errors. Occasionally happened in monster missions when a monster happened to get assigned the same ID as an item in a player's inventory.
- Fixed clients spawning a respawn shuttle in non-campaign missions even if the server has disabled respawning, leading to "missing entity" errors.
- Fixed planters dropping removed seeds after a save is reloaded.
- Fixed plants not updating the health after being fully grown in multiplayer.
- Fixed decal syncing working unreliably in multiplayer.
- Fixed "level doesn't match" errors after leaving a shuttle/drone behind in the multiplayer campaign.
- Fixed painted/dirty walls going to full opacity when transitioning to a new level in the campaign.
- Fixed crashing when trying to render a light whose range is less than 1 pixel.
- Fixed crashing when using a repair tool causes an explosion (e.g. when killing a terminal cell with a plasma cutter).
- Mudraptor: Adjusted and fixed the animations.
- Fixed irrelevant damage modifiers (like bleeding) affecting the damageemitter's particles. In practice, this caused damagemodifiers with bleeding modifier 0 not spawn any particle effects when the limb was hit.
- Fixed extinguish fires not working with extinguish fire orders if the room has not enough oxygen.
- Fixed the user set state of the crew list not being respected; autohiding/showing shouldn't change the state set by the player.
- Fixed significant lag spikes at outposts with many NPCs. Caused by too frequent pathfinding calls, when an NPC can't find a path to the target.
- Fixed AIState.Protect throwing exceptions when an attacker has been removed.
- Fixed status effects targeting nearby characters/items failing to launch, unless they used the "Active" effect type.
- Fixed crashing when trying to crouch while swimming in the character editor.
- Fixed pause menu being togglable during level transitions, causing errors if quitting the game during a transition.
- Fixed wire disappearing from the character's inventory and from the walls when getting shocked from attaching the 2nd end of a wire in multiplayer.
- Fixed airlock warning light in Kastrull not turning off when the airlock door is closed.
- Made plants non-combineable.
- Fixed random submarine selection setting for servers occasionally selecting non-submarines.
- Fixed dedicated servers still showing up as "playstyle-less" in the server browser.
- Fixed sounds defined in affliction status effects not working.
- Require at least 1 kick vote before kicking someone, no matter how low KickVoteRequiredRatio is set to.
- Fixed gaps being misplaced on certain wall structures, preventing certain walls from leaking in some subs (for example the wall above Typhon's junction compartment).
- Fixed "Select Matching Items" crashing in the editor when used with submarines with a linked submarine.
- Fixed hull above Kastrull's drone not being connected to the rest of the hulls, preventing oxygen from flowing between the drone and the sub when docked.
- Fixed junction boxes' signal connections passing power/load information.
- Fixed crash when trying to clone a linked sub that you don't have the submarine file for in the sub editor.
- Fixed incorrectly scaled items in the diving gear cabinet/locker assemblies.
- Fixed inability to sell faraday artifacts when the condition of the artifact is 0.
- Fixed monsters not fleeing if the attacker is a bot.
- Fixed OnImpact statuseffects not launching if the impact was negative (e.g. when a moving sub hits an item that's below the sub).
- OnDamaged status effects now launch only when there's any damage. Not when the damage is zero.
- Fixed health bar pulsating even when no damage is done by an attack/status effect.
- Fixed affliction probability not having any effect when used in status effects.
- Fixed EventManager crashing if there are no event sets configured for the current location type (only affected mods that add new location types without adding any events for them).
- Fixed items held in the left hand being drawn in front of the characters.
- Fixed ability to drag and drop items into outpost reactors.
- Set terminal's maximum message length to match maximum chat message length (otherwise chat-linked terminals work differently in multiplayer).
- Fixed diving suit's low oxygen warning beep not following the player wearing the suit.
- Fixed "propaganda" and "clown outbreak" outpost events never triggering.
- Fixed "clown brutality" event getting stuck after the NPCs have been spawned.
- Fixed "impromptu engineering" event giving only one coilgun ammo box despite the text saying 2.
- Fixed "black market" event always giving the player the alien pistol.
- Fixed incendium bars exploding when pressing the Use key while holding one.
- Fixed outpost security not reacting to players throwing items that explode on impact (e.g. flash powder or nitroglycerin).
- Fixed outpost security reacting to raptor bane extract injections with lethal force.
- Fixed mantis' animation.
- Fixed multiple wire nodes occasionally getting placed with one click when rewiring.
- Fixed fire and water flow sounds staying active when returning from a multiplayer session to the main menu.
- Fixed previously discovered map tiles becoming undiscovered when saving and loading a campaign.
- Fixed 1st shot from SMG magazines spawned with console commands doing nothing.
- Fixed calyxanide not damaging huskified humans or crawlers.
- Fixed explosives exploding when combining them results in one being removed.
- Fixed items that don't flip horizontally being positioned incorrectly in mirrored subs.

---------------------------------------------------------------------------------------------------------
v0.10.5.1
---------------------------------------------------------------------------------------------------------

- Fixed clients not receiving a message of their character dying if they die far away from the position they were last spectating, causing them to get stuck to a state where they appear alive but can't interact with anything.

---------------------------------------------------------------------------------------------------------
v0.10.5.0
---------------------------------------------------------------------------------------------------------

Changes and additions:
- Added gardening: four different growable plants that produce specialed fruits which can be crafted into different items, or just thrown about and splattered on the hulls of the sub.
- Added cleaning: decals are now persistent and water gradually dirties up the submarine's walls. The dirt and the decals can be cleaned with a special tool that can also be used to paint the walls.
- New submarine, the heavy transportation ship R-29. Original design by "Rav2n".
- Overhauled mudraptor: new sprites, more varied attacks and heavier armor.
- Option to change the channel on the headset, making it possible to do things like secret communication on another channel or devices that react to commands sent on a specific channel.
- Added a verification prompt when trying to handcuff yourself.
- The inventory of handcuffed players isn't hidden completely, just locked (with a tooltip that explains why it's locked). Hiding the inventory was confusing to many new players, and it was easy to mistake it for a bug.
- Added directional markers that show the locations of the interactable NPCs in outposts.
- User's helm skill affects engine output.
- The game is paused when the campaign map is open in the single player campaign.
- The campaign map is automatically closed if the submarine gets too far from the end of the level while the map is open in multiplayer.
- Clients are allowed to view the campaign map even if they don't have the permissions to select the destination or the mission.
- The docking confirmation prompt is only shown when attempting to redock to the outpost you just left from.
- Wrecks are now properly initialized when spawned with "spawnsub" console command.
- Readjusted the attacks for the Husk and the Humanhusk.
- Added the option to select the minimum number of players required on the server for traitors to become active to the server settings menu.
- Log when clients modify the properties of an item (e.g. light colors, signal component settings).
- Allow selling items as long as their condition is over 90%.
- ID cards can be sold (as long as they're not in the player's own ID card slot).
- Disallowed selling items in equipment slots.
- Added cancel button to the "reconnecting to server" message box.
- DockingPort, Turret and LightComponent toggle connections ignore 0 signals.
- Traitor victims get a message saying they were killed by a traitor.
- Stack chat message popups when the chatbox is hidden instead of just showing one at a time.
- Switches now have lights that indicate whether they're on or off.
- Added "fuel_out" output to reactors.
- Added "set_light" connection to turrets.
- Made stun gun darts craftable from any type of wire.
- Outpost generator uses the first module type defined in the outpost config as the 1st module instead of forcing it to "airlock" (making it possible for modders to create outposts with another type of entrance module).
- Mission rounds end automatically if there are more living players inside the outpost than outside it, even if the sub is not at the end of the level.
- Made togglehud command usable in the sub editor for nicer screenshots.
- Characters don't gain helm skill when the sub isn't moving. Prevents grinding the helm skill when the sub is docked or maintaining position.
- Improved the way solid obstacles reduce explosion damage. Non-broken doors and walls nullify the damage almost completely.
- Fabricator continues fabricating when transitioning to a new level while it's running.
- Hid movement orders from the contextual command interface when there are orders of another type available.
- Made improvements to store interface tooltips. They now include the item name and should be displayed more consistently.
- Disabled automatic crew list sorting. The order now remains the same throughout the round.
- Added a second previous order icon to the crew list.
- Added character godmode, renamed mainsub godmode command to 'godmode_mainsub'.
- Increased sub editor auto save slots from one to 8 by default.
- Made logbooks sellable.
- Equipping a weapon activates it's reload time (capped to a maximum of 1 second), preventing bypassing the reload times by swapping between multiple weapons.
- Hide campaign NPC icon when the NPC is dead or incapacitated.
- Bots now prioritize stunning melee weapons based on their damage if they run out of battery.
- Made antidotes cheaper and easier to fabricate.
- Location reputations are shown when overing the cursor over a location in the campaign map screen.

Modding improvements and fixes:
- The order of all installed mods (not just the enabled ones) is now saved into the config file.
- Workshop mods can now be downloaded and installed automatically before joining a modded server.
- Disabled the Executable content type due to issues with cross-platform support.
- Fixed Unsubscribe button sometimes failing to delete mod content.
- Fixed a crash when attempting to modify the currently selected core package when other core packages aren't available.
- Fixed a modding-related crash at startup.
- Increased the "SeverLimbsProbability" cap (for items) from 1 to 10. The value is multiplied together with the joint setting "SeveranceProbabilityModifier", and limiting the value to 1 makes it impossible to boost the probability of some weapons/attacks.
- Fixed negative rotation speeds not working on decorative sprites.
- Fixed ItemPrefabs loading after AfflictionPrefabs.
- Previous enabled mods are restored when leaving a server.
- Added support for "periodic effects" (effects that execute every x seconds) to Afflictions. See the new "nausea" affliction for a usage example.

AI improvements:
- Using the fire extinguisher when there is a fire is no longer considered stealing by the NPCs.
- NPCs now spawn an oxygen tank if they can't find any. They don't spawn diving gear though.
- NPC guards now spawn more handcuffs if they don't have any and are trying to arrest a target.
- NPCs now spawn a welding fuel tank, if they can't find any. They don't spawn welding tools.
- Some adjustments to the logic on when a diving gear is required and when it's not.
- Bots now avoid idling in narrow hulls. Instead of taking the whole hull volume into account, they now give weight only for the width of the room.
- Bots should now avoid idling in flooding hulls even when they have proper equipment.
- Medics don't anymore try to rescue targets that are fixing leaks.
- Medics now try to replace empty oxygen tanks for their targets before dragging them into safety. They should also take the suit off when it's not needed.
- Security officers and those who are ordered to fight intruders now actively seek new weapons if they have a poor weapon or run out of ammo.
- Bots don't try to move while grabbed by a friendly character.
- Bots now detect and ignore leaks that other bots are targeting.
- Bots don't anymore try to decontain diving suits when the path to the cabinets is flooding.
- All crew members now try to keep the reactor running, unless the player orders someone to shut if down or turns it off manually.
- Bots shouldn't anymore try to operate items that other bots are targeting (previously they used to walk next to the device and only then continue).
- Removed the following autonomous objectives from medic and the security officer: fix leaks, repair systems, and pump water.
- Bots should now give a high priority on items that they are currently repairing, no matter if the decision to repair that item was made by them or the player controlling the character.
- Bots that operate/fix should now wait a few seconds before heading on their business (previously only in idle state). They are not allowed to wait in some circumstances, like when they are underwater or when there's a threat around.

Bugfixes:
- Fixed items that are added outside hulls not getting saved in the sub editor.
- Fixed "missing entity" errors in multiplayer if the respawn shuttle despawns after its walls have started leaking.
- Fixed submarine upgrades, hired bots and purchased items disappearing if the round immediately after the purchases ends due to returning to the server lobby or the crew dying.
- Fixed characters spawning with a 100% husk affliction on the next round if they've become huskified during a multiplayer campaign round.
- Fixed dedicaters servers not setting a play style.
- Fixed servers with no play style showing up as "Serious".
- Fixed attachable items teleporting back to the player's inventory in multiplayer if they first equip it and then attach it immediately.
- Fixed duplicate saves in the multiplayer campaign's "load save" tab when the server is running on the same machine as the client.
- Fixed broken junction boxes carrying signals from other junction boxes.
- Fixed bots disappearing from the campaign save when loading a save that was done in a level between 2 uninhabited locations.
- Fixed mp campaign sometimes loading an outpost level with no outpost and forcing the player to the map view. Happened when a campaign save that had been done in a level between 2 natural formations was loaded, which would mess up the save and cause the bug when quitting and reloading the save.
- Fixed submarine voting not working in the server lobby.
- Fixed outpost events repeating more often than they should.
- Fixed dedicated servers always being public.
- Fixed right mouse button not behaving correctly in the campaign UI when using left-handed mode.
- Made endpoint checks in the banlist more robust.
- Certain audio errors no longer crash the game.
- More Fabricator syncing fixes.
- Fixed molochs bleeding when they take any damage on the brain/main body.
- Fixed attacks never being able to do more than 100 hp damage per affliction, which resulted for example nuclear explosions and railgun shots being too weak -> re-adjusted railgun and explosion damages.
- Fixed bots failing to get an item if their inventory is full.
- Fixed bots sometimes running towards a wall after extinguishing fires.
- Fixed Husks trying to target floors/ceilings.
- Fixed the security not reacting when being attacked by a friendly character with the husk stinger.
- Fixed the Husk infection not progressing properly in multiplayer (#3673.)
- Fixed taking more husk damage reducing the Husk infection when its strength was higher than 50 (#3673).
- Fixed creatures in the group "human" not being considered friendly, which prevented creating friendly non-human characters.
- Fixed bots not always prioritizing the selected (contextual) targets first when ordered.
- Fixed incorrect priority calculations for repair objectives that causes bots to make weird decisions on what to repair.
- Fixed latched monsters ignoring decoys. Also changed the latching logic a bit, which has some minor implications on the gameplay.
- Fixed a crash when "money" cheat command was used used in the main menu.
- Fixed bots suffocating in diving suits, because they were unable to take the suit off when they should. (#3333)
- Fixed bots sometimes being unable to hit with melee weapons, especially in the "arrest" mode or when the target is down.
- Fixed bots sometimes getting stuck when they are fixing leaks while they are a bit too far from the target.
- Fixed bots insisting on equipping the diving suit before accessing Kastrull's drone.
- Fixed bots rapidly turning left and right when they are positioned between a wall and another bot in the idle state.
- Fixed one of the Thalamus spawn organs always dying because the hull was not flooding in Wreck1.
- Fixed bots failing to take account all the items in the inventory. Addresses cases where bots are confused because there are some empty/broken items and some full/functional items in their inventory.
- Fixed bots getting stuck in the find safety state when they can't find any safe hull (e.g. all the hulls are flooding and they don't have a suit).
- Fixed bots avoiding lethal pressure in some cases even when they have a diving suit.
- Fixed bots being unable to get the diving gear when some of the hulls in the path are flooding.
- Fixed bots failing to switch oxygen tanks when the tanks are empty. They don't yet know how to use the oxygen generator for refilling the tanks (coming later).
- Fixed many AI objectives not resetting properly, causing many separate issues.
- Fixed bots trying to use stabilozine to treat internal damage even though it only treats poisonings.
- Incapacitated bots now forget what they were doing. Fixes bots shooting at the player when revived after being shot by the player.
- Fixes and improvements on NPC/bot reactions when being attacked by the player.
- Fixed the devotion not working right for the subobjectives of looping objectives. Should fix cases where the bots keep switching repair/fix targets, resulting in looping walking behavior.
- Fixed coils not triggering in some alien ruin rooms.
- Fixed misaligned oxygen tanks in the oxygen generator.
- Fixed misaligned railgun shells being in the single loaders.
- Fixed explosives not triggering inside depth charges.
- Fixed damage modifiers overriding each other instead of stacking, causing some protective items to make the characters less protected.
- Fixed skill checks in the "sound in the vent", "mediator" and "big brother" events always failing.
- Fixed conversation prompt staying open after finishing either of the "Mike the Idiot" events.
- Fixed attacks never being able to do more than 100 units of damage per affliction, making some weapons less effective than they should be.
- Fixed inability to override item assemblies with mods.
- Fixed items contained inside another item in an item assembly not getting saved in the sub editor.
- Fixed links between entities not getting saved in item assemblies, causing doors to create a duplicate gap when the assembly is placed.
- Fixed stabbing with a syringe bypassing the medical skill check.
- Fixed piercing coilgun bolts going through level walls.
- Fixed particles sometimes going through walls (example case: Typhon's ballast pumps).
- Fixed SMG magazines always spawning a bullet at the start of a round even if there's already one inside the mag.
- Fixed respawn shuttle sometimes spawning with upwards velocity.
- Fixed mining outposts sometimes failing to generate, causing the game to use one of the old pre-built outposts as a fallback.
- Fixed "acid party" traitor mission causing a crash if there's only one player on the server.
- Fixed ruins sometimes spawning close to the beginning/end of the level, blocking the way to the outpost.
- Fixed crew members that have been removed during the round (e.g. despawning, turning into a husk) reappearing on the next round.
- Fixed round summary displaying "new hire" instead of the status of recently hired characters who've died during the round.
- Fixed monsters often spawning behind the submarine even if there are valid spawnpoint ahead of it.
- Fixed duct blocks in vanilla subs being repairable with a welding tool instead of a wrench.
- Fixed giveperm, revokeperm, giverank, givecommandperm and revokecommandperm not working when executed on a player with spaces in their name by a client.
- Fixed occasional crashes at the end of the round due to a race condition where SteamManager tries to check for damaged walls while the sub is being unloaded.
- Fixed mudraptor eggs never hatching.
- Fixed the "giveaffliction" command not accepting the affliction identifier as a parameter in multiplayer.
- Fixed the contextual repair order being shown even if the item was not in need of repair.
- Fixed a networking bug that caused "index out of bounds" and "missing entity errors" (although there are probably other bugs remaining that can cause these error messages). Happened in multiplayer campaign when a purchased or player-owned item happened to take the ID of an existing structure during the start of the round.
- Fixed inability to give Operate Weapons order when there's only 1 turret.
- Fixed store total not updating properly when location reputation changes.
- Fixed bots not being able to reach leaks that are behind intact walls.
- Fixed pause menu staying open when clicking "Save and quit" in an outpost level.
- Fixed all saves getting hidden from the "load game" menu when deleting a save.
- Fixed projectiles staying active if picked up mid-flight, causing them to hit the character when dropped from the inventory.
- Fixed a crash when taking control of a previously player-controlled character that has turned into husk.
- Fixed attacks working unreliably when controlling a monster in multiplayer.
- Fixed grenade launcher's muzzle flash causing items' OnFire effects to trigger.
- Fixed clicking on the job name not selecting the job as a preference.
- Fixed bots running back and forth after reaching the target waypoint if there's nothing telling them otherwise. Now the bots should continue running towards the target as intended.
- Fixed "sound in the vent" and "giving directions" events not giving any rewards.
- Fixed prices not refreshing in the store screen if the crew's reputation changes while inside the outpost.
- Fixed characters not getting stunned when failing to repair an oxygen generator.
- Fixed missing fire extinguisher in securitymodule_03.
- Fixed secure steel cabinets not requiring a key card to open in securitymodule_01 and 02.
- Fixed campaign setup menu sometimes randomly selecting an invalid sub when opening the menu.
- Fixed monster attacks not working inside ruins.
- Fixed doors not working in AlienDoorAssembly2.
- Fixed ability to link hulls to each other multiple times.
- Fixed bots triggering the campaign map by undocking from outposts.
- Don't allow the current location or the destination to change it's type at the end of a round (i.e. an uninhabited location can't turn to an outpost as you're entering it).
- Bots don't try to power up the reactor unless ordered to in outposts.
- Fixed "invalid docking port network event" error if the ID of the port has changed after the event has been created (e.g. if one of the clients happens to have an item with the same ID in their inventory).
- Fixed changes to spawn point's text properties not saving in the sub editor without pressing enter.
- Fixed ability to "bypass" sonar disruptions by switching to passive sonar before the active ping reaches the disruption.
- Fixed incorrect diving suit deconstruction recipe.
- Fixed faraday artifact not playing the explosion effect in multiplayer.
- Fixed ability to bypass vote kicks by changing your name before you get kicked.
- Fixed killing a character with morbusine not unlocking the "Poisoner" achievement.
- Fixed killing a moloch that's the target of a mission not unlocking the "Killed a Moloch" achievement.
- Fixed Berilia's and Typhon's docking ports not being connected to the power grid.
- Fixed contained item positions not being updated if they're inside a non-equipped item in a character's inventory (e.g. a sonar beacon inside a toolbox).
- Fixed sonar beacon staying active after running out of battery.
- Fixed stationary batteries being able to provide power when broken.
- Fixed pumps being impossible to adjust manually after they've received a signal through the "set_targetlevel" connection in multiplayer.
- Fixed sub names and save times disappearing from the "load campaign" menu in the server lobby after deleting a save.
- Fixed autopilot being turned on automatically at the start of a round on nav terminals that control a shuttle/drone remotely.
- Fixed names not being color coded according to job in the server lobby when a round is running.
- Fixed non-mission artifacts sometimes spawning inside level walls.
- Signal components don't output anything if the result of an arithmetic operation is undefined (square root of a negative value, division by zero, inverse trig function outside the defined range).
- Fixed handcuffs becoming unequipped client-side on successive campaign rounds.
- Fixed copypasting a single docking port/hatch or a wire in the sub editor placing it very far from the submarine.
- Fixed characters not dying, but still being unable to move, if they get crushed by pressure when they have the vigor affliction.
- Fixed crashing if a turret receives a NaN signal in the position_in connection.
- Fixed crashing when trying to reselect the current preview image as the preview image for a workshop item.
- Fixed shadow-casting convex hulls being calculated incorrectly on hatches with windows (only affects mods that add hatches with windows).
- Fixed custom items disappearing when saving a sub if the sub is both the items and the sub are configured in the same content package.
- Fixed nullref exception if a client joins or disconnects when tab menu's crew tab hasn't been initialized.
- Fixed Dugong's oxygen generator being rewireable with a wrench instead of a screwdriver.
- Fixed particles not being emitted when cutting ores.
- Fixed unwired lamp in EngineeringModule_01.
- Fixed tunnel background being interactable in ResearchModule_02.
- Fixed inability to interact with hidden linked containers in multiplayer.
- Fixed undocked linked subs being positioned incorrectly when entering a new level in the campaign.
- Fixed players not getting notified about shuttles being left behind when docking with an outpost in the campaign.
- Fixed salvage missions not completing if the item is inside a subinventory (for example a toolbox).
- Fixed rejoining clients not gaining control of their previous character if they've changed their name.
- Fixed healthbar being positioned incorrectly on large resolutions.
- Fixed fabricator's hover text saying it's repairable with a screwdriver.
- Fixed last hit from a stun baton doing nothing.
- Fixed diving suit lockers that have been recolored in the sub editor reverting to default color when a suit is placed inside them.
- More reliable syncing of doors' stuck state. Should fix doors appearing usable client-side even though they're actually welded server-side or vice versa.
- More reliable memory component and text display syncing.
- Fixed events that require a specific item not taking items in subinventories into account.
- Fixed events where the player has to pay for something being possible to complete even if the player doesn't have enough money.
- Made "goodsamaritan" and "huskcultist" events remove the items from the player immediately after opting to give/use the item. Otherwise it's possible to keep the item by dropping it from the inventory before dismissing the conversation prompt.
- Fixed events that increase the medical skill giving the character a duplicate medical skill entry.
- Fixed light sprites not rotating when rotating an item.
- Fixed contained items not rotating when the container is rotated.
- Fixed legacy railgun controllers being fired with the Use key instead of the Shoot key.
- Fixed XP popups not showing up in multiplayer.
- Shuttle batteries can't be damaged by explosions because they can't be repaired.
- Fixed text overlapping with the icon in the "purchased supplies have been delivered" popup.
- Fixed mission notification appearing in front of the round summary.
- Fixed crawler walking/running animations when the creature is facing left.
- Fixed irrelevant damagemodifiers affecting the final damage when multiple damage modifiers exist.

---------------------------------------------------------------------------------------------------------
v0.10.4.0
---------------------------------------------------------------------------------------------------------

- Localization fixes.
- Fixed piercing coilgun ammo boxes never running out.
- Fixed end round button having no text when leaving an outpost.

---------------------------------------------------------------------------------------------------------
v0.10.3.0
---------------------------------------------------------------------------------------------------------

- Fixed SalvageMission not spawning the item if the mission has been attempted previously, causing an "attempted to pick up a removed item" error when trying to pick up the artifact/logbook.
- Fixed bots going to operate the reactor/navterminal in the main sub when they are inside the outpost. Now they should only be allowed to do this when ordered to. 
- Fixed mechanic tutorial getting softlocked if the oxygen tanks are put in the deconstructor without putting them in the player inventory first (e.g. by putting them inside a diving mask and moving them from there to the deconstructor).
- Fixed "failed to spawn item, component index out of range" error when an item that originally spawned in a container has been moved inside another container whose ItemContainer component doesn't have the same index as the previous one (e.g. when moving items from cabinets in a wreck into a toolbox).
- Fixed dialog prompts in the "clownrelations1" and "engineers_are_special" events being displayed to all players in the server.
- Fixes to localization issues (text overflows, some texts being displayed in English regardless of the selected language).
- Prevent selling items contained inside an item equipped in Head, OuterClothes, or Headset slot (should prevent accidentally selling your headset batteries or oxygen tanks in your diving mask).
- Fixed changes during the last campaign round not being saved.
- Fixed campaign character being recreated on every round start after modifying it via the tab-menu during a campaign.
- Fixed crashing when clicking the "close" button in the end credits in multiplayer campaign.
- Reset stores and unlocked missions when finishing the campaign.
- Fixed open subinventory slots staying visible during the campaign end cinematic.
- Fixed talk icon not disappearing from NPCs when another client finishes the conversation.
- Made end round button more noticeable.
- Added a missing platform to Wreck1.
- Added burn and lacerations resistance for assistant clothes, removed gunshotwound resistance.
- Raised explosive and piercing coilgun ammunition prices, reduced quantity by 25%.
- Limited availability of piercing and explosive rounds at cities to 1 box.
- Fixed bots getting stuck on ladders when there are two ladders next to each other and no non-ladder waypoint between them.
- Outpost medics won't anymore try to heal NPCs that are turned hostile by an event.
- Fixed OnActive StatusEffects not working on Vent components.
- Fixed clients crashing if they can't find a preview image for a campaign sub.
- Fixed characters not getting slowed down when walking/running in a partially flooded hull.
- Fixed end biome being used in sandbox/mission modes.
- Fixed event prompts not having a scrollbar if the first message is too long.
- Made chemical and explosive crates water proof to make it possible to use them for transporting water-sensitive materials.

---------------------------------------------------------------------------------------------------------
v0.10.2.0
---------------------------------------------------------------------------------------------------------

- Balanced monster spawns (less mudraptors in the low-difficulty levels).
- Made levels in the Cold Caverns and Europan Ridge biomes a little smaller.
- Gray out upgrades on the UI if the user lacks campaign management permissions.
- Disable elements in crew hiring menu when lacking permissions.
- Idling bots don't try to steer away from each other if there are characters standing on both sides. Fixes groups of bots "spazzing out" in small spaces.
- Fixed all clients seeing the mission-related conversation lines.
- Fixed last conversation the huskcultrelations event showing up for all players.
- Fixed mission notifications being appended to whatever conversation prompt a client has active.
- Fixed Dugong not receiving power through the docking hatch.
- Fixed unwired junction box in ResearchModule_01.
- Fixed occasional "connection index for mission out of range" errors when unlocking missions in multiplayer campaign.
- Refresh upgrade store when granted manage campaign and manage round permissions.
- Fixed client's character data not getting saved in the multiplayer campaign if they disconnect but their character doesn't get killed by the disconnect timer.
- Fixed tiny buttons in wrecks.
- Fixed crawler mask not showing up on characters.
- Fixed returning to lobby not triggering a proper reload of the campaign save when continuing.
- Fixed SmokeDetector's Output and FalseOutput properties doing nothing.
- Fixed some locations sometimes not being connected to the rest of the campaign map (example seed: JKPNeh4f).
- Fixed characters being able to play instruments while stunned.
- Attempt to fix the game process sometimes staying active after the game is closed.
- Fixed mining outposts sometimes failing to generate.

---------------------------------------------------------------------------------------------------------
v0.10.1.0
---------------------------------------------------------------------------------------------------------

- Fixed inability select other locations on the campaign map when a mission has been selected in one of the locations.
- Fixed purchased items not spawning if the crew dies and the previous save is loaded in the multiplayer campaign.
- Fixed clients not seeing subs they don't have in the campaign setup's purchasable sub selection.
- Clients who die due to a disconnection in the multiplayer campaign get to keep their character when they rejoin.
- Fixed submarines with spaces or commas in the name breaking campaign saves.
- Fixed favorite and recent server queries causing errors if there's a very high number of them.
- Fixed audio not working on some systems.
- Fixes to incorrectly sized item colliders.
- Fixed monsters not spawning in the first few levels of the campaign.
- Fixed store interface switching to the Buy tab after receiving a campaign state update in multiplayer campaign.
- Gray out items on store lists when the player doesn't have the relevant permissions.
- Putting outpost items into crates and toolboxes now gets the guards riled up.
- Fixed "kill" not being marked as a cheat command.
- Alarm buzzers and sirens turn off if they're deattached and picked up.
- Fixed wire that's connected between two docking ports becoming visible and interactable when leaving an outpost.
- Fixed subinventories being drawn on top of campaing interfaces.
- Fixed selecting purchasable submarines not working on non-host clients with campaign management permissions.
- Fixed ResearchModule_01 not being fully powered.
- Fixed initial campaign cinematic being shown to clients who join mid-campaign.

---------------------------------------------------------------------------------------------------------
v0.10.0.0
---------------------------------------------------------------------------------------------------------

Improved campaign mode:
- Explorable, procedurally generated outposts.
- Interactable NPCs: things such as hiring, unlocking missions and purchasing supplies are now done by interacting with NPCs instead of just a menu.
- Multi-step, branching scripted events in outposts.
- A reputation system that affects how outposts and factions relate to you and your crew. High reputation can make NPCs give you discounts for supplies or unlock special events and event outcomes, while low reputation may turn outposts hostile towards you.
- Items can now be sold in outposts.
- Persistent bots in multiplayer campaign.
- Bots can be hired in multiplayer campaign.
- New campaign map.
- The end location is now reachable (do note that the ending is still not completely final).
- Submarines can be upgraded: for example, you can increase the durability of the walls and make devices more powerful, less prone to malfunctions or less power-hungry.
- Submarines can be purchased and switched during the campaign.
- Improved end-of-round summary.

Miscellaneous changes and additions:
- Overhauled most structure and item sprites to make the artstyle more consistent.
- Balanced economy (item prices, hiring costs).
- The currency is now called the Europan Mark instead of credits.
- 4 new background music tracks.
- Tons of new decorative items and structures.
- Sittable chairs.
- Allow characters to hear messages sent through the radio when within speaking range of the speaker, even if the characters don't have functional headsets.
- Made organ damage non-limb-specific.
- Hostile bots now take stunning into account when evaluating the weapons. I.e. switch from stun baton to diving knife if the target is stunned and back to stun baton if it's not.
- Sodium and lithium explode in water.
- Item sprites can be rotated in the sub editor.
- Purchased adrenaline glands spawn in crates.
- Allow changing audio output device in the game settings.
- Added "Is On" property to pumps to make them easier to turn on in the sub editor.
- Tuned difficulty of level events, now with a less severe difficulty curve and more account taken of intensity.
- Numerous quality of life and visual improvements for stock subs.
- Mission specific creature variants.
- Node based event editor.
- Crawlers tuned to be considerably more dangerous.
- General creature balance improvements.
- Creatures avoid targeting the same targets as other characters of the same swarm/type. Should considerably reduce the "stacking", where multiple creatures attack exactly the same target.
- Bots can rescue/heal targets when they are inside wrecks/outposts.They are not allowed to switch submarines during the objective.
- Molochs' skirts are now fully severable and collide with the sub instead of floating through the walls.
- Grenades and syringe guns can be put inside toolboxes.
- Headsets no longer consume battery power

Bugfixes:
- Steam networking fixes and additional logging to address issues with some clients being unable to join servers.
- Ignore ballast tanks when calculating flooding in EventManager. Fixes intensity going up when a submarine with large ballast tanks dives.
- Fixed gaps generating incorrectly on sloped walls that have been mirrored vertically (horizontal gaps when they should be vertical and vice versa), preventing water from getting through the wall when it's damaged.
- Fixed sub MD5 hash not getting recalculated when saving a sub, causing a mismatch when trying to host a server without restarting.
- Fixed item highlights being visible in the generated sub preview images.
- Fixed cargo spawning partially inside walls in Azimuth.
- Fixed ragdoll going crazy when trying to run a wire past the maximum length.
- Fixed LOS effect "twitching" when the cursor is close to the character's position.
- Fixed handheld sonar pinging and quickly draining the battery when holding E.
- Fixed PowerContainer's charge indicator going outside bounds if the charge is set higher than the capacity in the sub editor.
- Fixed sub editor's entity list resetting when pressing esc.
- Fixed reactors degrading all the way to 0% condition and exploding when submerged.
- Fixed dumptofile command not including error messages.
- Fixed salvage missions not considering the item to be salvaged if it's inside a container in a character's inventory.
- Fixed ragdolls going crazy when moving directly from the sub to a ruin (e.g. when parking the sub so that the airlock is right against the entrance to the ruins).
- Fixed audio staying disabled when disconnecting and reconnecting the audio device.
- Fixed inability to detach an item the same round it's attached if it's been loaded from a save as a part of a character inventory at the beginning of the round.
- Fixed trying to give an order to a character who can't hear you when using the quick-assignment on the command interface.
- Avoid giving different campaign locations the same name.
- Fixed bots sometimes getting stuck in the "get item" objective, if the item was specified with a reference instead of identifier.
- Fixed bots getting stuck in broken hatches when they climb in ladders.
- Fixed a bug where a waypoint lost all the references when it was selected and the user pressed over an UI element, like the save button.

---------------------------------------------------------------------------------------------------------
v0.9.10.0
---------------------------------------------------------------------------------------------------------

Additions and changes:
- Added 2 new moloch variants: Black Moloch and Moloch Pupa.
- Reworked Moloch.
- Overhauled level layouts and events (longer and more difficult levels).
- Added two new afflictions: medical items and poisons cause organ damage instead of internal damage and explosions cause deep tissue injuries. Both are functionally identical to internal damage, and treated with the same items. 
- Added DXT5 texture compression to reduce memory consumption. Slightly increases loading times; if you're not short on memory, you may want to disable the compression from the game settings.
- Added partial dismemberment for live creatures. Currently enabled only for non-humanoids. (Dismembering dead bodies was already in the game).
- Destructible shells/armor -> Moloch's shell can now be destroyed.
- Added a new monster AI state: Protect.
- Increased the threshold for limping and changed the calculations.
- Added limping for non-human characters.
- Modded servers show up as purple in the server list.
- Added 4 new background music tracks.
- Added parameter autocompletion to the "spawnsub" command.
- All content types except UI styles are now hotswappable.
- Made smoke detector logic more accurate (no size restrictions on the size of the fire, the fire doesn't have to be inside the same hull).
- Added "Output" and "FalseOutput" properties to smoke detector.
- Option to define ambient light values for individual hulls in the sub editor.
- Characters float in place instead of sinking when staying still underwater.
- Improvements to water flow forces: flowing water can push characters around much more heavily now.
- Balanced item prices and fabrication/deconstruction recipes.
- Balanced medical items.
- UI layout improvements when using an ultrawide resolution.
- Added "set_channel" input to wifi components.
- Added "power_value_out" and "load_value_out" outputs to reactor.
- Added search/filter boxes to content package list in the settings menu and item lists in the Workshop menu.
- Added submarine filter to the server lobby.
- Detonators are only triggered by non-zero signals.
- The state of toggleable controllers (= switches) can be set in the sub editor.
- Made toolboxes purchaseable.
- Added a warning to keep the drone door closed in Remora.
- All Thalamus cells die when the Thalamus dies.
- Removed "hold fire" option from the "operate weapon" order, display turrets on minimap as icons instead of text.
- Added some logic to prevent the game from modifying/deleting any vanilla content in any situation.
- Readded legacy Carrier (doesn't spawn naturally but can be spawned with console commands).
- Modified Typhon 2's coilgun rotation limits a bit so it isn't possible to hit the walls when firing at enemies near the airlock.
- Hulls can be multiedited in the sub editor.
- Placed down wires can now be re-equipped in the sub editor by double clicking a loose end.
- Added charging docks to Remora.
- Adjusted how pixel sizes are converted to meters (which are used to display the submarine's dimensions and distances on the navigation terminal). Previously 100 pixels corresponded to 1 meter, now it's 80px -> 1m, making the human characters about 1.75m tall. 
- Distance calculations on the navigation terminal take the shape of the path into account instead of just using the direct distance to the target.
- Made improvements to the manual order assignment by adding always visible name labels, displaying indicators for characters' current orders, and repositioning the nodes.
- Reduced the damage range of fires, characters don't take damage from fires if there's a closed door or a wall in between.
- Always draw steering indicators at the center of the display instead of the center of the sub. Fixes indicators getting offset (sometimes even outside the display) during docking.
- Added option to give all command perms with the "givecommandperm" command by using "all" as the parameter.
- Wrecks with no predefined Thalamus items can no more be infested by Thalamus. Allows to create wrecks that always spawn without Thalamus.
- The "shut down" reactor order now allows the bot to continue doing other things after powering off the reactor, instead of just standing next to the reactor.
- Removed the "initiative" skill -> all bots should now react better when there's something to do. Note: this doesn't mean that they always react on everything. It's just the end of individualism. At least for now.
- Reduced the physical forces applied on characters when they are hit by melee weapons, harpoons, or frag grenades. Adjusted stun for crowbar and harpoon.
- Disabled retreat/escape behavior for the bots when they take damage from items or explosions. They still escape/fight back when attacked by other characters.
- Refactor the medic priority calculations/logic: Bots should never treat others autonomously, unless they are medics or ordered to rescue. Bots should always give a high priority for treating themselves, unless there's a medic on board.
- Adjusted the flipping logic of non-humanoids to make them flip less frequently.
- Monsters won't anymore target nasonov artifact unless it is inside the player submarine or in the player inventory.

Modding:
- Made it possible to use repair tools with StatusEffect's UseItem.
- Made pressure deaths more moddable. Dying because of high pressure isn't hard-coded anymore, the characters are just given the barotrauma affliction which (by default) kills them.
- Added "HideConditionBar" property to items.
- Fixed wearables staying on the character when the item is removed by a status effect.
- Character light sprites can now deform. The cells of Thalamus (Leucocyte and Terminal cell) now use the deformable light sprites.
- Creature flipping parameters are now exposed. Adjusted the flipping for all creatures.
- Allow to define character joints as weld joints in addition of normal revolute joints. Weld joints don't rotate.
- Allow sound definitions to ignore the muffling effect.
- Exposed the "scatter" value and added new "offset" attribute for monster events.
- Added support for status effects in limb definitions (ragdoll file).
- Status effects defined in the character definition can now also target limbs.
- Added ActionType.OnSevered status effect for limbs.
- Creatures can now be set to disrupt sonar.
- Player attacks can now also use the conditionals (i.e. when player is controlling a character). Previously only the AI used the conditionals.
- Conditional sprites don't anymore require a texture definition.
- Conditional Sprites can now be non-exclusive -> Draw more than just one sprite at a time.
- Fixed conditional sprites not being able to target limbs.

Bugfixes:
- Fixed crashing when opening the tab menu when there are clients present with no job preferences set.
- Fixed "ColdCavernsMaze" levels sometimes being extremely short.
- Fixes to level generation when playing with a very large submarine.
- Fixed bots being unable to shoot at enemies from another room/hull.
- Fixed bots being unable to get items from dead bodies.
- Fixed submarines being unable to move vertically in the submarine test mode.
- Fixed crashing when starting a new round with no audio device (speakers, headset) available.
- Improvements to shadow/LOS rendering.
- Fixed double click being ignored if it's been less than 0.4s since the last double click.
- Fixed all servers sometimes not showing up in the server list (showing only the servers in the same/nearby region).
- Fixed "lone sailor" achievement not unlocking in single player.
- Fixed "Gaze in to the Abyss" achievement sometimes unlocking as soon as the round starts.
- Fixed characters sometimes being unable to exit the submarine when outside the borders of the level.
- Fixed ruin/wreck monsters not spawning if the submarine is too close to them.
- Fixed ruin items sometimes getting saved as a part of the main submarine in the campaign.
- Fixed rare "item with the same key has already been added" errors when starting a round (particularly when playing with a submarine with very large numbers of items/structures).
- Thalamus entities can't be selected in the sub editor when they're hidden.
- Fixed "spawnsub" console command not working.
- Fixed projectiles, welding tools and plasma cutters hitting destroyed Thalamus organs.
- Fixed reactor not shutting down if the turbine/fission rate are controlled via signals even the power switch is toggled off.
- Fixed reactor sliders not moving when they're controlled by signals.
- Fixed level triggers sometimes affecting entities that have left the trigger. The most noticeable effect was characters getting burn damage indefinitely after they've been close to a hydrothermal vent.
- Made flamers fire proof to prevents the flames from blowing up the fuel tank inside it.
- Don't allow harpoons to stick to very small limbs (such as mudraptor's "mouth tentacles"), because it lead to physics glitches.
- Fixed the husk infection crashing when turning the character, if either the non-husk or the husked variation has no inventory defined.
- Fixed characters getting weapon XP after using a turret, until someone else operates the same turret.
- Fixed characters being able to crouch when their pose is controlled by a controller (e.g. periscope, modded chair).
- Fixed bots being unable to aim correctly when operating a turret in another submarine (such as a remotely controlled coilgun in a shuttle).
- Fixed bots sometimes taking too much time to interrupt their current objective when the room they're in floods, causing them to get crushed by pressure.
- Fixed bots sometimes letting go of ladders too soon, preventing them from reaching certain areas (such as the upper platform in Berilia's cargo bay).
- Fixed multiple bots sometimes trying to treat the same person.
- Bots stop grabbing the character they're treating after they're done.
- Fixed harpoons going through doors.
- Fixed depth charges going through level walls.
- Fixed husks attacking human husks wearing a diving suit.
- Fixed first shot from a firearm that uses a magazine/clip not doing anything.
- Fixes to waypoints in Kastrull, Berilia and Remora.
- Fixed chat-linked wifi components not working in single player.
- Fixed chat-linked wifi components not working in multiplayer outside of combat missions.
- Fixed Azimuth using tutorial junction boxes instead of normal ones (the tutorial variants are indestructible and don't have signal connections).
- Fixed autopilot not being able to navigate past wrecks.
- More reliable syncing of door's breaking state. Fixes doors sometimes being impassable or impossible to repair client-side, particularly when joining mid-round.
- Fixed repairing doors getting interrupted at 50% when the door's collider is re-enabled and the character pushed out of the doorway.
- Fixed items getting used in the health interface when dropped on a subinventory slot in front of the interface.
- Fixed dedicated servers letting clients join with an invalid name when there's no server owner.
- Fixed server letting clients join with a name that's already taken.
- Changed "creating hulls between docking ports failed" from errors to warnings. Allows creating exterior docking ports that aren't next to a hull without having the console pop up every time the port is used.
- Fixed changing resolution not updating character inventory slot sizes properly, causing invalid spacing in dead characters' inventories.
- Don't allow detaching signal components when rewiring is disabled or the item's connection panel is locked.
- Fixed misaligned hull next to Wreck1's airlock.
- Fixed "attempting to remove an already removed item" errors when mass-deleting items. Happened because removing items a wire is connected to removes the orphaned wires automatically.
- Fixed multi-part subs (example case: The Aeche III) getting teleported to oblivion when flipped.
- Fixes to bots getting stuck or killed for no apparent reason when the player is very far from them, due to the bots switching to a "simple physics mode" which prevents them from doing certain kinds of interactions.
- The explosive cargo mission that places a block of Volatile Compound N in one of the crates no longer requires delivering the volatile block to the destination.
- Disabled crush depth in the submarine test mode.
- Fixed monsters staying invisible if they die far away from the camera view.
- Fixed very small limbs (mudraptor's mouth tentacles, husk appendages) launching off at a very high velocity, leading to glitchy physics behavior, when hit by a non-raycast projectile or an explosion.
- Allow subs to be saved to subdirectories of the "Submarines" folder (e.g. "Submarines/Downloaded").
- Fixed a couple of waypoints in Berilia that prevented bots from using the ladders.
- Fixed Husked Crawler bleeding red blood.
- Fixed the priority of the operate order being 69 when it should be 70, which sometimes caused bots to get stuck between two objectives (like repairing or fixing leaks).
- Fixed enemies always using the priority defined for "room" when they should use the priority for "sonar".
- Fixed monsters not being able to drop down from platforms/hatches etc. In practice they still have difficulties in getting down from the hatches when they don't swim because they are so big.
- Fixed bots ignoring themselves as a target when they are rescuing others.
- Fixed numerous issues in the monster behavior when simple physics is enabled. e.g. Ignoring targets or not being able to attack or eat them.
- Fixed hitting damage modifiers emitting a ridiculous amount of particles.
- Fixed some cases where bots fail to open the door that they should be able to open (because they skipped a waypoint without checking the doors).
- Fixed monsters not keeping inside the level.
- Fixed a crash when the command interface button was pressed while the player is controlling a custom monster that didn't have character info but was able to speak.
- Fixed monsters sometimes ignoring their target after attacking.

---------------------------------------------------------------------------------------------------------
v0.9.9.1
---------------------------------------------------------------------------------------------------------

- Fixed bots being unable to fire turrets due to the visibility raycast hitting the turret's collider.
- Fixed submarine's version number resetting to 0.0.0.0 when saving in the sub editor (didn't affect the actual saved sub file, only the in-game metadata that got fixed by restarting the game - so there's no need to do anything to fix the sub files you saved with the previous version).
- Fixed server list occasionally crashing when trying to filter based on game mode.
- Fixed an issue in multiplayer campaign that occasionally caused clients to get kicked with a "missing entity" error message.
- Fixed clients occasionally crashing when joining a server mid-round. Happened when the client tried to execute the attack of a monster that has already despawned server-side.
- Fixed local changes an user has made to a mod getting overwritten when the item gets autoupdated.
- Changed the hotkey to toggle the entity list in the sub editor from Q to the "toggle inventory" keybind to make it a little more user-friendly on AZERTY keyboards.
- Fixed corpses in wrecks being considered dead members of the crew in SteamAchievementManager, preventing "lone sailor" from unlocking and making it possible to unlock "last man standing" with just one character.

---------------------------------------------------------------------------------------------------------
v0.9.9.0
---------------------------------------------------------------------------------------------------------

- Added wrecked submarines to levels.
- Reimplemented carrier (now called Thalamus).
- New submarine, Azimuth.
- Miscellaneous performance optimizations.
- Improvements to traitor missions (slightly simpler, with clearer instructions).
- Reduced the skill requirements for mechanical repairs.
- Reduced the damage when a mechanical repair fails.
- Rebalanced mission rewards.
- New water ambience sounds.
- Speed up despawning when there are lots of bodies inside the sub, enemies despawn x2 faster.
- Salvage missions can be completed by taking the artifact to the start outpost (the descriptions don't specify which outpost to return it to).
- Characters with insufficient skills can fail at mechanical repairs, causing minor injuries.
- Gaps that are inside a hull don't flood the sub, a warning icon is displayed on those gaps in the sub editor.
- Added submarine test mode to the sub editor.
- Moved the entity filter panel and "previously used" panel in the sub editor to the top left corner of the screen.
- Pressing enter after modifying the value of a text field in the sub editor is no longer required.
- "teleportsub" console command can be used to teleport the sub to the position of the cursor.
- The engine vibrates and plays a loud sound when it's damaged to indicate more clearly that it needs repairs.
- Added animated lights to alarm buzzers and sirens.
- Sonar beacon's label can be edited in-game.
- Assistants gain skills faster than other characters.
- Skills increase faster during non-campaign rounds.
- More noticeable particle effects on damaged devices.
- Added "itemdamage" parameter to the explosion command.
- Huskified characters turn to the final stage faster.
- Using the "dumptofile" and "findentityids" commands doesn't require a permission from the server.
- Added Scale and Color properties to DecorativeSprites.
- Added OnDamaged status effect type.
- Added lights that indicate the state of a docking port.
- Significantly increased the item damages of all explosives.
- Replaced the old husk stinger with tentacles (similar to Husked Crawler).
- Minor adjustments to Husk, Human Husk, and Husked Crawler.
- Modding: Added "probabilitymultiplier" attribute for damagemodifiers. Can be used to make items/armor affect the probability of getting an affliction.
- Diving suits now give some protection against husk infections.
- Light components can be set to flicker in the sub editor.
- Fixed odd movements when pressing the ragdoll button while stunned.
- Made it easier to interact with doors that are overlapping with a docking port/hatch.
- Option to disable bot conversations in multiplayer in the server config file.

Submarine editor improvements:
- Removed character mode. All the functionality of the character mode is now supported in the default mode.
- It's possible to modify the properties of multiple selected entities at the same time.
- Autosaving (the submarine is automatically saved to a temporary file which can be recovered if the game crashes).
- Added hotkeys for a bunch of actions (the hotkeys are visible in the tooltips).
- Pressing F focuses the camera on the selected entities.
- Control + A to select/deselect everything.
- Hold shift to ignore the grid when placing / resizing.
- The outlines of all wires are shown in wiring mode.
- Orphaned wires are deleted automatically.
- The content of the search box isn't reset when switching entity categories.
- Mouse middle mouse dragging is now 1:1, previously the view moved too fast.
- Linked submarines now have visuals when dragging.
- Holding down arrow keys now continues to move the entity after a small delay.
- Changing the background color by shift right clicking.

Antigriefing improvements:
- Players can be kicked/banned/muted/votekicked and their ranks changed by right clicking the name in the crew list or chat.
- Karma penalty for stunning: gets progressively more severe the more stuns a player causes.
- Stealing weapons or ID cards from stunned/unconscious characters reduces karma.
- Added karma category to server log.

Tab menu improvements:
- Improved layout.
- Show the roles of the players (moderator, admin, host) in the player list.
- Characters can be muted/kicked/banned from the player list.
- List the players who have joined/left the server.
- Display spectators in the list.
- Show player pings in the list.

Command interface improvements:
- Contextual commands: characters can be ordered to operate/repair/use specific items by holding shift while enabling the command interface.
- Job icons are shown in the command interface to make it a little faster to differentiate between characters.
- Added separate orders for repairing electrical and mechanical devices.

VOIP improvements:
- Added a keybind for local voice chat (= it's possible to only speak to players next to you without everyone within headset range hearing it).
- Added an adjustable delay for cutting audio capture after the push-to-talk key has been released.
- Fixed audio being suppressed when someone speaks even if VOIP volume is low or completely muted.

Workshop improvements:
- "Enabling" a mod through the ingame Workshop screen is no longer a thing; subscribing to a mod is all you need to do for the game to install it once it's downloaded.
- Loading preview images and installing mods is done asynchronously (= no lag spikes).
- Added notifications to the main menu to indicate when mods are being downloaded and have been installed.
- Files are automatically added to the Workshop item publish menu as they're added to a to-be-published content package's directory.

Bugfixes:
- Fixed achievements not unlocking.
- Fixed positions of artifacts spawning in caves and on level walls getting desynced between the server and clients.
- Fixed new wire node being created at an item client-side if connecting the wire fails due to an electric shock server-side.
- Fixed clients executing console commands they don't have permission to use.
- Fixed enablecheats command not being relayed to server.
- Fixed light component and alarm siren/buzzer states occasionally getting desynced.
- Fixed inability to enter the sub through very small hulls.
- Fixed antibiotics not giving husk infection resistance when shot from a syringe gun. 
- Fixed text overflows in the player management panel in the server lobby in languages other than English.
- Fixed searchlight toggle doing nothing.
- Fixed hulls that have minuscule amounts of water in them (too small to be even rendered) being able to trigger InWater effects and water footstep sounds.
- Fixed pumps dicarding the previously received set_targetlevel signal after 0.1 seconds, preventing manual control systems from working if the pumps aren't receiving a continuous set_targetlevel signal.
- Fixes to occasional crashes when rendering alien artifacts.
- Fixed radio chat key not working.
- Fixed reconnected clients not gaining XP.
- Fixes to sprite depth issues in Berilia's decorative fin structures.
- Fixed bots with an active order not switching to idle state when they have nothing to do, causing them to stand in place or walk against a wall.
- Fixed docking ports without a door sometimes getting linked to an incorrect door, preventing the door's linked gap from working correctly.
- Fixed monsters not spawning in ruins if the submarine hasn't left the starting outpost.
- Fixed freezing caused by SoundManager.InitStreamThread.
- Fixed generic Powered components (= charging dock) always using the default power consumption value defined in XML even if the power consumption is changed in the sub editor.
- Fixed last traitor objective's end message not being shown.
- Fixed command interface showing non-interactable devices as valid targets.
- Fixed dragged characters sometimes getting stuck on staircases.
- Fixed serious performance issues triggered by bot's combat and rescue objectives when there are no safe hulls left.
- Fixed characters being grabbable through walls.
- Potentially fixed a crash in GameMain.WindowActive caused by voice chat capture when the game is exiting.
- Spawn cargo above the floor structure of the cargo room, not above the bottom of the cargo hull. Fixes items spawning partially inside structures where the hull extends below the floor.
- Fixed all monsters bleeding red blood.
- Fixed light sprite's scale not being taken into account in light culling, causing lights with a large scaled-up light sprite to disappear before they're off-screen.
- Fixed damageable items not taking damage from repair tools.
- Fixed hitscan projectiles not hitting items.
- Fixed the short freeze when switching to the sub editor.
- Fixed sprites not being included in the xml element when using "copy to clipboard" in the particle editor.
- Fixed clients being able to use the number inputs in the multiplayer campaign store without the appropriate permissions.
- Fixed ability to buy more than 100 items of a kind despite 100 being the limit of how many purchased items of a kind can spawn.
- Fixed handheld sonar pinging when LMB is held, quickly draining the battery.
- Added some checks to prevent character sounds from crashing the game when audio playback is disabled.
- Fixed character collider's angular damping getting set to 0 if the character gets frozen, which caused the character's swimming animation to get wobbly.
- Fixed private messages not having the [PM] tag when dead.
- Fixed inability to open the health interface when hovering the cursor over another character, even if the character's health interface is inaccessible.
- Fixed bots being inactive when far away from all player characters.
- Fixed some particles (like muzzle flash) not being drawn on top of structures that are outside hulls.
- Fixed enemies being unable to target entities outside the submarine if they are inside it.
- Fixed oxygenite shards and tanks causing characters to move at turbo speed.
- Fixed waypoint links to gaps, doors, and ladders etc being removed when linking waypoint to another in the sub editor. Allow to remove links between waypoints.
- Fixed "teleportsub" console command teleporting also the connected outposts.
- Fixed characters getting stuck on platforms that extend outside the sub.
- Fixed diving suit lockers that have been recolored in the sub editor switching back to the default color when a suit is placed inside them.
- Coilgun/railgun loaders don't deteriorate if launching the turret fails. Fixes loaders deteriorating rapidly if the turret is receiving a continuous signal.
- Fixed rendering glitches on the surface of water when there's steep angles on the surface.
- Fixed inability to fire ranged reapons from sub to another through docking ports.
- Fixed inability drag characters from sub to another through docking ports.
- Fixed bots trying to shoot targets inside the alien ruins.

---------------------------------------------------------------------------------------------------------
v0.9.8.0
---------------------------------------------------------------------------------------------------------

Additions and changes:
- Added husked Crawler.
- Re-worked Crawler.
- Moloch: Changed behavior. Added attacks on the tentacles. Fixed some behavior and targeting related issues.
- Improved eating animations.
- Rebind monster attack to "R", because the middle mouse button is now reserved for the command interface. Fixes attacking while controlling a husk or some other monster.
- Calculate the direction from the limbs separately when attacking. Fixes some issues when an attack applies forces on multiple limbs.
- Added damage protection on Hammerhead Matriarch's and Moloch's skirts/tentacles.
- Changed the ai target calculations for characters.
- Adjusted the AI targets for: navterminal, sonar, flashlight, diving suit, underwater scooter, flare, fire extinguisher, and many weapons.
- Husk infection progress is now a bit different: The thresholds are different, and the damage is taken only in the final phase before turning.
  The final phase now causes minor twitching in the body.
- Husk faces are now only visible on fully turned (human) husks.
- Fixed rapid turning into husk when taking a a lot of damage from husks.
- Monsters with "flee health threshold" defined now only flee when they are being chased.
- Adjusted Bonethresher's attacks.
- Adjusted the AI priorities for Hammerhead Spawn, Husk, Tigerthresher, Moloch, Mudraptor.
- Mudraptors don't flee anymore when on low health.
- Improvements and fixes on the medic AI.
- Add medical autonomous objectives for also other jobs than medics.
- Improvements and fixes on the extinguish fires behavior.
- The bots don't anymore report about low priority issues while fighting or fleeing. Also fixes bots always reporting theirself as the target for the required treatments.
- Movement speed modifiers now adjust the swimming animations and steering forces too.
- Removed deprecated Molochboss. The boss will be reimplemented later.
- Forced aggressive behavior for creatures that are spawned as mission targets, make an exception with the Matriarch.
- Pressing enter is not required after changing values in text fields in the sub editor.

Modding:
- Husk affliction mechanics now fully support different species.
- Added "Visibility" parameter for the characters (similar to Noise).
- Added "Attack Force Multiplier" for all limbs.
- Implemented per joint and per limb scaling.
- New LimbType: "Jaw". Used for eating animations.
- Added "Attack Distance" parameter, which is currently only used for Aggressive and PassiveAggressive behaviors.
- Added "Constant Angle" and "Constant Torque" for keeping a limb constantly rotated in a desired orientation.
- Allow to define world forces for the root movement in three phases of the attack: start, middle, end. Set the main collider position to the main limb position when the attack ends to fix the rubberbanding behavior after the attacks.
- Implemented "After Attack Delay": A property for adding a delay after the attack has hit the target, before starting to update the after attack behavior (e.g. falling back).
- Renamed "AttackContext.NotDefined" to "AttackContext.Any".
- Added "Retreat" parameter for attacks. When enabled, the character tries to steer away from the target while attacking it.
- Accept the plural "requireditems" when overriding items.
- Replaced "identifiers" with "items" on "RequiredItems" elements. Both strings are handled in code -> no functional difference. Fixed just for clarity.

Bugfixes:
- Fixes to crashes when autoupdating Workshop items during startup.
- Fixes to disconnections with the error message "expected old event" when loading a round takes a long time.
- Fixed crashing if the selected core content package contains errors (missing files, invalid XML files).
- Fixed splash screen causing a crash on some Mac systems.
- Fixed corrupted save files causing the game to crash during loading.
- Fixed clients being able to run the "enablecheats" command client-side without the permission to use the command.
- Fixed AI inputs not being synced with clients, preventing clients from seeing when the bots aim/shoot/attack.
- Don't allow using the "flipx" console command while playing online.
- Fixed portrait area & health bar being clickable (despite being hidden) when grabbing another character.
- Fixed a case of characters getting stuck facing one direction. Happened when you switched a character when the command interface was enabled.
- Fixed previous order disappearing from the crew list on resolution change.
- Fixed text not being colored according to message type (default/radio/pm/dead) in the chat input box.
- Fixed "collection was modified" exception if drawing a subinventory causes highlighted inventory slots to change.
- Fixed coilgun/railgun projectiles occasionally hitting the wall next to the turret when launched.
- Fixed text overlays "vibrating" when using the Health Scanner HUD while the sub is moving.
- Fixed level editor not saving level generation parameters that are inside an <override> element.
- Fixed job icons overflowing from the job selection panel when using mods that add more jobs.
- Fixed clients being unable to cancel file transfers.
- Fixed StatusEffects with a delay or a duration "transferring" to another target when the same effect is applied on another entity (for example when using the same stabilozine syringe on multiple characters).
- Fixed particles spawned in StatusEffects only copying the emission angle of the parent item, but not the rotation when CopyEntityAngle is set to true.
- Fixed terminals not sending any outputs server-side.
- Fixed bots unequipping diving suits when they shouldn't. Only happened while doing a low prio objective.
- Fixed retreating bots attacking with adhoc weapons like tools. If the bots retreat, they shouldn't use weapons at all.
- Fixed the priority calculation for the rescue all objective. Should fix bots refusing to treat seriously injured characters and also fixes the priority of the targets.
- Fixed occasional rapid flipping (usually noticeable only in debug draw mode) when a bot has no valid path or the path has ended.
- Fixed bots sometimes not being able to climb ladders because they skip a node too early. Happened especially in Katrull.
- Fixed some cases where bots fail to release the ladders when they should.
- Fixed bots occasionally disgarding an autonomous objective with low priority after starting to follow it.
- Fixed bots ignoring unsafe hulls (= any threats) when they shouldn't and consequently heading into danger.
- Fixed some monster attacks causing internal damage instead of bitewounds.
- Fixed Hammerhead Matriarch's head damage modifier ignoring bitewounds.
- Fixed latched creatures not reacting on being damaged.
- Fixed monsters flipping constantly while swimming.
- Fixed Husks not regenerating health properly.
- Fixed AI targets not being decreased on inactive items.
- Fixed fire extinguisher definition (xml): the identifier and the tag shouldn't be the same string.
- Fixed monsters sometimes moving slower than they should when walking inside.
- Fixed charge indicator not being flipped in horizontally/vertically flipped batteries.
- Fixed fabricators occasionally getting stuck to the active/inactive state client-side when the fabrication is paused due to insufficient power.
- Fixed ancient weapon not cutting through holes in walls.
- Fixed ambient light being brighter in the submarine editor than in-game.
- Fixed walk speed not being affected by speed reductions.
- Fixed all enemies ignoring the speed modifiers.
- Fixed wires appearing as loose items on the floor after saving and reloading if they've been disconnected from both ends.
- Fixed non-stackable status effects with a duration having no effect.

---------------------------------------------------------------------------------------------------------
v0.9.7.1
---------------------------------------------------------------------------------------------------------

- Fixed crashing when attempting to publish Workshop items.

---------------------------------------------------------------------------------------------------------
v0.9.7.0
---------------------------------------------------------------------------------------------------------

UI/UX improvements:
- Graphical and functional overhaul of all user interfaces.
- Cursor changes according to what it's hovered on (hand icon when on a button, caret icon when on a textbox, etc).
- New loading screen.
- Better feedback on shooting.
- Double clicking on an item moves it to the equipped inventory (e.g. ammo to the equipped weapon).
- Periscopes can be deselected by pressing esc.
- Fabricators can pull ingredients directly from the user's inventory without having to place them in the fabricator's input slots.
- Lock the on/off switch in the pump interface when the state is controlled by signals, same with the engine slider.
- 1 second cooldown before doors can be opened/closed after someone else has opened/closed them. Makes it less likely for doors to be opened/closed accidentally when multiple people are trying to use them at the same time. 
- Show a warning if trying to start a campaign for the first time without playing the tutorials.
- Diving suits and fire extinguishers are not automatically picked up from the lockers/brackets when clicking on them to make it less likely to accidentally pick them up. Instead, clicking on them opens the inventory of the container, the same way when interacting with e.g. a steel cabinet.
- Subinventories (= inventories inside items, toolboxes for example) open/close faster and cannot be interacted with until fully open.
- Contents of toolboxes and crates are shown in the tooltip when hovering the cursor over the slot.
- In-game message boxes (mission/traitor notifications) close automatically after 15 seconds if not interacted with.
- Right-clicking in the sub editor opens a context menu that can be used to remove, cut, copy and paste entities (making it possible to remove them when using a keyboard that doesn't have a delete key).
- Hide cursor when aiming with a turret or a ranged weapon.
- Hide inventory when operating a turret.
- Added filtering to sprite and particle editors.
- Added a "Decorative" category to the submarine editor.
- Made docking indicators more visible on the sonar.
- Show mic input level also when Push-to-Talk mode is selected to make it easier to adjust the level without having to switch the mode to Voice Activity.
- Pressing the up arrow brings up previously sent chat messages, making it easier to resend them.
- The filter in the sub editor only searches from the currently selected category.

Optimizations:
- Major physics optimization. Most importantly, the physics are now multithreaded, making the game perform much better when there are large numbers of characters active.
- Item optimizations. Items that don't currently have any components active are not updated, which significantly improves the performance especially in large subs with lots of items.
- More aggressive character culling (characters stop being rendered as soon as they exit the camera view).
- Dead bodies despawn after a few minutes (or when the character respawns in multiplayer). The despawning character's items are placed in a duffel bag and dropped near the body. Prevents performance issues when lots of bodies start to accumulate in the submarine.
- Preload necessary monster assets at the start of the round to prevent lag spikes when a monster spawns.
- Fixed serious performance issues when creatures are on the borders of the sub (some issues still remain).
- Improved the performance of human AI (bots).

Additions and changes:
- Added Korean translation.
- Added an improved version of Typhon.
- Reworked Berilia.
- New shuttle, "Hemulen".
- Merged Selkie and Bunyip into a new, improved shuttle (just called Selkie now).
- Increased level sizes.
- Rebalanced monster spawns.
- Balanced skill levels and skill gains.
- Skill gain values are now moddable (see Content/SkillSettings.xml).
- Added a few new artifact missions.
- The job gear variants are not just visually different versions of the same item, but completely separate items. The job variants now allow the players to choose what kind of gear they want to spawn with, not just the look of the uniform.
- Attachable items and wire nodes can now be freely placed around the character instead of always being placed at the position of the character. When attaching items/wires, there's a placement grid that makes it much easier to neatly attach/wire things mid-round.
- The submarines now get automatically outfitted with a semi-random selection of supplies when starting a campaign. The items that have been manually placed in the submarine editor are kept as-is.
- Split internal damage into multiple subtypes: blunt force trauma, lacerations and bite wounds. The new afflictions are functionally identical to the default internal damage affliction, but can be used to identify the source of the injuries.
- Humans are more resistant to gunshot wounds, lacerations and blunt force trauma than monsters. The intention is to allow making weapons more effective towards monsters without making killing your crewmates with them too easy.
- Added a "terminal" item that can be used to send and display textual signals. Could be used for things such as terminals that send commands to devices or display some data received from devices.
- Added muzzle flashes to small firearms.
- Added a crosshair when aiming with small firearms. The crosshair also indicates the spread of the weapon.
- Increased the skill requirements to operate the reactor.
- New background music for editors.
- Characters with an insufficient electrical engineering skill may get electrocuted when rewiring powered devices.
- Added holes in the level walls next to the outpost at the end of the level, so the player doesn't have to backtrack through most of the level if they approach the outpost from the wrong side of the level wall.
- Added heavy water currents at the sides of the level to make it more obvious that you're not supposed to go that way.
- Added subtle chromatic aberration & blur when suffering from heavy bloodloss.
- Nerfed hull damage from plasma cutter and welding tool explosions.
- Removed repair thresholds from items; any device that's not in perfect condition can now be repaired.
- Rebalanced medical items: stat-boosting effects last much longer.
- Modified vigor buffs from steroids and hyperzine to be intantaneous instead of delayed.
- Tweaked opiates. They now do less overdose damage, produce a lower addiction for skilled users, but produce a serious addiction for unskilled users.
- Bandages now have 3 uses.
- Removed oxygenite shards as a product of deconstructing liquid oxygenite to prevent production loops.
- Screwdrivers can be used as shivs!
- Fuel rods now always return their steel on deconstruction.
- Constructing fuel rods now requires lead.
- Mouse button names are now translated.
- Improved tiger thresher texture and lights.
- Replaced the legacy ladder, stair and docking port sprites.
- New alarm buzzer sprite that actually looks like an alarm buzzer.
- New (smaller) small pump sprite.
- Decreased the range and brightness of the "halo" around the players.
- Exposed pump's MaxFlow parameter in the sub editor.
- Added a lot more oomph to nuclear explosions.
- Added damage particle effects that are rendered on top of the characters (also under water).
- Split internal damage into categories: gunshot wound, blunt trauma, lacerations, monster bites, and internal damage.
- Gunshot wound is no longer a bleeding affliction.
- Humans are more resistant to damage caused by weapons (means we can increase the damage on monsters without making the weapons too lethal on humans)
- Added damage protections on some clothes.
- Major SMG buff: larger magazine, less spread, more damage, but slightly lower fire rate.
- Minor Shotgun buff: more damage and stun.
- Slightly decreased the stun effect from revolver ammunition.
- Modding: Removed all texture paths from limbs where they are not required. Fixes issues when trying to create a copy with a custom texture based on an existing character. Note that the "Copy Character" functionality does not automatically replace texture paths that have been defined in limbs, because that could lead into issues. If there are texture paths in the limbs, you'll have to handle it manually. The texture paths defined in limbs are limb specific overrides to the common path defined in the ragdoll's properties.
- Use "weldingequipment" tag instead of "weldingtool" identifier when seeking the equipment for fixing the leaks to enable support for custom welding equipment.
- Use "cuttingequipment" tag instead of "plasmacutter" identifier as required items for collecting minerals to enable support for custom cutting equipment.
- Artifact mission markers are shown on the sonar even after the artifact is on board to make it harder to lose the artifact.
- Made monster mission markers more imprecise.
- Made the "name contains illegal symbols" error message more descriptive (with instructions to change the name to something else).
- CPR damage can be modded by editing the affliction xml.
- A warning when attempting to start a campaign that was saved with different mods than the ones that are currently active.
- Switched from .NET Framework 4.5/Mono to .NET Core 3.0:
	- Improves general stability, especially on macOS and Linux.
	- Lowers number of dependencies, simplifying the installation process.
	- Introduces features that will translate into further stability and performance improvements in the future.
- Switched from MP4 to WebM to minimize bloat and dependencies on patented tech.
- Cap the framerate to 200 FPS when VSync is off to prevent overloading the GPU. The cap can be adjusted by changing the "framelimit" attribute in config_player.xml.
- Wifi components in the respawn shuttle can't communicate with components in other submarines/shuttles.
- Power consumption of damaged devices doesn't increase as much anymore.
- Made tonic liquid purchasable.
- Added combat priorities to alien weapons to allow bots to use them.
- Improved name tag hiding.
- Give job items to humans spawned with the "spawn" command.
- Slightly increased the view range of the coilguns and railguns.
- Continue playing the main menu and editor music from the previous position instead of restarting when switching between screens.
- Marked "editsubs" a cheat command (so you can't just switch to the sub editor, spawn whatever you need and go back to the game without enabling cheats).

AI:
- Bots can now undock the sub.
- Humanoids now use the "group" property like non-humanoids. This allows non-humanoid creatures to be treated as friendly/neutral subjects by the bots.
- Replaced the generic "cannot reach target" messages with context-specific and more descriptive messages.
- Bots now take the other bots into account when they evaluate the importance of the tasks. Fixes multiple bots going to fix the same leaks or repair the same items.
- Bots should now abandon the combat objective only when not fleeing from an enemy. If they fail to flee from an enemy, they will fight (or avoid) instead.
- Fixed bots loading the turrets only with the default ammunition. 
- Fixed multiple bots trying to navigate the submarine at the same time.
- Fixed pathfinding applying 10x more penalty on vertical distance when the host is outside (should only apply inside).
- Fixed bots starting the path from obstructed waypoints or waypoints that are inside when they are outside or vice versa.
- Fixed issues when bots are trying to enter the airlock from outside.
- Fixed bots getting stuck in the combat mode (with 100 priority) when they try to retreat to a target that cannot be reached.
- Fixed two-handed items like ammoboxes not being visible when the bots carry them.
- Fixed issues when the bots try to equip items or contain them inside other items.
- Fixed bots sometimes going to repair leaks/fix things without a mask or a suit.
- Fixed bots being unable to put diving suits into lockers when there already is a diving suit in the targeted container. Instead of dropping it on the ground, the bots now try to find a new place for the suit before abandoning the objective.
- Fixed bots seeking paths through doors when they have a crowbar/wrench equipped.
- Fixed bots sometimes being unable to put off fires and dying while trying to do it (because of a failing raycast).
- Fixed bots not shooting hostile submarines.

Monsters:
- New behaviors: avoiding, passive-aggressive, and aggressive.
- Adjusted Bonethresher, added a berserker attack when the creature is low in health.
- Revised Matriarch's behavior: Matriarchs now spawn in swarms, protected by other Hammerheads, and they try to keep the distance to the submarine. Boosted the explosion and increased the Spawn count.
- Added new missions about Hammerhead Matriarch.
- Revised all the creatures using the new behaviors.
- Changed how "attack when provoked" works. The previous state is now reset when the target changes. Also fixed several relate issues. Rename the property (requires action if custom characters use it). When a creature is attacked and "attack when provoked" is false and the attacker is not found in the predefined ai targets, the creature flees by default instead of just ignoring the attacker.
- Refactored the eating behavior: fixes small creatures not being able to eat significantly larger creatures.
- Adjusted the commonness and the reward of the Thresher swarm mission.
- Improved the indoors escaping behavior.
- Reduced the linear velocity when not facing the movement direction. Should fix monsters moving unnaturally when abruptly changing directions.
- Increased the swimming speeds of all monsters and adjusted the animations accordingly.
- Improved the path steering while swimming inside the submarine.
- Halved the swimming speeds inside the submarine.
- Increased the attack ranges for Hammerhead and Hammerhead gold to help them reach the targets.
- Don't allow large creatures like Bonethreshers or Hammerheads enter the submarine, because they easily get stuck and it's glitchy.
- Fixed characters that cannot enter the submarine still trying to target the inner walls.
- Fixed Tigerthresher and other creatures that can't attack the submarine bumping on the doors.
- Fixed characters occasionally getting stuck while trying to reach the last known position of the previous target.
- Fixed a crash when the creature is set to attack when provoked and when the damage source is null.
- Fixed extra creature being spawned when using the <monster> elements in the monster mission definitions.
- Fixed Hammerhead Matriarch's skirt going throught the walls.
- Fixed performance issues when creatures are trying to find a path out from the submarine while escaping. Also improved the escaping behavior in general.
- Fixed Mudraptors sometimes squeezing themselves towards doors without being able to attack them.
- Fixed monsters not reacting to being fired with turrets unless they can target the attacker.
- Fixed minor slipping in Mudraptor's walking animation.
- Weapons and tools now have ai targets that are only activated when the items are used -> shooting monsters should make you much more attractive target than just swimming peacefully around. 

Multiplayer:
- Fixed a bunch of bugs that caused "missing entity" errors. However, there are many different reasons the error can occur, so even though we have not run into the issue anymore during out testing rounds, there is still a chance it may occur in some situations.
- Fixed inventory items occasionally getting mixed up in the multiplayer campaign.
- Fixed a bug that caused clients to get disconnected with an "invalid object header" error when a character has a large amount of different afflictions.
- Fixed collider tunneling when client is slow to send inputs. Caused characters to occasionally noclip through walls when the connection or framerate is poor.
- Fixed server owner occasionally timing out if loading the round takes too long.
- Fixed server owner's character occasionally being killed due to round start timeouts.
- Fixed players not getting notified in any way when their connection to the server has timed out, allowing them to keep playing without being able to interact with anything.
- Made giveperm/giverank commands suck less by allowing names, endpoints and SteamIDs instead of clientlist id, and allowing users to skip question prompt by adding rank or perm as a second parameter.
- Fixed multiplayer campaign saves appearing in the single player "load game" menu if they're placed in the singleplayer save folder (leading to a crash if a player starts to load the save).
- Fixed server not sending condition updates for inactive items, potentially causing the condition to get desynced when all of the components of the item go inactive.
- Fixed clients only being informed of the reason for their ban the moment they're banned, but not if they try to rejoin.
- Fixed clients not attempting to reconnect to the server automatically when the connection is lost, forcing the client to rejoin the server manually.
- Fixed clients sometimes being able to noclip through walls when the framerate or connection is poor.
- Karma system can be enabled/disabled in the "host server" menu.
- Option to set the number of password retries before a ban.
- Fixed voice chat indicators not working in the in-game crew list.
- Moved "End Round" button to the pause menu.
- Added a separate server log category for wiring.
- Fixed clients not relaying console commands that don't exist client-side to the server (i.e. custom commands implemented by a server mod can now be used by clients).
- Added "killdisconnectedtime" command that can be used to set the time after a disconnected player's character gets automatically killed.
- Increased default killdisconnectedtime to 2 minutes.
- Player cap can be adjusted in the server settings.
- Made "showseed" console command usable by clients.
- Fixed lobby command (which switches to the single player lobby) being usable in multiplayer.

Bugfixes:
- Fixes to render order oddities (structures with a depth > 0.5 always rendering behind all items, inconsistent render order between sub editor and in-game). Now structures with a depth of >= 0.9 are always behind everything (and visible through the LOS effect), and item's sprite depth is capped to 0.9.
- Fixed background structures that are resizeable on both axes always being drawn behind other background structures regardless of the sprite depth.
- Fixed Kastrull flooding when the drone undocks.
- Fixed ballast pumps deteriorating in Kastrull's drone despite being unreachable by the players.
- Fixed sonar transducers consuming no power.
- Fixed EventManager intensity being calculated incorrectly in multiplayer, causing monster spawns to be more sparse in multiplayer than in singleplayer.
- Fixed autopilot overshooting and compensating too heavily when attempting to maintain position, causing it to never fully stop on the target position.
- Fixed charactes being unable to get through multi-layer walls from inside the sub (for example the walls above Humpback's command room).
- Fixed plasma cutter not cutting through holes in walls.
- Fixed melee weapons not working inside ruins due to the colliders that block subs from entering the ruins.
- Fixed fabricator cancellation failing to be communicated under certain circumstances.
- Fixed fabricator and deconstructor operating faster when run on overvoltage, making it possible to fabricate/deconstruct things almost instantaneously by using relays.
- Fixed camera position "twitching" when moving the cursor around while unconscious.
- Fixed crashing if there's no audio device available.
- Fixed texts in mission/traitor notifications occasionally overflowing outside the border of the message box.
- Fixed subinventories not opening when trying to heal an unconscious character.
- Fixed engines causing crashes if MinVoltage is set to 0.
- Fixed small "twitch" when a character enters or exits a submarine.
- Fixed starting a combat mission with just 1 player counting as winning the mission.
- Fixed linked shuttles occasionally spawning at the wrong side of a sub's docking port.
- Fixed clients being assigned as traitors in combat missions even if there's no-one else in their team.
- Fixed server lobby screen not scaling correctly after changing to a bigger resolution.
- Made the screen distortion effects caused by afflictions change less abruptly when the condition of the character changes quickly.
- Fixed items being swapped from slot to another when combining an item with one that has a higher condition.
- Fixed lights in deviced bleeding through characters and blurry black "shadow" around characters.
- Fixed '+' and '-' signs in number input fields being misaligned in Chinese and Japanese.
- Fixed Workshop item descriptions only showing the first 256 characters.
- Fixed reactor highlight effect extending outside the reactor sprite.
- Fixed ID-restricted doors only taking the first ID card in the inventory into account.
- Fixed crashes in the character editor when creating a humanoid with incomplete limb definitions.
- Fixed the character editor crashing if no textures were found.
- Don't allow to save invalid texture paths in the character editor.
- Decreased the range of some of the motion sensors inside alien ruins to prevent certain rooms from being nearly impossible to get past without getting zapped by an alien coil.
- Fixed excessively large tonic liquid collider.
- Fixed accordion collider.
- Fixed doors not blocking hitscan weapons.
- Fixed sonar showing everything around the sub when sending out a directional ping and immediately switching to passive.
- Fixed inability to drag characters from room to another in alien ruins.
- Fixed crashing if a modded UI style contains multiple child styles with the same name.
- Fixed wire nodes getting misplaced when flipping wires in the sub editor.
- Fixed groups of items that include wires sometimes not getting placed at the position of the cursor when pasting them in the sub editor.
- Fixed currents heavily slowing down the submarine regardless of the force or direction of the current.
- Fixed some held items vibrating/twitching when moving.
- Fixed turrets emitting muzzle flash particles in an incorrect direction (the rotation of the particle was correct but the direction it flew towards not, which isn't noticeable with the non-moving vanilla particles).
- Fixed "skip tutorials" returning to the main menu instead of opening the correct tab when starting a new game.
- Fixed all items being highlighted in the multiplayer campaign store menu when another player buys something.
- Fixed setting the number of items to buy by typing a number in the text box being practically impossible in the multiplayer campaign store.
- Fixed grenades exploding multiple times if you throw one, pick it up before it explodes and rethrow it.
- Fixed bots occasionally letting go of ladders too soon when going to operate an item, causing them to fall down.
- Fixed some waypoint issues in Orca.
- Fixed wifi components in the respawn shuttle being able to communicate with the main sub in non-combat missions.
- Fixed engine sound range being up to 20 times larger than it should be.
- Fixed monsters occasionally being able to attack through walls.
- Fixed alarm buzzer not returning to the original rotation when the alarm stops.
- Fixed a couple of unfair ruin traps (rooms with coil/sensor placement that makes it impossible to pass through without getting zapped).
- Fixed mechanic tutorial getting softlocked if the player never has an oxygen tank (or aluminium) and sodium in their inventory at the same time. I.e. if they deconstruct the oxygen tanks first and put the aluminium in the fabricator, and then get the sodium and put it in the fabricator.

---------------------------------------------------------------------------------------------------------
v0.9.6.0
---------------------------------------------------------------------------------------------------------

Networking/multiplayer fixes:
- Fixed the game occasionally freezing when joining a server.
- Fixed a bug that occasionally caused clients to disconnect with an "entity not found" error in the multiplayer. In technical terms, the issue occurred when the server spawned an entity with a given ID, sent a network event for that entity, and then spawned another entity that took up the ID of the previous entity. This could happen, for example, if in the multiplayer campaign a player happens to get an item with the same ID as an item in the inventory of another player who isn't currently present, and the other player joins the server. There are still most likely additional bugs that can cause similar error messages, so this fix will probably not get rid of the errors entirely.
- Fixed start button staying disabled in the server lobby when switching from the campaign mode to another game mode.
- Fixed clients occasionally getting disconnected due to the campaign store. Happened if a location had changed from one type to another (for example, natural formation to outpost), the players had bought something that wasn't originally available from the location and a new client joined.
- Fixed clients occasionally being prompted to download subs from the server even if they already have a matching sub.
- Fixed server having a password even if the password box is left empty in the in-game "host server" menu when hosting with the Linux version.
- Fixed server name being shortened to one word when hosting from the in-game "host server" menu with the Linux version.
- Fixed server name length not being restricted when set from serversettings.xml or using console commands.
- Fixed "ready to start" tickbox disappearing if a client joins while a round is running.
- Fixed traitors remaining as traitors client-side after restarting the round, allowing them to access the sabotage interface despite not having a traitor objective.
- Fixed characters occasionally not selecting/deselecting a periscope client-side, causing them to walk in place or not grab the periscope.
- Fixed male asian heads not appearing in the server lobby.
- Fixed campaign servers never being filtered out from the server browser when filtering based on game mode.
- Fixed clients not displaying the "could not connect" popup if the initial connection to a server times out.
- Fixed door weld state occasionally getting desynced, causing the door to be welded server-side but possible to open client-side.

Electricity fixes:
- Fixed junction boxes not passing signals to relays.
- Fixed broken junction boxes and relays carrying power.
- Fixed devices not receiving power if they're connected directly to batteries/supercapacitors with no relays or junction boxes in between.
- Fixed light components that receive power from somewhere else than a power input connection not going out when they lose power (e.g. lights on the diving suits).
- Fixed pumps and batteries operating/recharging faster when receiving overvoltage, with no upper limit, making it possible to for example operate pumps at 10x the speed by connecting them to a relay that's receiving 10x more power than is being drawn from it.
- Fixed LightComponents being toggled twice when they receive a signal to the toggle connection.

Misc fixes:
- Fixed "last used" listbox overlapping with the entity visibility tickboxes in the submarine editor on low resolutions. 
- Fixed misaligned colliders on the "Shell A Cap 0 deg A/B" wall pieces.
- Fixed links disappearing between linked subs and docking ports when loading in the sub editor.
- Fixed loading freezing for up to 10 seconds if the game cannot fetch the remote content for the main menu (update notifications, changelogs, etc).
- Fixed lights on devices (junction boxes, nav terminals, reactor) being rendered on top of characters.
- Fixed lights lagging a little behind moving objects (e.g. diving suit light).
- Fixed characters being able to grab/heal others when handcuffed.
- Character editor: don't switch to the limb mode when clicking a limb in the joint edit mode. Fixes difficulties in using the joint angle widgets when the widgets are interloping limb source rects.
- Character editor: Fixed the texture path field not being copied if the source character has no texture path defined. In this case, we can use a texture path found in one of the limbs.
- Fixed bots incorrectly reporting problems in the room they are in instead of the room the issues is spotted at.
- Fixed bots reporting broken devices or asking medical attendance even if they are taking care of those things.
- Fixed bots saying "put out a fire in hull" instead of using the name of the room when they extinguish a fire.
- Fixed AITargets staying active even if the entity is not active (for example, the sonar could still be heard by monsters after it's turned off).
- The bots now only report about issues that have not been already been reported.
- Fixed monsters attacking doors that are open.
- Monsters keep pursuing the target if the behavior is "pursue" even when they cannot attack.
- Bots stop operating devices if a player starts operating them (unless they have been ordered to operate the device).
- Fixed bots playing the rewiring sound when repairing an item with a screwdriver.
- Fixed bots sometimes stopping behind a closed door when trying to extinguish a fire.
- Fixed chat messages occasionally extending below the lower bound of the chatbox.
- Fixed searchlight and turret lights disappearing before the light is fully off-screen.
- Waypoint fixes in Kastrull and the drone.
- Fixed Kastrull flooding when the drone is undocked.
- Fixed ballast pumps in Kastrull's drone being off by default.
- Fixed enormous in-game ballistic helmet sprite.
- Fire extinguishers can't be placed inside toolboxes anymore.
- Fixed lobby screen not scaling correctly after changing to a bigger resolution.

---------------------------------------------------------------------------------------------------------
v0.9.5.1
---------------------------------------------------------------------------------------------------------

- Fixed crashing when attempting to start a tutorial.
- Fixed Kastrull's drone not being docked to the sub by default.
- Fixed items occasionally launching through walls/floors when they're spawned or dropped.
- Nerfed Hammerhead Spawns.
- Fixed occasional disconnections when the Hammerhead Matriarch releases her spawns.
- Fixed Hammerhead Matriarch exploding twice when it attacks.
- Fixed bots sometimes getting stuck in an objective loop, causing them to repeatedly drop and pick up diving suits or spam doors.
- Fixed bots being allowed to go outside without a diving suit.
- Fixed characters with a rectangular main collider being unable to use path finding.
- Fixed microphone volume scrollbar resetting to the maximum value when opening the settings menu.
- Fixed a bug that caused occasional crashes on Linux when pinging servers in the server list menu.

---------------------------------------------------------------------------------------------------------
v0.9.5.0
---------------------------------------------------------------------------------------------------------

Misc additions and changes:
- A new submarine, Kastrull.
- 6 new traitor missions with much more varied objectives.
- More variants of all job outfits.
- 30 new character face sprites. 
- Overhauled job assignment logic to make the job distribution a little more balanced. Now each client gets assigned one of the spawnpoints (and its associated job) according to their job preference, which means that if the sub for example has 2x as many engineer spawnpoints than medic spawnpoints, there tend to be 2x more engineers. When playing with a mod that adds new jobs to the game, spawnpoints that have no job associated with them are considered spawnpoints for the non-vanilla jobs.
	- We would like to get feedback from players about this: does the job assignment seem fair, are people generally getting the jobs they want? 
- New logic components: sin, cos, tan, asin, acos, atan, modulo, round, ceil, floor and factorial.
- Improved autopilot: much faster and less likely to get stuck.
	- We would like to get feedback from players about this: Is there still incentive to steer manually?
- AI characters don't set stationary batteries to recharge unless ordered to do so.
- Items can be made damageable by projectiles, melee weapons and explosions by adding DamagedByProjectiles="true", DamagedByMeleeWeapons="true" or DamagedByExplosions="true" to the config.
- Nerfed welding fuel + diving mask combo. The tank depletes much faster and one tank is only enough to make the target fall unconscious, not to kill them.
- Added deconstruction recipes to all drugs.
- Added huskified face sprites to all characters.
- Question prompts in the debug console and dedicated server console (such as "enter the reason to ban XXX") can be cancelled by pressing Ctrl+D or Ctrl+Z (or Ctrl+C in the in-game debug console).
- Welding tools and plasma cutters explode when loaded with the wrong fuel.
- Removed sodium as a product of recycling fire extinguishers.
- Added some loose vents and panels to Orca and Typhon.
- Option to set a name for a character added by a mod without having to configure it in a separate text file. Use displayname="somemonster" in the character element to set the name.
- Balanced splash screen audio volumes.
- Alarm buzzers twitch when active to make it more clear where the sound is coming from.
- Scrollbars that work as on/off switches (e.g. power switches and autotemp sliders in item interfaces) can be toggled by clicking on them.
- Decreased the chance of selecting a traitor mission that's already been selected during the session.

Multiplayer:
- Option to choose a "play style" for the servers to tell the players what kind of gameplay and rules they can expect on the server.
- Improved server browser:
	- More filtering options
		- Same version
		- Show whitelisted
		- Karma enabled
		- Traitors enabled
		- Friendly fire off
		- Voice chat enabled
		- Modded
	- Option to filter by play style.
	- Option to filter by game mode.
	- Added the option to favorite servers.
	- Added a list of recent servers.
	- Added a friends list, you can keep track on which servers your friends are playing at as well as join them directly from the friends list.
	- Miscellaneous layout improvements.
- Improved server lobby:
	- Improved character customization interface: players now have full control over their appearance.
	- Improved job preferences interface: players can now more easily switch around their class preferences, as well as pick which variation of an outfit they would like to wear.
	- Mission selection is more flexible: mission types can be toggled separately.
	- The campaign interface is displayed directly in the menu, not in a separate view.
	- The submarine preview is displayed directly in the menu without having to open a separate window.
	- The job preferences of other players are indicated in the player list.
	- Voice chat icon now indicates the loudness of the audio being transmitted/received.
	- Voice chat settings are indicated in the bottom-right corner of the chat box.
	- The server log is integrated into the chat box.
	- Added new server settings under anti-griefing tab which previously were only accessible through serversettings.xml.
		- Allow friendly fire.
		- Allow rewiring.
		- Allow disguises.
	- Miscellaneous layout changes.

Human AI:
- Changed the logic for automatically unequipping the diving gear, extinguishers or items that are held in hands.
- Taught the bots to place diving suits, fuel rods and fire extinguishers into right places, if they can't unequip the items without dropping them AND if the current objective is not high priority. The system uses tags/identifiers and two new attributes: "preferredcontainers" in Items and "containablerestrictions" in ItemComponents so it can be adjusted both in the editor and in xml.
- Improved the code to prevent dead-locks between the AI states.
- Start looking new oxygen when the current oxygen tank is at 10% instead of starting when it's empty (which often lead the bot to suffocate while doing the objective).
- Combat: Don't ignore empty weapons when evaluating weapons for the first time (allows to try reloading a weapon before ignoring it as useless).
- Fight Intruders: Automatically switch weapon when the current weapon runs out of ammo. Find ammunition for the current weapon if no other decent weapon is found. Don't allow to go offensive while armed with poor weapons, like a wrench.
- Fix Leaks: Improved the operating of welding tools.
- Rescue: Major refactoring. Allow to heal self. Improve the priority calculation. The priority is now based on the severity of wounds.
- Taught the bots to look deeper into the inventories (recursive) when seeking items.
- Changed the decision making on whether or not a bot needs diving gear.
- The bots now avoid unsafe paths in the idle state or when doing low priority objectives.
- The bots don't follow targets outside of the submarine.
- The bots don't stay still when idling underwater.They swim in place instead.
- Adjusted the combat priorities for the weapons.
- Increased the minimum initiatives.
- Adjusted the target evaluation for the Fix Leaks objective.
- Improved the distance approximations for all AI objectives.
- Increased the base devotion (how much the current objective priority is boosted).
- Reduced the shooting distance when the bots are operating turrets.
- Adjusted the idle waiting, standing, and walking times.
- Fixed bots getting stuck if the next node was behind a door.
- Fixed bots getting stuck on ladders when the main collider bottom was slightly lower than the floor level, even though the bot should be able to take off from the ladders.
- Fixed bots getting stuck on ladders when they need a new target while climbing.
- Fixed bots ignoring/avoiding targets in hulls when there were dead enemies inside them.
- Fixed issues in switching empty oxygen tanks to new.
- Fixed bots unequipping and re-equipping diving gear while ordered to follow another character.
- Fixed bots not being able to handle things when they cannot find diving gear. Now they should first try to get the gear and if it fails, they should just target a safe hull.
- Fixed bots shooting friendly characters with turrets.
- Fixed bots always treating weapons as revolvers.
- Fixed the loading of smg magazines/fuel tanks etc (because they are different from revolver rounds).
- Fixed autonomic objectives overriding the user-defined settings (steering, batteries).
- Fixed bots being able to do things while hand-cuffed.
- Fixed a dead-end when an item is taken by another character after the target item was defined and before the objective is completed.
- Fixed item prioritization calculations.
- Fixed hull safety calculations always using the current visible hulls (which should only be taken into account when the hull is the current hull).
- Fixed bots abandoning the operate item objective if there was another character operating the item.
- Fixed bots speaking about success/failure to repair when another character fixes their target.
- Fixed bots reporting individual failures when doing a loop objective. Should fix bots spamming with the "Cannot reach the target" msgs.
- Fixed the current objective not being reassigned after sorting the objectives, leading to sorting the subobjectives of the old current objective, which would be fixed only after the next time the objectives were sorted (after 1 sec).
- Fixed the gap size being misinterpreted when calculating the priority for a fix leak objective.
- Fixed bots switching repair targets while repairing an item.
- Fixed bots in some situations facing the wrong direction. The bots should now always face the item they are operating.
- Fixed bots' ragdolls getting unstable due to constant flipping in some rare cases.
- Fixed bots not immediately targeting the other rooms when they reach the airlock (when entering the submarine).

Monsters:
- New monster: Hammerhead Matriarch
- New monster: Hammerhead Spawn
- New diving suit sprite for husks.
- Characters now have a separate property that defines whether or not they can walk, meaning that characters can now enter the submarine even if they cannot walk. When there is no water, the character will fidget around.
Also fixes Fractal Guardians flying in non-flooded alien ruins.
- Monsters now remember the position of the last target even when idling. The memories fade, however.
- Monsters now flee briefly when being fired at with the turrets. Fixes swarming characters being easy to exploit.
- Don't allow the monsters to retaliate unless they are in the same submarine as the attacker. Removed the CanRetaliate parameter on character AI that was added in the previous update.
- Refactored ConditionalSprite: ConditionalSprite now takes Sprite or DeformableSprite as child elements.
- StatusEffects can now be used to spawn characters.
- Monster missions now support multiple monsters of different species.
- Minor adjustments on eating. Fixes Bonethresher's eating animation.
- Improved the avoid steering logic (used when the character is not using pathfiding, i.e. outside the submarine).
- Charybdis: Increase the damage against structures for all attacks.
- Adjusted Mudraptor, Bonethresher and Tigerthersher behavior. Threshers now hunt in packs.
- Fixed incorrect flipping and mirroring. Disable mirroring on characters that don't need it.
- Fixed Mudraptors preferring doors over humans.
- Fixed targeting at wall center position instead of the section position. Fixes hammerheads and bonethreshers targeting destroyed wall sections.
- Fixed the damage modifiers on hammerheads not working properly.
- Fixed a crash when trying to create a swarm with characters that have no swarming behavior defined.
- Fixed monsters not targeting the closest limb when they should.
- Fixed ai targets not being updated when the character is dead, causing the characters to be too perceivable/not perceivable enough by the monsters.
- Fixed limbs' lightsources not being visible inside the submarine.
- Fixed immobilized characters (e.g. stunned, monsters on dry land) occasionally "hanging" mid-air.
- Fixed draw order issues due to normal sprites and deformable sprites being used on the same characters.

Character editor:
- Added "TailTorqueBoost" parameter that can be used to prevent long and fast-moving characters, like the Tigerthresher, to get tangled around themselves.
- "TailTorque" no longer affects the swimming sine amplitude (how strong the tail moves).
- Sprite orientation no longer affects the damage modifiers.
- Exposed the ragdoll main limb.
- Exposed the damage emitters.
- Exposed the damage sound of damage modifiers.
- The radial widget angles are now rounded to the closest 10.
- Fixed characters being able to collide with the submarine, which often caused large monsters to get stunned and impact sounds to be played when they're spawned.
- Fixed characters moving when they shouldn't.

Bugfixes:
- Rewrote power distribution logic to resolve several issues and oddities in the way power was distributed across electrical grids, particularly when relays were used. The new system is also less performance intensive, so submarines that had performance issues due to large and complex power grids should now run better.
- Fixed inability for mods to override jobs.
- Fixed pumps calculating targetlevel incorrectly when receiving a "set_targetlevel" signal, causing neutral ballast level value in the sub editor to be off.
- Fixed clients being able to join servers when they're using content packages the server doesn't have, which usually causes the client to get disconnected when a round starts.
- Fixed clients being able to join servers after enabling a required content package in the settings, even though they need to restart first (leading to errors when a round starts).
- Fixed "attempted to access a potentially removed character" console errors if a character dies while the client is waiting to apply the character's remote inventory state.
- Fixed broken waypoints in Typhon that prevented bots from opening some of the doors.
- Fixed characters being very hard or impossible to hit with melee weapons when they're lying on the floor.
- Fixed characters placing their feet above a platform when not actually standing on the platform (noticeable in rooms where there's a platform on top of the "actual" floor).
- Fixed husk eggs not causing a husk infection when injected.
- Fixed depth sorting not working on damageable structures.
- Fixed characters stepping on nothing if their feet are below the lowest step of a ladder.
- Fixed door components being selectable when the door is broken, causing characters to drop from ladders if they interact with a door while climbing.
- Alien motion sensors don't react to dead bodies to prevent bodies from blocking the way through the ruins by constantly activating coils.
- Fixes to waypoints and outdated structure sourcerects in Bunyip, Selkie & Venture.
- Put the shotgun shells in Dugong's, Kastrull's and Humpback's armory inside the shotgun.
- Fixed clients retaining their original character when taking control of another one in the multiplayer campaign, but keeping the items of the new character.
- Fixed sourcerects being moved when going through the sprite lists with arrow keys in the sprite editor.
- Fixed servers occasionally appearing in the server list twice.
- Improved color input layout in EntityEditors to prevent overlaps.
- Fixed flares not depleting when in inventory.
- Fixed propeller position becoming unmirrored when saving and reloading a mirrored engine.
- Fixed detection area offset becoming unmirrored when saving and reloading a mirrored motion sensor.
- Fixed a couple of doors and hatches in vanilla subs being repairable with welding tools instead of wrenches.
- Fixed ruins occasionally having rooms too narrow to pass through.
- Fixed door gaps occasionally getting misplaced when placing them in ruins, preventing water from flowing through the room.
- Fixed "picked/selected required" fields disappearing from the item editing panel in the submarine editor if left blank.
- Fixed being able to hit through walls with melee weapons.
- Fixed framerate issues when using passive sonar near large amounts of sound emitters (right outside a submarine for example).
- Fixed empty exploding ammo boxes exploding when deconstructed.
- Fixed old chat messages overlapping in the server lobby after the scrollbar of the chatbox becomes active.
- Fixed textbox selection not being cleared when pressing Ctrl+Z or Ctrl+R, causing a crash if the selection is outside the bounds of the current text and the player attempts to remove text from the box.
- Don't allow reporting things while inside ruins.
- Fixed crashing if a client has written something in the chatbox, gets disconnected and sends the message.
- Fixed servers showing up in the server lobby after the server has been shut down.
- Fixed traitor missions not ending when the traitor dies and the traitor retaining their old mission info in the info menu.
- Fixed dead characters still appearing in the crew list when a client joins mid-round.
- Fixes to decorative sprites: Rotation property is in degrees, fixed offset anim type being used as the rotation anim.

---------------------------------------------------------------------------------------------------------
v0.9.4.0
---------------------------------------------------------------------------------------------------------

Monster additions and changes:
- New character: Bonethresher.
- New character: Golden Hammerhead.
- Completely remade the Tigerthresher (new skin, ragdoll, behavior and attacks).
- Reworked Hammerhead (new ragdoll, adjusted behavior and attacks).
- Adjusted the behavior of most characters.
- Medium sized monsters can now more easily trigger impact effects when ramming the submarine.
- Characters are now allowed to move faster than previously (9 -> 15).
- Changed the mouth position calculations and redefined the values for all monsters that have the eating behavior.
- Removed Moloch Baby (Which was just a test. Molochs will be revisited later).
- Better bend deformations on limbs.
- Better feedback about hit impacts on limbs when the character takes damage.
- AI monsters should hit moving targets more easily.
- Added configurable health regeneration, which is applied when the character is eating a corpse.
- Added configurable affliction reductions (bleeding, burn, damage).
- Added an option for the monsters to ignore retaliation when they are attacked.
- Added an option to target the attack on specific limb types.
- Added an option to continue the movement, "following through" the target after the attack.

Modding improvements:
- Mods can override specific content without having to create a completely new content package. This can
be done by surrounding the element with "<override></override>" (for example, an Item or a Character
config element you want to replace a vanilla Item/Character with). The overrides work based on identifiers;
for instance, if you configure an item with the identifier "wrench" and surround it with the override
tags, it will replace the vanilla wrench.
- Content package load order: the game will first load the core package, then other content in the order
 of selection (proper ui still pending). The load order is saved in the config_player.xml.
- Made AI orders and event manager settings moddable.
- The engine and reactor sound ranges can now be modified in the item XML.
- The husk affliction can now be modified and applied on any character.
- Support for multiple simultaneous husk afflictions based on the same system.
- Support for multiple husk appendages. Made the attachment limb configurable in the affliction definition.
- Additional content package validity checks during startup: make sure all XML files in the package can 
be loaded, and disable the package if they can't. Fixes tons of console errors on startup when a mod with 
invalid XML files is enabled.
- Don't allow publishing workshop items that contain invalid XML files.
- Don't allow selecting invalid content packages in the settings menu.
- Fixed disabled content packages becoming active when they're autoupdated.

Character editor improvements:
- Improved layout, hotkeys, general UI/UX improvements.
- Support for editing the character configuration files including health, ai, inventory, sounds, particles etc.
- Support for limb sounds.
- Support for light sources attached to limbs.
- Support for adding and removing attacks.
- Support for afflictions in attacks.
- Support for damage modifiers in limbs.
- New functionality: creating limbs (without having to operate on duplicates).
- Support for creating humanoids.
- Allow to create new characters based on an existing character (copy character).
- Added a limb specific "sprite orientation" that overrides the universal "spritesheet orientation".
- Option for mirroring limb sprites.
- Option for hiding the limb sprite (invisible limbs).
- Multiple minor additions and changes, like an option to enable lights or to display the damage modifiers
drawn on the character.
- Exposed structure sound types.
- Exposed the mouth position.
- Exposed the angular damping and density for limbs (removed mass, which was not used).
- Added a default texture path for ragdolls so that the texture can only be defined once. Limb specific 
texture definitions override this.
- Allow to define a group for different species. The characters in the same group are friendly to each other.
- DecorativeSprites can now be used on character limbs (like on items).
- Made it easier to adjust the source rect's position with the arrows. Hold CTRL to change the size.
- Fixed a rare case where characters got stunned in the character editor.

Misc improvements:
- New husk faces.
- Increased default VOIP and microphone volume and the maximum values.
- Force a restart when switching the language.
- More detailed "x is not a valid XML file" error messages.
- Improved mission and traitor info popups.
- Show the number of lights (total and shadow-casting) in the sub editor.
- When rewiring, clicking the right mouse button only removes one node from the wire.
- Wire nodes are added by left clicking in the sub editor, and can be laid out horizontally/vertically
by holding shift.
- Improved logging for DXGI_ERROR crashes on startup.
- Made level ambient lighting darker.
- Added "pause" console command (only usable in single player).

Bugfixes:
- Fixed crashing when the recharge speed of a PowerContainer with no interface (e.g. Alien Generator) is 
adjusted by a signal or a bot.
- Fixed docking interface becoming active on navigation terminals when any of the submarine's docking
ports are close to another docking port, even if the terminal in question is not wired to that port.
- Fixed an occasional crash when a bot starts retreating away from an enemy immediately after spawning.
- Fixed clients not creating a download prompt when a sub they don't have is selected by vote.
- Fixed traitor missions almost always placing the mission-related items inside the same containers.
- Fixed traitor goal durations being displayed as "duration(xx) seconds" instead of "xx seconds".
- Fixed Traitor's "find an item" objectives not being considered complete if the target item is inside 
another item within the traitor's inventory.
- Fixed server using the provided campaign savefile name as-is (without the required .save file extension) 
when starting a new campaign through the console. Caused clients to throw "File transfer failed (wrong 
file extension """!)" errors and prevented them from receiving the save files.
- Fixed servers being able to start the round multiple times by spamming the "start" console command 
before loading the round finishes.
- Fixed rewiring sound playing whenever a remote player is using a rewireable device.
- Fixed subinventories not opening when grabbing another character with no items in the corresponding slot.
- Fixed draggable inventories getting stuck to a half-open state if the item is equipped when 
the inventory is opening/closing.
- Fixed light sprites being mirrored when the item is mirrored, even if the mirroring the item's sprite 
had been disabled (e.g. junction boxes).
- Fixed motion sensor detection area not being flipped when the item is mirrored.
- Fixed status monitor not mirroring rooms on the display in mirrored subs.
- Fixed engine propeller position not being flipped when the item is mirrored.
- Fixed diving suits being displayed in an incorrect position when the locker has been flipped on either axis.
- AI characters turn autotemp back on when leaving the reactor.
- Fixed item sprites becoming unmirrored when a damaged sprite is fading in.
- Fixed damaged item sprites that are set to fade in according to the damage always being drawn at full opacity.
- Fixed spectators being distributed into teams in combat missions, potentially leading to imbalanced crew sizes.
- Notify the client using the "togglekarmatestmode" command about the test mode being enabled/disabled.
- Send karma change notifications when karma has changed by 1 unit or more when test mode is enabled, not 
just when an action causes an immediate change of 1 unit or more.
- Fixed adjacent sprites bleeding into the platform and topwindow sprites.
- Fixed autocompleting submarine/shuttle names when using the submarine/shuttle console commands.
- Fixed some items (like sonar beacon) attracting monsters even when they're powered off.
- Fixed inability to open the pause menu if an inventory slot had been highlighted when exiting 
the game screen.
- Fixed welded door sprites "twitching" when the submarine moves.
- Fixed crashing when a character with no hands or arms drops a holdable item.
- Non-humanoids (i.e. monsters controlled by a player) cannot be assigned as traitors.
- Traitor missions are considered unsuccessful if the objectives cannot be completed (for example if the
submarine doesn't have suitable containers to place the traitor items inside).
- Fixed the "Barotrauma" title text staying invisible in the main menu when coming back from the credits.
- Fixed clients not refreshing an item's editing hud when a remote player adjusts the values (i.e. if two 
players had selected the same lamp and one changed the color value, the other client wouldn't see 
the value change in the editing hud).
- Fixed a couple of the additive light sprites being slightly offset from the lamp.
- Clients don't display client-side vitality changes in healthbars until the actual vitality is received 
from the server. Fixes health occasionally dropping and then jumping back up if the client predicts damage 
incorrectly (e.g. if a melee attack hits client-side but doesn't server-side).
- Fixed character syncing being very inaccurate when switching to freecam and spectating a character
far away from other players.
- Fixed oxygen/fuel tanks attached to a tool being rendered behind the character's legs.

---------------------------------------------------------------------------------------------------------
v0.9.3.3
---------------------------------------------------------------------------------------------------------

- Fixed an error when trying to start a multiplayer campaign with voting enabled
- Fixed a character inventory desyncing error in multiplayer that caused random disconnections
- Fixed download prompts for submarines not showing up

---------------------------------------------------------------------------------------------------------
v0.9.3.2
---------------------------------------------------------------------------------------------------------

- Fixed a networking error that prevented clients from selecting the correct submarine in multiplayer if
the settings menu had been toggled open, which caused the client to start the round with an incorrect
submarine and get kicked out from the server due to entity ID mismatch errors.
- Added Japanese translation.
- Added Polish, Spanish and Turkish NPC conversations.
- Improvements to Russian and Spanish translations.

---------------------------------------------------------------------------------------------------------
v0.9.3.1
---------------------------------------------------------------------------------------------------------

- Fixed clients waiting an excessive amount of time before resending network messages the server has not
acknowledged receiving. Caused clients to occasionally enter a state where they can't interact with devices
or pick up items.
- Fixed fonts getting messed up when playing in Simplified Chinese.

---------------------------------------------------------------------------------------------------------
v0.9.3.0
---------------------------------------------------------------------------------------------------------

Traitor improvements:
- Players who haven't been a traitor yet are more likely to get selected as a traitor.
- If both teams have a traitor during a combat mission, traitor win will result in the opposite team's victory.
- Fixed the order of the traitor objective chat messages.
- Fixed flooding the respawn shuttle counting as flooding a part of the submarine when doing the "flood
the submarine" traitor task.

Multiplayer fixes:
- Fixed server not sending a condition update for an item that gets removed when its condition drops to zero.
Caused potassium and magnesium to explode continuously client-side when immersed in water.
- Fixed server list only displaying servers that are located close to the client.
- Fixed server list displaying the selected game mode incorrectly.
- Fixed Chinese server names and descriptions showing up as "?????" in the server list when not playing in Chinese.
- Fixed occasional "error while reading a message from the server" console errors when joining a server.
- Fixed clients occasionally timing out and disconnecting during the loading screens.
- Fixed character name box resetting in the server lobby when another client joins or disconnects.
- Fixed "collection was modified" error when a client who's been given control of a bot tries to use 
the report buttons.
- Fixed server hanging when a client joins if the server has a very large number of submarines installed.
- Fixed a bunch of client-side console commands crashing the game if the client disconnects while a question 
prompt is active and then enters something in the console.
- Fixed full SteamP2P servers not showing up on the server list regardless of the filters.
- Fixed "remove ban" and "range ban" buttons in the server settings menu doing nothing.
- Fixed switches occasionally getting desynced between clients.
- Added a tickbox for selecting/deselecting all permissions to the client management panel.
- Fixed clients with campaign management permissions not seeing the permissions of newly joined clients.
- Fixed statuseffects with a duration not having an effect on karma.
- Causing an "oxygen low" affliction decreases karma (for example when injecting large amounts of fentanyl).
- Fixed scroll values resetting in the multiplayer campaign store menu when purchasing/selling items.

Miscellaneous improvements:
- Attempting to drop an item to an empty inventory slot that's not of the right type (e.g. trying to put 
an extinguisher in the normal inventory slots), automatically moves the item to the correct slot if it's free.
- Made irrelevant items (light components, lamps, small automated pumps, etc) non-interactable in the tutorials.
- The first patient cannot be healed in the doctor tutorial until the "take the patient to the medbay" 
objective has been completed.
- The docking interface does not become active in the captain tutorial when leaving the first outpost.
- Added sounds for rewiring and repairing.

Miscellaneous fixes:
- Fixed skills not having any effect on repair durations.
- Fixed inability to enable content packages created for a version prior to 0.9.2.0 (ones that have the 
content package in the Data/ContentPackages folder instead of in the mod folder).
- Use a welding tool icon to indicate damaged walls in the mechanic tutorial, because the generic repair
icon caused some players to think the wall needs to be repaired with a wrench.
- Minor changes to the instruction texts in the mechanic tutorial.
- Reduced repair durations in the engineer/mechanic tutorials.
- Fixed draggable subinventories staying visible when stunned.
- Fixed light sprites not being scaled in the sub editor when resizing lamps.
- Fixed contained items not changing their position when flipping the container (e.g. oxygen generator 
with some tanks inside).
- Fixed projectiles emitting sparks when they hit a character (not just when they hit a structure).
- Fixed sonar's zoom slider not moving when autodocking zooms in.
- Fixed small creatures being unable to reach waypoints.
- Fixed bots getting stuck while trying to repair items (in practice hatches) while holding ladders.
- Hid SMG rounds and coilgun bolts from the sub editor because they're not usable by themselves, but are 
spawned automatically when the SMG/coilgun is fired.
- Hid the junction box tutorial variant from the sub editor.
- Stun guns and darts can be fabricated and purchased.
- More reliable melee weapon hit detection (for example in the security tutorial it was previously very
difficult to hit the crawler after it falls to the ground).
- Enemies steer back towards the level if they end up outside the boundaries.
- Added confirmation popups when exiting the sub editor or character editor to prevent losing unsaved work.
- Fixed reactor warning lights being clickable and becoming invisible when pressed.
- Fixed CPR button becoming invisible when pressed.
- Fixed water occasionally flowing only through one gap in a hull, for example water only draining 
through a hole at a one side of a room even if there is another hole at the other side of the room. 
- Fixed scrollbars not resizing when filtering lists (e.g. the submarine list in the "new game" menu).
- Fixed being able to fire flamers (and other repair tools) through walls and doors.
- Fixed flamers working underwater when the water is shallow enough for the character to stand.
- Fixed battery recharge rate slider not moving when the recharge rate is set by an incoming signal 
or a remote player.
- Fixed some connection panels being rewireable in vanilla subs when a wire is equipped.
- Fixed some pre-placed body armors and grenades in vanilla subs having an incorrect scale.
- Fixed crashing when a character gains a skill level on a skill that's not initially configured 
for the character class.
- Fixed "Add File" dialog of the Workshop publish screen always using the mod's root folder as the file 
path even if the file is in a subfolder.
- Fixed contentpackage version number not being updated when updating an older workshop item.
- Fixed subinventories closing when items are dropped into or removed from them, which made reloading 
weapons or putting several items into a container cumbersome.

---------------------------------------------------------------------------------------------------------
v0.9.2.2
---------------------------------------------------------------------------------------------------------

Karma improvements:
- Attacking someone who has just recently attacked you doesn't reduce karma.
- The karma penalty from attacking someone scales according to their karma (i.e. smaller penalty for 
attacking a griefer whose karma is low).
- Damaging characters by performing CPR doesn't decrease karma.
- Fixed karma decreasing when moving a wire from a connection to another.
- Reviving characters with CPR increases karma.
- Made the default karma settings a little less strict.
- Fixed clients always getting kicked (never banned) if the "kicks before ban" karma setting is set above 0.
- Players aren't notified about their karma decreasing when it decreases "naturally" towards the neutral
value of 50.

Bugfixes:
- Fixed mechanic tutorial crashing after the welding task when playing in Russian.
- Less restrictive client name symbol constraints. Fixes clients failing to join servers if their name 
contains Chinese symbols for example.
- Fixed inability to enable/update content packages created for a version prior to 0.9.2.0 (ones that have 
the content package in the Data/ContentPackages folder instead of in the mod folder).

---------------------------------------------------------------------------------------------------------
v0.9.2.1
---------------------------------------------------------------------------------------------------------

- Fixed crashing if a traitor client switches to a non-human creature and their original character dies.
- Traitors don't lose karma by damaging structures if their goal is to flood the sub.
- Traitors cannot be assigned to kill themselves.
- Fixed round summary and traitorlist command displaying incorrect traitor mission info.
- Fixed inability to end the round if there's an active traitor mission but no traitors assigned.
- Disabled traitors in campaign mode.
- Fixed server crashing when attempting to greet a traitor with no objective.
- Fixed dead characters being occasionally selected as traitors.
- Fixed info menu still displaying the old traitor objective after a traitor dies and respawns.
- Allow traitors to re-use the sabotage button when someone starts to repair the device without having 
to re-open the interface.
- Fixed grenades exploding multiple times when triggered using a detonator.
- Scaled down alien materials (oxygenite, sulphurite, fulgurium, etc) and fixed their collider sizes.
- Karma doesn't spontaneously decay/increase when dead.
- Increased karma penalties for poisoning someone.
- Option to kick clients with low karma from the server and ban them if they get kicked more than x times.
- Space herpes randomly toggles inverted controls on/off to make it more difficult to bypass the effect 
by modifying keybinds.
- Fixed workshop item preview image not being refreshed in the publish tab when adding a preview image 
to an item that doesn't have one.
- Fixed "error loading submarine" console error when creating a copy of a submarine, deleting the original 
sub and then saving the copy.
- Fixed server logging an "attempted to send a chat message to a null client" error when a client tries 
to send a private message to a non-existent client.
- Enable dynamic range compression and VOIP attenuation by default.
- Fixed inability to extinguish fires through holes in walls.
- Fixed some texts not fitting on the submarine's wall labels in Spanish and Polish.
- Fixed "Broken English" character trait not being translated.
- Fixed missing "undock" text in the navigation terminal interface.
- Fixed some of the items in Berilia and Bunyip being impossible to pick up.
- Fixed crashing when less than 3 arguments are passed to the "color" console command.
- Fixed crashing when attempting to rewire two linked devices at the same time.

---------------------------------------------------------------------------------------------------------
v0.9.2.0
---------------------------------------------------------------------------------------------------------

Easier server hosting:
- Switched to Steam's networking API, which allows clients to connect to servers without the need for the
host to forward their ports.

Expanded traitor feature:
- Multi-step traitor missions that not only make things more interesting to the traitors themselves but 
also to give the rest of the crew a fighting chance of detecting the traitor.

Anti-griefing:
- Karma: a system that detects malicious actions and automatically creates a more challenging experience 
for griefers, or potentially triggers a kickban. The feature is completely optional and the server hosts 
can decide how aggressively it will react to malicious actions. In a nutshell, you can lose karma for doing 
dumb things, karma is regained gradually over time and may be increased more rapidly by doing good things, 
thus negating false positives and also giving you the chance to redeem yourself. Lose too much karma and 
you'll start to experience increasing levels of inconvenience.
- Wire griefing is more difficult: wires have to be disconnected from the connection panels at both ends
before they can be removed. Disconnected wires can be seen visibly hanging from the device, with noticeable
particle effects and sound cues that make it easier to detect and fix wiring problems.
- Added a built-in overheat warning light and siren to reactors and increased the time it takes for the
reactor to catch fire and explode.
- Option to disable friendly fire altogether.

New items and structures:
- Additional weapons: stun gun, SMG, shotgun, grenade launcher, flamer, two new types of coilgun ammunition (piercing & explosive).
- New monster loot: husk stinger, mudraptor shell, crawler mask, moloch shell.
- Fun stuff: accordion, captain's pipe, toy hammer.
- Tons of new decorative submarine pieces for the sub editor.

New submarine:
- Berilia, a submarine for 16 players.

Bugfixes:
- Fixed crashing when selecting doors or gaps in the sub editor.
- Fixed crashing when combining items inside an ItemContainer (e.g. cabinet, deconstructor).
- Fixed shuttles not being able to redock into some submarines with unconventionally positioned docking 
ports. Specifically, if a port needed to be docked to from below but was positioned above the center of
the submarine (or vice versa), the docking interface would not activate on the navigation terminal.
- Fixed docking port using the wrong submarine's position for joint adjustment, causing errors when 
docking a submarine with greater mass to one with a smaller mass.
- Fixed an issue that caused occasional ID mismatch errors if a client died during a multiplayer
campaign round and disconnected before the round ended.
- Fixed item editing panel not appearing in wiring mode when selecting a wire in the sub editor.
- Fixed ability to throw throwable items while unconscious.
- Fixed bots not using fire extinguishers client-side in multiplayer.
- Fixed clients not hearing the sound when someone crowbars a door open.
- Fixed progress bars not showing client-side when cutting/welding doors.
- Fixed inability to combine items in multiplayer.
- Fixed occasional "index out of range" errors when loading walls that have been set to a non-default
scale in the submarine editor.
- Fixed inability to scroll the crew list with the mouse wheel when the cursor is over certain parts 
of the list.
- Fixed sonar pings stopping mid-way when active sonar is turned off, which could be exploited to stop
the pings before they reach a monster further away from the sub.
- Fixed clients not seeing other characters when entering spectator mode after their character has been
eaten by a creature.
- Fixed clients not seeing other characters in spectator mode after the distance between the submarine 
and the client's corpse gets great enough.
- Fixed clients getting stuck to a non-functional game screen if they start a new round before the ending 
cinematic has finished server-side.
- Fixed projectiles hitting a character you're standing next to when firing.
- Fixed characters automatically equipping handcuffs (i.e. handcuffing themselves) if they were picked up
when the only free inventory space was the hand slots.
- Fixed a rare race condition that occasionally caused the game to crash during the loading screen with 
a "no text packs available in English!" error message.
- Fixed husk infection being healable with broad-spectrum antibiotics even when the infection has reached 
the final stage.
- Fixed attachable items (detonators, electrical components) becoming deattachable without any tools 
if the sub is saved after deattaching them.
- Fixed projectile raycasts not taking wall rotation into account, causing the projectiles to hit sloped 
walls when standing next to them.
- Fixed PowerTransfer components checking overloads based on the item the recursive power check starts from, 
not the item that's currently being checked. Caused junction boxes to never break or catch fire in some subs
- Fixed crashing in the character editor when no textures were found for the selected character.
- Fixed crashing if a humanoid character has no knees or ankles.
- Fixed EventManager calculating flooding amount incorrectly, causing floods to only have a very small
effect on the intensity value.
- Fixed batteries and supercapacitors being able to provide power through their signal connections 
(e.g. "set_charge_rate", "charge_rate_out").
- Lighting fix: obstruct background lights behind hulls. Previously the background lights would only get 
obstructed by background structures, causing light to "bleed through" parts with no structures (e.g. 
humpback's docking port) and windows in the background walls.
- Fixed item loading being interrupted if any item XML cannot be loaded, causing some items not to be
loaded if any of the selected content packages are missing files or contain corrupted item XMLs.
- Fixed fire sounds not playing when standing inside a fire source.
- Fixed client names being converted to lower case when comparing them to the name written by the sender, 
preventing the message from being sent if the name wasn't written in lower case.
- Pass private messages to the client hosting the server when the message is targeted to the server.
- Private messages appear in the server log.
- Fixed plasma cutter and welding tool hit particles being offset from the flame.
- Fixed steel bar and titanium-aluminium alloy deconstructing to 100% condition items even when degraded 
(which could be used as an exploit to get infinite coilgun rounds).
- Fixed holdable items staying in the characters hand(s) when swapping them from a hand slot to another 
limb slot (for example, when moving a flashlight from a hand slot to the head slot).
- Fixed text wrapping not working properly with words that are longer than a single line.
- Fixed deconstructor losing some of the material from deconstructed items if the output container couldn't hold all of the new items.
- Fixed discrepancies in door welding & repairing logic regarding collision.
- Fixed a crash when retrieving lobby information with an uninitialized IP.
- Fixed max player count in server list & duplicate lobby entries.
- Fixed arrow keys not changing caret position when typing.
- Fixed doors looking repaired as soon as the condition goes above 0%, even though the collisions aren't 
re-enabled until the door gets above 50%.
- Fixed water not leaking through broken doors.
- Fixed inability to throw items through platforms.

Misc additions and changes:
- Respawn shuttles now spawn inside the level somewhere near the submarine, instead of always spawning
at the beginning of the level.
- Respawn shuttles don't leave and despawn until a new respawn is pending.
- Added "respawnnow" console command which immediately dispatches the respawn shuttle.
- Search for default animation/ragdoll folders from the folder where the character file is located, not
from "Content/Characters". Fixes mods not being able to load animation/ragdoll files if the file paths
are not defined explicitly in the character configuration file.
- Improved performance by deleting dead monsters that are far away from the sub and by disabling physics
on dead bodies when they stay still long enough.
- Added option to use conditionals to activate/deactivate ItemComponents. You can take a look at the 
reactor and junction box config files to see how it's used.
- Added some indicator lights to junction boxes and reactors.
- Stun batons don't affect large enemies (molochs, hammerheads, endworms, etc).
- In wiring mode, items are selected by pressing E instead of clicking. Selecting items with the left
mouse button made it very difficult to manipulate the wires because it was easy to accidentally select
some device instead of a wire node. 
- Crate/toolbox inventories stay open and can be moved across the screen when the item is equipped.
- Added limits to submarine name and description length.
- Delete incomplete file downloads when disconnecting from a server while a file transfer is active.
Prevents console errors about corrupted submarine/save files caused by the partially downloaded files.
- Increased Humpback's battery capacity.
- Added widgets for manipulating coilgun/railgun rotation limits in the sub editor.
- Added a command for setting the value of a property on all selected entities in the sub editor 
(for example, "setentityproperties scale 2" would set the scale of all selected items/structures to 2).
- Show ballast tanks and airlocks in a different color on the status monitor to make it easier to 
distinguish which rooms are actually flooding and which are supposed to have water in them.
- Option to define multiple inventory variants for a character (e.g. to add variation to monster loot).
- Start playing the main menu music during the loading screen.
- More reliable human walk sounds (played at specific points of the walk cycle instead of relying on 
impacts between the feet and the floor).
- Option to show a 16x16 grid and snap the cursor to it in the sprite editor.
- Reactor can be controlled with movement keys.
- Option to add a probability for afflictions applied by an attack.
- Husk attacks have a 50% chance of causing a husk infection.
- Decreased minimum item scale from 0.1 to 0.01.
- The amount of materials received from deconstructing fuel rods depends on the condition of the fuel rod.
- Reactors keep sending the temperature_out signal after a meltdown.
- Improved file transfer

---------------------------------------------------------------------------------------------------------
v0.9.1.0
---------------------------------------------------------------------------------------------------------

Additions and changes:
- Disabled riot shields for now (too much griefing potential).
- Toolboxes can be fabricated and decontructed.
- Nerfed nitroglycerin's structure damage and increased the impact tolerance from 4 to 6.
- Made alien pistols a little less underwhelming (sounds, recoil, particle effects).
- Deconstructors drop all items that are inside the deconstructed item. Previously they would just get destroyed, 
making it a potential exploit to destroy items that should not be possible to deconstruct.
- Modified welding fuel tank and oxygen tank sprites a bit to differentiate them from each other a bit more.
- Modified plasma cutter and welding tool sprites a bit to differentiate them from each other a bit more.
- Diving suits play the warning beep when there's no tank in the suit (not just when the tank is running out).
- Server list can be sorted according to ping, name, compatibility or any of the other property in the list.
- Docking ports of the enemy submarine are not shown on the sonar during combat missions.
- Recharge headset batteries between rounds in single player.
- Disable status monitor displays when out of power. 
- Reduce server CPU usage.
- Update ladder and gap references if a waypoint is moved around in the editor.
- More descriptive error messages when publishing a Workshop item fails.
- Allow selecting multiple files at once when adding files to a Workshop item.
- Made the autogenerated submarine preview pictures larger.
- The "Host server" menu remembers the previously used port numbers and the player count.
- Restrict server names to a maximum of 60 characters.
- Items now collide with platforms.
- The game automatically opens the generated crash report when it crashes.
- Added "setmaxplayers" command to the dedicated server.
- Clients can change the server password using the command "setpassword" if they have a permission from the host.
- Reduced the range of the sonar ping sound and added a more subtle ping sound that can be heard further away.
- Watchmen now hold position when attacked.
- Added a subtle glow to alien buttons to make them a bit more noticeable.
- Items that are set to be hidden in-game can still be interacted with in the sub editor.
- EXPERIMENTAL: option to disable rewiring items in multiplayer. At the moment the setting can only be
changed by editing a parameter called "allowrewiring" in serversettings.xml.

Misc bugfixes:
- Fixed the position of an outpost's docking port not being taken into account when determining how to 
place it in the level. Caused large submarines sometimes to collide with walls when docked to outposts 
where the port is offset from the center.
- Fixed corrupted sub files causing crashes.
- Fixed item editing HUD not appearing on any other item after one item has been selected in-game 
(e.g. editing the channel on a wifi component prevented editing other items).
- Fixed ladders and other resizeable items reverting to their original size if they're resized and 
the sub is saved and reloaded.
- Fixed inability to resize gaps in the sub editor after they've been placed.
- Reactors take other power sources into account when calculating how much power they need to generate. 
Fixes overloads on Humpback when turning on the backup batteries and operating the reactor normally.
- Fixed watchmen not retaliating when a character does very small amounts of damage to them.
- Fixed bots being able to take handcuffs off from themselves.
- Fixed waypoint and spawnpoints being selectable in the sub editor even if they're hidden.
- Fixed deconstructing coilgun ammo boxes giving out more materials than the materials required to fabricate them.
- Scrollbars can only be dragged if the mouse button is pressed down while the cursor is on the scrollbar,
not by holding the button and moving it on the scrollbar. Fixes accidentally switching from slider 
to another (often happens in the reactor interface).
- Fixed crashing when setting limb or joint scale to 0 using console commands.
- Fixed dropdowns in the Workshop item publish menu being draw behind the buttons below them.
- Fixes bots being unable to exit ladders if some part of their body is below the platform.
- Ignore keyboard inputs (delete, arrow keys, copy/paste) in the sub editor when a textbox is selected.
Prevents accidentally deleting items/structures when attempting to delete text from a textbox.
- Toolboxes can't be put inside other toolboxes or in the doctor's clothes.
- Fixed items bought from the store during a singleplayer campaign session being deducted from the credits 
when save & quitting from the map.
- Flares stop emitting particles when inside an inventory.
- Fixed oxygen not flowing through horizontal gaps between subs (e.g. between Remora and the drone).
- Decreased the size of the mountain in the RidgeBasic level type to prevent it from blocking the main path.
- Fixed too small collider sizes on a bunch of crafting materials.
- Fixed order options ("hold fire"/"fire at will" etc) being displayed in one button instead of
being split into separate buttons when playing the game in Chinese.
- Fixed "Text Self_CauseOfDeathDescription.Unknown not found" console error if a character gets killed
by being inside a respawn shuttle when it despawns.
- Fixed sonar not scaling properly when resolution is changed mid-round.
- Fixed fabricators & deconstructors displaying the "insufficient power" warning when power is low 
(but still high enough for the devices to run).

Networking fixes:
- Fixed another ID mismatch problem that occasionally caused clients to get kicked out in multiplayer, 
usually with an error message warning about a missing item.
- Fixed players always getting range banned when banned by a client.
- Fixed turrets not being aimed correctly in multiplayer if they're in another sub (e.g. the coilgun in 
Remora's drone).
- More reliable fabricator and deconstructor syncing. Should fix items disappearing when multiple players
attempt to use the device at the same time and strange timing inconsistencies when deconstructing
multiple items in succession.
- Fixed all servers showing "unknown" as the game mode in the server list. 
- Fixed server not allowing forward slashes in host messages.
- Fixed repair interface sometimes getting stuck close to 100% in multiplayer.

Character editor fixes and improvements:
- Nicer layout, made the panels hideable.
- Added buttons for creating joints, duplicating limbs, and deleting limbs/joints.
- A dropdown for selecting which content package to add the character to.
- Allow creating a new content package during character creation.
- Added hotkeys 1, 2, 3 for limb, joint, and animation modes respectively.
- Change the logic of deciding on which parameters are shown and when. In the ragdoll mode you can now 
see the ragdoll, but also scale it and see the main parameters. Source rects are now longer shown on the 
sprite sheet if limbs mode is disabled.
- Automatically select edit limbs mode when a new character is created.
- Option to create multiple limbs in the character creation wizard.
- Disallow deleting the main limb because it often causes crashes.
- Only allow selecting PNG files as the texture.
- The spritesheet is shown by default.
- Fixed deleted joints not being saved properly.
- Only lock the axis for torso/head position when alt is down.
- Disable test pose if the character is not a humanoid. 
- Clamp camera offset so that the character is always at least partially visible.

---------------------------------------------------------------------------------------------------------
v0.9.0.7
---------------------------------------------------------------------------------------------------------

Changes:
- Made husks more common.

Multiplayer fixes:
- Fixed an ID mismatch problem that occasionally caused clients to get kicked out in the multiplayer 
campaign, usually with an error message warning about a missing item.
- Fixed servers using a local campaign save path sent by the client setupping the campaign, preventing
the campaign from starting up if the path does not exist at the server's end.
- Fixed radio communication occasionally not working between characters in the multiplayer campaign. Characters 
that had made it through at least one round were not able to communicate through radio with characters that 
have just been spawned for the first time.
- Kick votes persist during a multiplayer session even if the client disconnects (= disconnecting and rejoining 
just before you get kicked doesn't work anymore).
- The server sends a "this client previously used the name xxx" message when a client rejoins with a different name.
- Fixed GameServer.UnbanPlayer passing the name to BanList in lower case even though BanList was case 
sensitive (preventing unbanning clients with the "unban" command if their name is not in lower case).
- Fixed server not saving the whitelist when it's enabled/disabled, causing the setting to revert when 
relaunching the server.
- Fixed structure texture scale and texture offset now being reverting to default values when the 
submarine is saved by the server, causing them to reset between campaign rounds.
- Fixed client always launching the default "DedicatedServer.exe" even if using a content package that 
should replace the server exe.
- Servers only report content packages with files that cause multiplayer incompatibility to the master server. 
Fixes servers showing up as incompatible in the server list if they have custom sub files (or other types 
of files that don't cause compatibility issues) installed.
- Fixed crashing when clients attempted to kick/ban players through the in-game info menu when a round
was running.
- Fixed client that's hosting a server not being taken into account in the player count visible on the server list.
- Fixed server list not displaying non-English symbols correctly (e.g. Cyrillic or Chinese characters).

Misc fixes:
- Replaced WinForms with SDL which should resolve most of the fullscreen/resolution issues. It's also now
possible to change the resolution when in fullscreen without having to restart the game.
- Fixes to the DXGI crashes during startup.
- Fixed Character.GetConfigFile searching for the character file from all available content packages, not 
just the ones that are currently selected. Caused modded character files to affect the game even when 
the mod was not enabled, leading to various issues such as characters failing to equip items if the mod
changes the number or type of inventory slots a character has.
- Fixed a bug in monster/item spawnpoint logic that occasionally caused perfectly valid spawnpoints to be 
discarded when there were floating ice chunks in the level, sometimes causing monsters to spawn very
far from the submarine (which often lead to the player not running into them at all).
- Fixed bots not being able to retaliate when attacked with a repair tool.
- Fixed crashing when firing a revolver in the sub editor.
- Fixed items applying their status effects twice if they're put into a container by swapping them with
another item. For example, replacing a fuel rod in the reactor by dropping a new fuel rod on it caused
the reactor behave as if it had two rods in it.
- Switches send out a continuous 0/1 signal that can be flipped by interacting with the switch (as opposed 
to working like buttons which send out a pulse when interacted with).
- Fixed an issue that occasionally caused the main menu to look distorted when launching the game on Mac.
- Fixed crash after opening the file browser from the Workshop menu more than once on Linux.
- Fixed combat mission achievements being impossible to unlock.
- Fixed item scales not being saved when the scale is modified in the sub editor.
- Fixed incorrect physicorium shell description.
- Fixed server list & workshop menu not resizing properly when changing resolution.
- Fixed player input being used to determine whether a character should be holding on to ladders, causing 
AI characters to let go of ladders when holding RMB.
- Fixed explosion damage bypassing armor (both creature shells and wearable items).
- Fixed OverrideSaveFolder and OverrideMultiplayerSaveFolder settings not being saved.
- Fixed order/rept icons "twitching" when the sub moves. or
- Fixed players being able to repair submerged electrical items indefinitely. 
- Fixed a "attempted to access a removed ragdoll" console error when a character wearing the health 
scanner HUD is removed.
- Fixed console errors when a battery's or supercapacitor's capacity is set to 0 and the interface is open.
- Fixed ability to drop items into secure lockers (or other containers that require specific items)
without having access to it.
- Automatically move the gaps linked to doors when the door is moved (and vice versa).
- Fixed items disappearing when they're dropped into a full container.
- Fixed crashing when an item that requires aim to use is used by something else than a character 
(e.g. a status effect).
- Fixed having a broken device on a sub in the sub editor and switching to Character Mode causing a crash.
- Fixed the bottom of the background ice texture not rendering correctly on high resolutions.

---------------------------------------------------------------------------------------------------------
v0.9.0.6
---------------------------------------------------------------------------------------------------------

- Fixed clients failing to connect to servers that have banned clients based on their Steam ID.
- Removed Berilia (vanilla sub that's not ready for release).

---------------------------------------------------------------------------------------------------------
v0.9.0.5
---------------------------------------------------------------------------------------------------------

Additions and changes:
- Automatically fill the client name textbox with the player's Steam username.
- Allow clients (including the host) to change their name in the server lobby.
- Censor password boxes to make joining servers a little more streamer-friendly.
- Show the name of the server in the "connecting to..." popup instead of the IP address.
- Added a close button to the debug console and a text that explains it can be opened/closed by pressing F3.
- Electrical components are attached to walls with the left mouse button instead of E.
- Flares are activated with the left mouse button instead of E.
- Nerfed plasma cutters and welding tools.
- Made coilgun ammunition boxes deconstructable.
- Removed minimum job count requirement from Captain, Engineer & Mechanic (i.e. it's not possible to play
other jobs even when there's 3 or less players on the server).
- Increased default respawn transport time to 5 minutes, decreased respawn interval to 3 minutes.
- Allow muting players mid-round through the info menu.
- Allow to edit the door opening/closing speeds and increase the defaults.
- Reduce the follow-up distance and require the bot to be in the same room than the player before stopping, 
so that bots with a follow order don't stay on the doorways when the player is trying to enter the airlocks.
- Stop "breathing" deformations when the character is dead.
- Disable obstructed paths when the submarine docks to another submarine/outpost.
- The location of save files can be changed in config_player.xml using the attributes "overridesavefolder" 
and "overridemultiplayersavefolder".

Bugfixes:
- Fixed crashing during startup due to faulty OpenAL installations.
- Fixed inability to select the voice capture device if the name of the device contains non-latin symbols
(Cyrillic or Chinese characters for example).
- Fixed a networking issue that occasionally caused clients to get kicked with a "disconnected due to 
excessive desync" error message.
- Fixed fires being very hard to put out completely in multiplayer.
- Fixed items not being repaired after purchasing repairs in the campaign.
- Removed outdated Launch_BarotraumaServer script from the Linux version (does not work anymore, the 
dedicated server should be launched by running the file called "DedicatedServer").
- Fixed server owners not being able to join their own server if whitelist is enabled and the owner is not
on the whitelist.
- Fixed inability to ban clients by their Steam ID using the console.
- Fixed all servers showing up as "Round has not started" in the server list.
- Fixed server ignoring the max players value set in the "host server" menu and using the setting 
configured in "serversettings.xml" instead.
- Fixed spectators not hearing the living players' voice chat.
- VOIP improvements (less crackling and pops).
- Increased oxygen output in vanilla submarines to prevent characters from suffocating when playing with
an oversized crew.
- Fixed occasional console errors when ending a round (causing the round end summary not to appear).
- Waypoint fixes in vanilla subs.
- Disallow shooting and attacking when the cursor is over a UI element (to prevent, for example, 
accidentally firing a gun when dismissing a message box).
- Fixed "file not found" errors on Linux when attempting to enable a mod that defines file paths
using a backslash instead of a slash.
- Fixed monsters ignoring decoys.
- Fixed store menu switching back to the equipment category every time something is bought/sold in 
the multiplayer campaign.
- Fixed "push to talk" field going outside the audio settings menu on some aspect ratios.
- Fixed long server names overflowing in the server list menu.
- Fixed the character saying "OrderDialogSelf.dismissed" when a player removes an order from themselves.
- Fixed subinventory slots going outside the screen when for example grabbing someone with a toolbox 
in the leftmost inventory slot.
- Fixed monsters sometimes spawning inside the floating ice chunks within the levels.
- Fixed physicorium shells not being containable in railgun shell racks.
- Fixed physicorium ammo box not being containable in coilgun ammunition shelves.
- Fixed inability to spawn items in characters' inventories with the "spawnitem" console command.
- Fixed health interface not focusing to the most damaged limb when closing and reopening the interface.
- Prevent welding doors shut during the tutorials (as the player doesn't have access to any tools to 
reopen the door).
- Fixed AI pathfinding when the path is from a submarine to another submarine.
- Fixed crashing when AI crew tries to find a path out of the ruins.
- Fixed Watchmen looking at the wrong direction.
- Fixed crashing due to an invalid display resolution.
- Fixed alien item assemblies not being hidden from the sub editor.

---------------------------------------------------------------------------------------------------------
v0.9.0.4
---------------------------------------------------------------------------------------------------------

- Fixed "Steam authentication failed" errors when trying to reconnect to a server after cancelling the
connection.
- Fixed clients occasionally failing to spawn items when playing using a different language than the server,
which caused them to get kicked.
- Fixed extra cargo failing to spawn in multiplayer when playing using a different language than the server. 
- Fixed legacy items failing to load if a sub is saved with a language other than English and the language 
then changed to something else.
- Fixed excessively small password input box when connecting to servers.
- Fixed a bug that occasionally caused items to drop from the inventory when moving items between 
inventory slots in the multiplayer.
- Prevent junction boxes from getting damaged due to overvoltage in the engineering tutorial.
- Fixed structures getting scaled incorrectly when cloning a structure with a non-default scale in the 
submarine editor.
- Fixed occasional crashes when leaving a multiplayer session while the "cinematic" at the end of the round
is still playing.
- Fixed items not being moved to the humanhusk's inventory when a huskified player dies (= clothes and
other gear seemed to magically disappear when the character "resurrected" as an AI husk).
- Fixed clients not seeing turrets rotating at their end when another client is operating the turret.
- Fixed hitscan projectiles (revolver rounds) going through walls if the weapon is fired while its 
barrel is partially inside the wall.
- Fixed welding tools being able to weld doors and burn characters through walls.
- Fixed bots reporting leaks when there are holes in the interior walls.
- Fixes to the colliders of some of the shuttle wall pieces.
- Fixed Linux version crashing when attempting to browse for files in the Steam Workshop menu.
- Fixed credits not resizing when resolution is changed.
- Added an upper limit to impact damage done to ragdolls, preventing characters from getting instakilled if
a Moloch or another large monster smashes against the sub hard enough.

---------------------------------------------------------------------------------------------------------
v0.9.0.3
---------------------------------------------------------------------------------------------------------

- Fixed captain tutorial not continuing after the part where the mechanic has to be ordered to do repairs.
- Fixed mechanic tutorial getting stuck if repairing the devices is interrupted before they're fully repaired.
- Fixed Workshop item preview images not working on Mac or Linux.
- Fixed "Add file" and "Browse preview image" file dialogs crashing some Mac/Linux systems.
- Unlock tutorials one by one.
- Fixed crashing when clicking on the "no matching servers found" message in the server list.
- Fixed loading screen being dismissable when the window is not active.
- Fixed connection panel overlay overlapping with the connections on resolutions higher than 1080p.
- Fixed incorrect "mission completed" text in the combat missions.
- Fixed "a swarm of [monster]" description in the crawler swarm mission.

---------------------------------------------------------------------------------------------------------
v0.9.0.2
---------------------------------------------------------------------------------------------------------

- Automatically set the keybinds to AZERTY when French is selected as the display language.
- More readable font and a fix to some texts appearing slightly "clipped".
- Additions to the credits.
- Minor tweaks to subs and shuttles.
- Added propeller damage to the shuttle engine.
- Increased maximum voice chat volume.
- Directional voice chat is enabled by default.
- Display the language names in the respective languages in the initial language selection screen.
- Playing the splash screens or tutorial videos doesn't require libvlc and libvlccore to be installed
on the user's system in the Linux version anymore.

Bugfixes: 
- Fixed a bug that caused frequent desync kicks when playing a multiplayer monster mission.
- Fixed private servers showing up in the server list.
- Fixed an index out of range error in DoctorTutorial if proceeding too fast to the submarine.
- Fixed report messages not going through to some clients when there are multiple clients on the server.
- Fixed players not seeing reports made by bots in multiplayer.
- Fixes to missing translations and UI layout problems when using languages other than English.
- Miscellaneous crew AI fixes and improvements.
- Fixed find safety AI objective not working properly.
- Fixed bots loading only half of the target items in the contain item objective.
- Fixed directional sonar indicators not being displayed on the sonar monitor.
- Fixed floating ice chunks occasionally spawning too close to the start of a level, causing them to clip
through the submarin and/or the outpost.
- Fixed incorrect reward amount in the "Chemical shipment" description.
- Fixed inability to use the underwater scooters with LMB.
- Fixes to UI layouts on 4K resolution.
- Fixed unnecessary silence at the end of the "Objective Complete" music track.
- Fixed ruin walls being almost impossible to cut from inside the ruins.
- Fixed the "report leaks" button being highlighted inside ruins.
- Fixes to wall colliders.
- Fixed "Pause on focus lost" setting being always treated as if being enabled.
- Fixed dedicated server overwriting existing crash reports.
- Fixed save time being displayed in UNIX time in the right-hand panel in the campaign setup UI.
- Fixed "Praise the Honkmother" and "Extravehicular activity" achievements not unlocking in multiplayer.
- Fixed "No fun allowed" achievement being possible to unlock by committing suicide while wearing a clown costume.

---------------------------------------------------------------------------------------------------------
v0.9.0.1
---------------------------------------------------------------------------------------------------------

- Added a bunch of missing translations.
- Fixed Steam Workshop on Mac.
- Fixed docking interface button not working in the multiplayer.
- Fixed medical doctor tutorial crashing on languages other than English.
- Fixed a bug that caused AI characters to occasionally get stuck next to stairways.
- Fixed animation and ragdoll file paths getting messed up if there are multiple content packages 
installed that include monsters with the same name.
- Fixed crashing when a StatusEffect causes an item to be used on a target. 
- Fixed a gap between Remora and the drone.
- Added more supplies to Remora.
- Fixed watchman's dialogue getting muffled.

---------------------------------------------------------------------------------------------------------
v0.9.0.0
---------------------------------------------------------------------------------------------------------

Additions and changes:
- Translations to German, Russian, French, Brazilian Portuguese, Traditional Chinese and Simplified Chinese.
- Numerous fixes and improvements to the crew AI. The biggest change is that the AI characters can now do
tasks by themselves even when they haven't been assigned an order.
- One new outpost.
- New docking system.
- New logo and main menu art.
- Added a credits tab to the main menu.
- Some new item and structure sprites.
- Some new environment sprites.
- Increased the amount of credits the player starts with in the campaign.
- Balanced location and mission distribution.
- Balanced mission rewards.
- AI characters can be ordered to fight intruders.
- Lock the inventory when aiming with a railgun or a coilgun.
- Swap the order of the starting location & destination in nav terminals when playing in a mirrored sub.
- Option to automatically pause the game when the window loses focus.

Bugfixes:
- Fixed splash screens and tutorial videos crashing the Linux version.
- Fixed damaged item sprites not updating client-side after being repaired.
- Fixed characters occasionally taking impact damage when hitting walls while climbing.
- Fixes crashing when attempting to use symbols such as <, > or | in the save file name.
- UI layout/scale fixes on resolutions larger than 1080p.
- Fixed crashing when loading the same sub twice in the sub editor.
- Fixed submarines occasionally being rendered at an incorrect position when viewing them in the sub editor 
after they've been used in-game.
- Improved the syncing of ragdolled characters.
- Fixed characters not receiving impact damage when ragdolled.
- Fixed characters' arms occasionally spinning around when standing still.
- Fixed tutorial level generation parameters being used in some normal campaign levels (leading to extremely
small levels and submarines overlapping with the outposts).
- Fixed characters running more slowly when their torso is in a different hull than the feet (for example 
in Humpback's bilge). 
- Fixed character's feet getting stuck to platforms when climbing ladders while holding A/D.
- Fixed monsters being able to drag characters through walls.
- Fixed items "vanishing" if they move directly from sub to another without going outside first.
- Fixed content package hash calculation failing if the package is not enabled and contains new monster files.
- Fixed inability to enable content packages if some of the files included in the package are already in 
the game folder (which may happen, for example, if enabling a content package fails).
- Fixed AllowRagdollButton settings not being synced with clients, leading to strange ragdolling behavior
client-side if the server has disabled ragdolling.
- Fixed incorrect keybinds being displayed in a couple of tutorial texts.

---------------------------------------------------------------------------------------------------------
v0.8.10.0
---------------------------------------------------------------------------------------------------------

Additions and changes:
- Completely remade tutorials (separate tutorial for each job).
- Added a door and hatch variants with integrated buttons.
- New outpost graphics.
- Added swarm behavior to crawlers.
- Added a new mission where you have to kill a swarm of crawlers.
- Numerous crew AI improvements.
- Balanced item deterioration values.
- Mineral sprites change when collected from the environment.
- Added an option to disable directional voice chat.
- Added automatic submarine repair option to the campaign.
- Added "all" tab to the entity list in the submarine editor.
- Hide the crew area, chat box and server buttons when operating a turret or searchlight.
- Doors can be repaired with a wrench.
- Some new lamp variants.
- Display a progress bar when welding doors shut.
- Items that don't give any materials when deconstructed cannot be deconstructed.
- Added a console command that resets selected items and structures to prefab values ("resetselected").
- Option to toggle structure drop shadows and edit the position of the shadow in the sub editor.
- Minor physics optimizations.
- Disable background music & ambience in the character editor.
- More pronounced limping animation when a character's legs are injured.
- The inventory slots next to the character portrait (ID card, uniform, etc) can be hidden.
- Some new sound effects and background music.
- All walls can be scaled in the submarine editor.
- Structure damage is visualized when using debugdraw.
- Improved font scaling on different resolutions.
- Added Steam overlay support to Workshop.
- Server list shows which servers have voice chat enabled.
- Show a message box notifying respawning traitors that they're no longer a traitor.
- Added a search bar to the store menu.
- Added search bars to sub lists in campaign setup UI and sub editor.

Bugfixes:
- Don't allow rewiring and deattaching an item at the same time (happened when interacting with an item
while holding both a screwdriver and a wrench).
- Fixed bots being unable to complete almost any task in the multiplayer due to a bug that caused
them to interpret the sub as another crew's submarine.
- When spawning multiple monsters at the same time, spread them around a bit to prevent the players
from getting attacked by a ball of overlapping crawlers.
- Fixed huge lag spikes when a character tries to escape from an enemy but can't find a path away from it.
- Fixed file transfer progress bars not being visible in the server lobby.
- Fixed crashing when attempting to start a mission round with mission type set to None.
- Fixed ElectricalDischarger electricity effect staying visible if the item breaks or the component 
is deactivated from outside (e.g. via a StatusEffect or the parent component).
- Fixed specular maps being rendered on top of characters when outside the sub.
- Fixed excessively bright lights around sonar flora and lava vents.
- Fixes to item collider sizes.
- Fixed inability to scroll through long texts in the sub editor's textboxes.
- Fixed clients not being able to see other characters in spectator if they've died far away from the sub.
- Fixed non-latin characters not being displayed correctly in Workshop item texts.
- Don't prevent selecting items in the sub editor when the cursor is on a wire node, because it makes it 
very difficult (or impossible) to select small items in the wiring mode.
- Fixed crashing when attempting to use the "spawnitem" command when a round is not running.

---------------------------------------------------------------------------------------------------------
v0.8.9.10
---------------------------------------------------------------------------------------------------------

Additions and changes:
- Added collision sounds to items (e.g. when dropping or throwing items on the floor).
- Devices that are not currently being used never deteriorate spontaneously.
- Added a new submarine, "Berilia".
- Minor improvements to menu layouts.
- Randomize map seed when opening the "new game" tab.
- Show the "starting a round" popup to all clients when the server initiates a new round.
- The CustomInterface ItemComponent can be used to trigger StatusEffects. Buttons apply OnUse effects when
pressed, tickboxes apply OnUse when checked and OnSecondaryUse when not.
- StatusEffects can modify item sound and sight ranges (requires an AITarget).
- Sonar beacons can be toggled on/off.

Bugfixes:
- Fixed submarines not being able to move horizontally in multiplayer if not accelerating fast enough.
- Fixed an inventory syncing issue that occasionally caused items to be dropped when moving them from the
inventory to a container or vice versa.
- Fixed items occasionally dropping from the inventory at a very high speed, sometimes causing them to
clip through floors.
- Fixed idling AI characters causing lag spikes if they can't find a path out of the room they're inside or
if the submarine has no waypoints.
- Fixes to AI characters getting stuck if they fail to reach a leak they're trying to repair.
- Fixed characters "selecting" equipped railgun shells and depth charges, causing the characters to face
towards the item.
- Prevent AI characters from jumping down from high places.
- Fixed highlighted items being selected when letting go of the Shoot button.
- Fixed inputs still working in multiplayer when the pause menu or the settings menu is open.
- Fixed some Steam achievements being impossible to unlock in single player.
- Fixed "Poisoner" Steam achievement being impossible to unlock.
- Fixed crashing when enabling game mode voting in multiplayer.
- Fixed voice chat volume not being applied on startup (i.e. the default volume was always used until you
went back to the settings menu to change it).
- Fixed power not working correctly in some grids with chained relays and junction boxes.
- Fixed crashing when attempting to publish a sub with a preview image larger than 1MB on the Steam Workshop.
- Don't allow overwriting vanilla submarines/characters even if the vanilla content package is not selected.
- Don't allow deleting vanilla subs or subs that are a part of some content package through the sub editor.

---------------------------------------------------------------------------------------------------------
v0.8.9.9
---------------------------------------------------------------------------------------------------------

Additions and changes:
- New control scheme: items are selected by left clicking, deselected with right click or esc, and held
items are used on devices by pressing E (e.g. when rewiring with a screwdriver or repairing something 
with a wrench). The new controls are somewhat experimental; the intention is to make them more intuitive
to new players. You can still switch back to the legacy control scheme from the game settings.
- Set default radio chat keybind to R and creature attack keybind to Mouse3.
- MODDERS, PLEASE NOTE: Moved crafting recipes from the fabricator xml to the xmls of the items. Makes it 
possible for modders to add new craftable items without having to modify the fabricators. 
- Some menu layout improvements.
- Camera movement is disabled completely when an item interface is open (not just when the cursor is on 
the interface).
- Option to disable the camera pan/zoom effects from the game settings.
- Option to set a custom preview image for subs.
- Allow aiming on ladders when not moving.
- Characters play Entrance of the Gladiators on the guitar when wearing a clown mask.
- Display a warning on the status monitor when docked to an outpost ("Docked to X, undock before attempting 
to maneuver the submarine").
- Improvements to the line of sight effect. Prevents ugly-looking artifacts in spots where two wall pieces
meet.
- The server gives the "None" permissions to new clients, allowing server hosts to automatically give 
specific permissions to all clients.
- Increased submarine masses to make it less easy for characters to push them around.
- Ping direction is shown on the sonar display when adjusting the direction slider even if directional ping 
is not enabled.
- Tweaked charybdis' AI, attacks and animations.
- Nuclear explosions cause radiation sickness.
- Reduced structure damage done by reactor explosions.
- Higher-resolution submarine preview images.
- Added a notification that tells where cargo spawns at the start of a round.
- Let the camera zoom out further when controlling a large monster.
- Added a longer delay to getting killed by pressure (5 seconds in max pressure).
- Made the pressure-zoom-in effect appear as soon as the pressure in a room starts to rise.
- Added blood particle effects when under high pressure.
- Some optimization to reduce loading times.
- Added a search bar to fabricators.
- Increased the range of docking port sounds and added a subtle camera shake when locking the ports to make 
it more noticeable when a sub docks.
- Made all new medical items fabricable.
- Automatically put the currently equipped item in the inventory (no matter if it's one or two handed) when 
picking up items that require two hands. 
- Job preferences can be edited mid-round in the info menu.
- Slightly reduced the amount of oxygen characters consume from hulls.
- Enemies don't attack outposts or targets inside it anymore.

Multiplayer fixes:
- Fixed characters retaining the last known inputs when a client disconnects, causing the character to
keep welding, honking a bike horn or whatever else they were doing until the server kills the character.
- More reliable throw StatusEffect (= grenade explosion) syncing. Fixes clients not seeing explosions
at their end.
- More reliable item wall attaching syncing. 
- Servers don't attempt to send position updates for items that have no enabled physics body (e.g. attached 
items). Fixes "received a position update for an item with no physics body" console errors when attaching
items to walls.
- Fixed spectate button staying visible when a round ends while a client is in the lobby.
- Fixed remote characters sliding slowly to the left client-side when standing in place.
- Fixed server creating "attempted to create a network event for an item that hasn't been fully initialized 
yet" console errors when spawning LightComponents mid-round.
- Fixes monsters flipping around way too often client-side (especially when inside the sub).

Bugfixes:
- Fixed wire connections that have been done mid-round not working properly. 
- Fixed crashing when attempting to speak as a monster in single player.
- Fixed linked subs not getting docked correctly when loading a saved game.
- Fixed turrets not working if they're placed inside the submarine.
- Fixed calyxanide not being usable in syringe guns.
- Explosive harpoons disappear after exploding.
- Emptying the "required items" field of an item in the sub editor now removes the item requirements (instead 
of using the default ones).
- Fixed crashing if a fabricator finishes creating an item after the user has been removed (e.g. eaten).
- Fixed crashing if none of the selected content packages contain location portraits suitable for the main menu.
- Fixed projectiles not applying status effects on impact if they have no attack defined.
- Fixed thorium rods not being usable in the reactor.
- Conditionals return a match when checking status tag inequality and the target has no status tags (e.g. 
checking if a character doesn't have a StatusEffect with a "poison" tag returns true even if the character 
has no active StatusEffects).
- Fixed severed limbs occasionally noclipping into the submarine.
- Fixed large engine emitting smoke before it becomes repairable.

---------------------------------------------------------------------------------------------------------
v0.8.9.8
---------------------------------------------------------------------------------------------------------

Additions and changes:
- Improved tutorial - better videos, instructional texts, objective list that suggest what you should do 
next, option to rewatch the videos and re-read the instructions.
- Overhauled charybdis (still a work in progress though).
- Automatically grab adjacent ladders when the top/bottom of the current ladder is reached. Makes moving 
through docking ports a little less confusing. 
- Option to configure when afflictions become visible with the health scanner by adding 
a "ShowInHealthScannerThreshold" attribute to the affliction.
- Added labels next to periscopes in Humpback and Dugong.
- Modified Humpback's bilge to make it easier for AI characters to fix.
- Enemies can now navigate out from the sub when escaping.
- Bunch of tweaks to monster AIs (targeting priorities, attack cooldowns, etc).
- Made InventoryIconColor and ContainerColor properties saveable.
- Removed descriptive name from alien artifacts (so be extra careful when bringing them on board).
- Allow panning the campaign map with WASD.
- Allow editing selected wires in wiring mode (so it's possible to, for example, modify the colors of
the wires without having to disconnect them).
- Decreased structure damage done by frag grenades and made them disappear after they've exploded.
- Batteries output charge values as integers.
- Made damaged junction boxes less sensitive to overvoltage. Nearly broken junction boxes were barely able 
to handle any overvoltage, leading to chain reaction where one junction box breaking causes the grid to be 
overloaded, and the rest of the boxes start taking damage at an increasing speed.
- Reactors don't cool down when underwater anymore.
- Removed minimum conditions from battery deconstruction output (= deconstructing an empty battery still 
gives the materials used to craft the battery).
- Made a bunch of ItemContainer UI panels larger.
- Items can be dragged and dropped directly from the inventory into containers without having to select 
the container first.
- Plants can be picked up from the environment without any tools.
- Added more help texts to highlighted items ("[E] Interact", "[E] Climb"...)

Multiplayer fixes:
- Changes to event syncing logic to prevent cases where clients fall behind the server and get kicked out
due to the server not being able to send out network events to the clients fast enough.
- Networking optimizations that prevent level objects and continuously deteriorating items from creating
excessive amounts of network events.
- Fixed windows clients being unable to start a campaign in servers running on Linux.
- Fixed clients being unable to start a campaign using a submarine that's not in the default Submarine
folder at the server's side.
- Fixed loading submarine files and campaign saves occasionally failing when running multiple instances
of the game from the same install location (for example, a dedicated server executable and a client 
executable).
- Don't transfer files through the network when sending them to the owner of the server (i.e. a client 
hosting directly from the main executable).
- Fixed fires and water occasionally getting out of sync between a client using the fire/water console
commands and the server.
- Fixed clients disconnecting with an "unknown object header" error if they fail to read a network event
(when they should instead report the error to the server and wait for a message that contains a more
descriptive error).
- Campaign fix: clear missions from locations that change their type, and all adjacent locations. Not 
clearing them caused missions to still be available when they logically shouldn't be (e.g. a transport 
mission from an uninhabited location to another) and syncing issues in multiplayer.
- Disable campaign start button if a round is already running when joining.
- Fixed clients being unable to end campaign rounds at all if the sub isn't at the start/end outpost 
(regardless if they have the permission to end the round or not).
- Fixed campaign characters still being displayed in the server lobby after the game mode has been 
changed to something else.
- Fixed items in the characters inventory always starting at 100% condition client-side even if they had 
deteriorated during the previous round.
- Fixed LevelResource (mineral, plant, etc) deattach timers not being synced with clients.
- AI characters can take out excess fuel rods from the reactor when needed.
- Item interfaces and the health interface can be closed with Esc.

Bugfixes:
- Fixed almost all items using default repair duration values (10 seconds with high skills, 100 seconds
with low skills) instead of the ones configured in the item XMLs.
- Nuclear shells and nuclear depth charges disappear after they've exploded. 
- Fixed "trying to add a dead character to crewmanager" errors when attempting to revive a character 
killed by some other affliction than internal damage, bleeding or burns.
- Take the position of a sub's docking port into account when determining where to place outposts.
Previously the outposts were simply placed midway between the adjacent walls, which occasionally caused
problems with submarines whose docking port is close to the bow or tail.
- Fixed a bug in relay components that caused a bunch of issues in power grids that utilize relays:
Relays would receive the full amount of power from the grid regardless of the load of the devices
connected to the power_out connection, causing unnecessary overloads and fires.
- Fixed batteries being able to draw power through relay components that are connected directly to 
a power source, even if the relay isn't on.
- Don't allow steering the sub with WASD when a textbox is selected.
- Use the SpriteColor of the item when drawing the moving parts of turrets and doors.
- Fixed steering issues that caused monsters to swim in an incorrect direction when they're targeting
something inside the sub.
- Fixed a crash due when scaling the Mudraptor.
- Fixed crashing if a character has neither a head angle or a torso angle configured.
- Fixed characters always being created in the default folder in the character editor.
- Monsters don't target doors/hatches at the exterior of the sub when inside or inner doors when outside.
- Don't display disabled limbs on sonar (i.e. severed limbs that have "faded out").
- Close the save/load dialogs when leaving the sub editor. Otherwise they'll still be visible when 
re-entering the editor, and saving at that point will overwrite the previously loaded sub with an empty one.
- Removing an item after it's been combined doesn't trigger the OnBroken StatusEffects (e.g. combining two 
half-full flash powder jars doesn't cause them to explode).
- Fixed welding tools and plasma cutters not hitting targets if the barrel is inside the target (e.g. if
trying to weld a completely broken wall with the cutter partially inside the wall).
- Fixed very small mineral colliders that made them extremely hard to hit with the plasma cutter.
- Fixed items with no sprite crashing the game (now they just cause a console error).
- Don't allow autointeracting with contained items (e.g. picking up an ammunition box from a loader) 
if another item is currently selected. Makes it less likely for players to accidentally pick up items 
from containers when they deselect another item.
- Fixed characters not letting go of the character they're grabbing when the health interface is closed
by clicking outside the window.
- Fixed CrewManager throwing errors if changing resolutions when a crew member is dead.
- Fixed items emitting light from inside containers in the sub editor.

---------------------------------------------------------------------------------------------------------
v0.8.9.7
---------------------------------------------------------------------------------------------------------

Additions and changes:
- The fission rate gauge on the reactor now visualizes the amount of fuel available.
- Doors and hatches can now also be repaired with wrenches.
- Changed default StatusEffect conditional comparison type back to OR.
- Clients communicate syncing errors to the server, and the server logs a more descriptive error about
what went wrong. Should make it easier to diagnose disconnection issues from now on.
- Ending a multiplayer campaign round by talking to watchman doesn't require any special permissions.
- Server automatically ends rounds if there have been no players alive in 60 seconds and respawning 
is not allowed during the round.
- Added a button for resetting an entity's properties to the default values to the sub editor.
- Updated handheld sonar UI graphics.

Bugfixes:
- Fixed non-radio chat/VOIP having an unlimited distance.
- Fixed a networking bug that caused the server to send item state changes to the clients before sending
a message about the item being spawned. For example, spawning any item with a LightComponent would always
cause clients to get disconnected.
- Changes to the way the clients are put in sync with the server when joining mid-round. Should make it 
less likely for clients to get disconnected immediately after starting a round.
- StatusEffects only apply non-limb-specific afflictions to one limb even if targeting the whole character. 
Fixes drugs like fentanyl and morphine being way too harmful due to the oxygen loss affliction being 
applied once per every limb. 
- Fixed TargetItemComponentName not working in StatusEffect conditionals (making it impossible to create
conditionals that target a specific component of an item).
- Made all of the new medical items combinable and usable in a syringe gun (assuming the drug is in a syringe).
- Fixed inability to throw anything in the multiplayer.
- Fixed multiplayer campaign setup UI showing the client's subs instead of the server's.
- Fixed campaign view button overlapping with the "ready to start" tickbox in the server lobby.
- Fixed sub/mode voting not being enabled when changing the setting after the server has been started.
- Fixed character inventories occasionally being saved incorrectly in the multiplayer campaign when an
- Fixed flares not activating by left clicking.
- Fixed affliction icons flickering rapidly in the health interface and above the health bar if their
strength is fluctuating around the threshold where the icon becomes visible.
- Fixed dedicated server crashing when typing in more text than can fit on one line. 
- Fixed enemies "fleeing" after they have been shot. There was a steering issue when they targeted characters 
inside the sub while being outside.
- Fixed Hammerhead attack causing warping.
- Fixed incorrect submarine and level seed in server logs when playing campaign mode.
- Hide the start button from the campaign UI if the client doesn't have the permission to manage 
the campaign or rounds.

---------------------------------------------------------------------------------------------------------
v0.8.9.6
---------------------------------------------------------------------------------------------------------

Additions:
- A major overhaul on the crew AI. They should now be much better at executing their tasks, keeping
themselves alive and less likely to get stuck.
- Re-enabled multiplayer campaign.
- New alien ruin art.
- New main menu (still a work in progress).
- New fonts.
- New subs and a new shuttle.
- New husk sprites.
- Improved item/character highlight effect.
- New signal items (divide, multiply, subtract, memory, equals, greater than, color, xor).
- Option to adjust microphone volume in multiplayer.
- Added a console commands for changing the gender and race of the character.
- More intuitive BrokenSprite condition logic: a BrokenSprite with a MaxCondition of 50 will start 
fading in at 50 (and be fully visible when the condition drops to 0 or down to the MaxCondition of 
the next BrokenSprite).
- Added Mirror X/Y buttons to editing HUDs and tooltips that tell about the keyboard shortcuts.

Multiplayer fixes:
- Improved item position syncing logic. Less warping or items being impossible to pick up due to
being in a different position server-side.
- Fixed clients not sending a network update to the server when dragging an item out of an inventory
slot, causing situations such as suffocation after dropping a diving suit due to the server not
knowing that you'd dropped it.
- The client hosting a server and spectators don't trigger autorestart.
- The owner of a server is allowed to spectate even if spectating is disallowed in server settings.
- Fixed "play yourself" always toggling to true when a round ends.
- Fixed missing item names in the extra cargo menu.
- Fixed traitor rounds failing to start if the server is not hosted by a client.
- Fixed console command aliases not being taken into account in GameClient.HasConsoleCommandPermission 
(meaning that the client needed a permission for each name variant of a command, making it impossible 
to for example use "fixwalls" instead of "fixhulls").
- Made the "control" console command usable to clients. 
- Show the "ready to start" tickbox in the server lobby even if the client has the permission to start 
the round.
- Fixed server lobby screen not showing the names of the submarines the client doesn't have.
- Fixed inability to select the respawn shuttle as a client host.
- Fixed VoipCapture creating new "could not start voice capture" popups constantly if there's no 
suitable capture device.
- Fixed crashing when starting a round if a submarine name contains underscores.
- Fixed clients console errors when attempting to modify the properties of an ItemComponent in-game
(for example, the color of a light component).
- Added some more information to the console messages and error popups when a client gets disconnected.
- Fixed enablecheats command crashing the server if it's used when there are no clients present.

Misc bugfixes:
- Audio fixes (less snap, crackle and pop).
- Fixed particle "jitter" when the submarine was moving fast.
- Fixed damage modifiers affecting all afflictions if they use affliction types instead of affliction 
identifiers. 
- Fixed end round vote text going outside the screen if there's a 2-digit amount of votes.
- Fixed StatusEffects only applying afflictions to one limb even if the target is "Character" instead of "Limb".
- Disable audio instead of crashing if no audio device is found.
- Fixed item interfaces getting repositioned every frame when the editing HUD is open.
- Fixed held items clipping with the sleeves of the character (e.g. when holding a revolver while an 
uniform is equipped).
- Fixed being able to levitate by spamming the ragdoll button.
- Fixed dead characters draining oxygen tanks inside diving suits/masks.
- Fixed reactor gauges getting messed up if the optimal fission rate is more than 100% (which may happen
if the power consumption is larger than what the reactor can generate).
- Fixed mud raptors not having an inventory (nor lootable items).
- Fixed inability to interact with any items when aim assist is set to 0%. 
- Fixed info panel flickering out and Tab getting "inverted" (= info panel shown when tab is not being held) 
when selecting crew members in the panel.
- Fixed characters arms occasionally getting stuck above their shoulders.
- Fixed wire nodes occasionally being created at the wrong end of a wire (e.g. when moving a wire between 
connections in a connection panel, the wire stretched from the device at the other end of the wire to 
the device that's being rewired).

Misc:
- Changed the way arguments are given to the "setclientcharacter" command (no semicolon to separate the 
names, quotation marks have to be used for multi-word names just like with any other command).
- Show the amount of credits in the crew tab of the campaign menu.
- Don't spawn new monsters if docked to the start outpost or within 50 meters of the start/end of the level.
- The diving knife now causes also internal damage besides bleeding.

---------------------------------------------------------------------------------------------------------
v0.8.9.5
---------------------------------------------------------------------------------------------------------

Bugfixes:
- Fixed alien vents crashing the game when there's a character nearby.
- Fixed chatbox retaining the radio message prefix after being deselected.
- Push-to-talk doesn't trigger when typin in a text box.
- Fixed some server log messages and texts sent to clients being incorrect (= showing the tags that are
used to fetch the texts from the language files instead of the actual texts).
- Fixed AI orders that target a specific item (such as the order to power up the reactor) not working in
multiplayer.
- Fixed crashes when attempting to use voice capture or change voice capture settings when there are no 
suitable capture devices available.
- Fixed clients not being notified when an AI character shuts down the reactor.
- Fixed deconstructors staying active without power in multiplayer.
- Fixed sonar labels going outside the screen when at the left side of the display.

Additions & changes:
- Added some supplies to vanilla submarines.
- Balanced item deterioration rates and adjusted neutral ballast settings in vanilla subs.
- Increased the impact tolerance of crawlers to prevent them from killing themselves by bumping into walls.

---------------------------------------------------------------------------------------------------------
v0.8.9.4
---------------------------------------------------------------------------------------------------------

Multiplayer improvements:
- Got rid of the listen server: when hosting as a client, the game actually runs the dedicated server executable
in the background. Makes client-hosted servers a little smoother due to the better performance of the dedicated
server, and also makes it much easier for us to maintain and test the multiplayer because we no longer have
two separate server applications.
- Added multiplayer campaign.
- VOIP support! Still a work in progress, so minor audio glitches are to be expected.
- Improved character and submarine position syncing. Way less rubberbanding and teleporting!
- Fixed servers occasionally starting the round multiple times when autorestarting or starting by voting.
- Fixes players being unable to log in as a client when they're hosting a dedicated server on another machine.
- Option to randomize your job preferences in the server lobby.
- Fixed a server timing issue that occasionally caused the server to kick clients due to desync when a round starts.
- Fixed occasional server-side "maximum packet size exceeded" errors.
- Require the players to either dock with the ending outpost or to get the sub close and enter the outpost before 
automatically ending the round.

Bugfixes:
- Fixed crashing if the round ends while the health window is open.
- Fixed incorrect item panel positioning in the crew command interface when the sub is docked to something. 
- Fixed crashing when an incompatible content package is selected in config.xml or if the content package 
cannot be found.
- Fixed screen distortion effects on Linux.
- Fixed non-character key input on Linux (arrow keys, tab, etc).
- Fixed fullscreen option not taking effect on game launch.
- Fixes to a bunch of crashes in the character editor.
- Fixed subinventories not being displayed on the inner clothes slot, making it impossible to use the extra
slots in uniforms.
- Fixed game settings resetting every time the game is updated.
- Fixed bots shooting at their own crew with turrets.
- Fixed wifi components not receiving chat messages in single player.
- Fixed AI not reloading coilguns if an empty box of ammunition is inserted in the loader.
- Fixed incorrect deusizine scale.
- Fixed turret light toggle not doing anything.
- Fixed character skills that aren't defined in the job xml never increasing, resulting in all jobs except 
the captain always having a helm skill of 0.
- Fixed flashlight & scooter light cones being "clipped".
- Fixed StatusEffects bypassing limb damage modifiers.
- Fixed waypoints not getting connected between docking ports on some subs.
- Fixed target identifiers being bypassed when a StatusEffect is set to target nearby items or characters.
- Fixed the "insufficient skills to use the item" text popping up if a character doesn't have sufficient 
skills to operate one of the item's components, even if the component was not interacted with (e.g. captains 
got a warning about not being able to use the connection panel of a nav terminal, even if they didn't select 
the connection panel).

Steam Workshop:
- Update installed workshop items automatically on startup.
- Allow adding submarines to workshop items with the "add file" dialog.
- If creating an update for a workshop item that's currently installed, use the installed version instead 
of the one downloaded from the workshop.

Additions:
- Some new random events.
- A bunch of new afflictions and medical items.
- Some new item sprites.
- A couple of new cargo missions.
- Added some new items that can be crafted from alien materials.
- Display linked hulls as one room on the status monitor.
- Tons of new sound effects.
- Display the controlled character in the crew interface.
- Option to "give orders" to the character you're controlling. In single player it can be useful if you want 
the controlled character to keep doing something when switching to another one, in the multiplayer it can be 
used to let others know what you're doing.
- Added a weak spot to Moloch's bladder.
- Baby Moloch, doo doo doo doo doo doo 
- Added damage particles to Mud Raptors and Molochs.
- Added "minimum velocity" property to to motion sensors. Allows making sensors that, for example, keep a door open 
when a character is standing in the doorway.
- Option to choose whether to use AND/OR logic in StatusEffects with multiple conditionals. Defaults to AND.
- Added a 1 second "cooldown" to water detector state switches to prevent alarms from toggling on and off constantly 
when the water level is fluctuating around the position of the detector.
- Added scram option (reactor shutdown) to the nav consoles in the vanilla subs.
- Support for binding Mouse4, Mouse5 and MouseWheel.
- Made Hammerhead and Mudraptor attracted to light. 
- New husk sprite (still WIP).

Misc:
- Decreased deterioration rates across the board. Repairing a damaged item to full condition also now resets
the deterioration delay, meaning that the item will not start deteriorating again immediately after it's been
repaired.
- Miscellaneous optimization.
- Removed the info button from the top-left corner - the info menu is now opened with TAB.
- Changed default chat/radio keybinds to T and Y.
- Welding tools repair all the walls within the range of the raycast, not just the first wall the raycast hits. 
Makes it easier to repair overlapping and multi-layered walls.
- Decreased the range of passive sonar - previously there was often no reason to use the active sonar because
the passive mode showed the area around the sub so clearly.
- Health scanner shows all active afflictions (not just those that are visible in the health interface). 
Allows detecting afflictions at an earlier stage, making the item much more useful.
- Nerfed the structure damage done by Molochs and Crawlers.
- Reduced creature HP across the board.
- Increased the amount of minerals in levels.
- Increased flare burn time, making them more useful as path markers during exploration of ruins.
- RepairTool damage is configured using StatusEffects and Afflictions instead of the "limbfixamount" attribute 
that always does burn damage.
- Made headsets craftable.
- Battery output doesn't start dropping until the charge is below 10%.
- Restrict the amount of power going through relay components to the MaxPower value of the relay.
- Set Humpback reactor output a bit higher, batteries now start at full charge and relays can't be overloaded.
- Miscellaneous fixes and balancing to vanilla subs.

---------------------------------------------------------------------------------------------------------
v0.8.9.3
---------------------------------------------------------------------------------------------------------

- Made molochs slower.
- Watchmen cannot be dragged or grabbed.
- AI characters can give treatment to characters who aren't unconscious.
- Added a button that dismisses the tutorial popups to prevent accidentally closing the popups.
- Underwater scooters now attract monsters.
- Improvements and balancing to vanilla submarines.
- Made alien ruin walls more durable.
- Reduced item deterioration speeds.
- Added "yes to all" and "no to all" buttons to the prompts when deleting containers in the submarine editor.
- Improved the background smoke texture in hydrothermal wastes.
- Baby moloch, doo doo doo doo doo doo

- Fixed console errors in the chemical shipment mission due to auxiliorizine being still present in the
mission configuration despite the item being removed.
- Made coilgun ammunition boxes craftable and purchaseable, coilgun bolts cannot be purchased anymore.
- Fixed AI-controlled husk not spawning when a huskified player dies.
- Fixed AI crew occasionally going outside to fix leaks.
- Fixed server failing to sync clients who join the server after a character has been removed during 
the round (e.g. eaten, turned into a husk).
- Fixed server-side console errors when clients attempt to use a fabricator.
- Display Steam authentication errors in the server logs.
- Fixed status effects with a ReduceAffliction value of 0 freezing the game.
- Fixed sliders not moving in the battery/supercapacitor interface when an AI character is operating it.
- Fixed chatbox being deselected in the net lobby when receiving a lobby update from the server (i.e. 
whenever the server host changes any setting).
- Fixed OnBroken status effects firing in the submarine editor when an item's condition is set to zero
(for example, reactors exploding and breaking all the nearby walls).
- Fixed file number being added to the file extension of debug console log files ("file123.txt (2)" 
instead of "file123 (2).txt").
- Fixed battery positioning in charging docks.
- Fixed crashing when ending a single player round while a character is outside the sub.
- Fixed "attempting to remove an already removed item" console errors when ending a round.
- Fixed fire sounds persisting in menus.
- Fixed the layout of the extra cargo menu in server settings.
- Fixed depth charges disappearing from loaders when interacting them with both hand slots full.
- Fixed StatusEffects not being able to target item components. Caused doors to be impossible to weld 
and most likely other issues with item StatusEffects as well. 
- Artifacts spawn in artifact holders again.
- Fixes to "attempted to move pulljoint extremely far" errors which occasionally caused severe problems
in syncing characters' positions.
- Fixed a bug that occasionally caused monsters to spawn very close to the submarine in monster missions.
- Fixed servers occasionally starting the round multiple times when automatically starting the game via 
autorestart or clients being ready. 
- Fixed up-to-date content packages being reported as incompatible in the Steam workshop menu.
- Changed the default radio chat hotkey to T.
- Fixed the line of sight effect not working on ruins when looking at them from inside a sub.
- Fixed fabricator allowing new items to be created when the output is not empty, resulting in wasted materials.
- Fixed servers reporting incorrect player counts in the server list.
- Fixed order messages not being visible in single player if the character issuing the order has no headset.
- Fixed riot shields retaining their pushing ability even when the user is stunned or unconscious. 
- Fixed rubber ducks not floating like a good duck should.
- Prevent locations from being generated too close to each other in the campaign map.
- Fixed battery and supercapacitor charges not staying in sync between the server and clients.
- Fixed watchmen imploding continuously if they end up outside.
- Fixed non-downloaded workshop items showing zero as the file size.
- Fixed spectate button staying disabled if starting a round fails (due to a missing sub file for example).
- Fixed crashing when teleporting characters from a submarine to ruins in multiplayer.
- Fixed automatic temperature control setting turbine output above 100 if the power consumption is higher 
than what the reactor can generate. Caused "failed to write an event for the entity" errors in multiplayer.
- Fixed AI characters attempting to treat dead characters.

---------------------------------------------------------------------------------------------------------
v0.8.9.2
---------------------------------------------------------------------------------------------------------

- Fixed "incorrect filename case" errors.
- Fixed crew UI occasionally overlapping with device interfaces (such as the "passive sonar" checkbox).
- Fixed second submarine overlapping with the outpost at the end of the level in combat missions.
- Steam query port can be automatically forwarded using UPnP if your router supports UPnP.
- Fixed water currents inside the sub occasionally being way too strong to break free from.
- Fixed rewards mentioned in the mission descriptions not matching the actual reward of the mission.
- Fixed "can't create an entity event for Hull - the entity has been removed" errors when removing hulls
with fires inside them.
- Fixed submarine/mode selection tickboxes in the server settings menu.
- Fixed crashing when attempting to select an item in Humpback's fabricator interface.
- Fixed crashing when attempting to use active sonar in the submarine editor.
- Fixed the husk appendage not appearing on huskified humans.
- Fixed order/report messages being flagged as spam way too easily, causing frequent spam kicks.
- Fixed sliders buttons being invisible while pressed in device interfaces.
- Fixed an item being spawned in the submarine editor when selecting an item from the menu while another 
one is already selected.
- Fixed submarine colliders not taking into account the body offsets of the wall structures, causing
some items outside the submarine's walls to be impossible to interact with (the most noticeable being the
button that opens Orca's airlock from the outside).
- Added a small stun effect to railgun shells.
- Added a little extra fuel to vanilla subs.
- Slowed down item deterioration rates.
- Moved the position of turrets in Orca and Typhon to prevent players getting caught under them.
- Moved humpback's cargo spawn position a bit to prevent the cargo from falling down the hatch under it.
- Added better visual feedback when reactor is in poor condition.

---------------------------------------------------------------------------------------------------------
v0.8.9.1 (closed alpha)
---------------------------------------------------------------------------------------------------------

Too many changes to list here. :) We've been working on this update for a year now, with a team of about 
a dozen people (as opposed to a couple of devs working on it on their free time).

Almost every aspect of the game has been improved to some extent - some polished a bit, some went through 
a more major overhaul and many things are completely new.

This is by no means a complete list, but here's some of the new things:

- A full graphics overhaul: almost all of the sprites has been polished or completely remade.
- Improved random event system that tries to keep the overall difficulty of the game at certain level,
delaying additional monster spawns if there's already lots of things going on, or spawning more when 
there's a more quiet moment.
- Improved difficulty system: now the difficulty level has a much more noticeable effect on the gameplay.
- General difficulty balancing all across the board: we've tried to make the difficulty curve more approachable
to new players while still keeping things challenging for more experienced players on higher difficulty levels.
- More varied levels, environmental hazards.
- A new more detailed health system with things such as limb-specific injuries, addictions, overdoses, 
mental issues... The system is also highly moddable, and makes it much easier to implement things such as
hunger mechanics, more varied poisons or stat-boosting items.
- Completely redesigned in-game HUD (the inventory, crew command interface, chat, etc).
- Redesigned crafting system.
- Minerals scattered across the level (can be used for crafting).
- A command/report system that can be used to communicate with your crew more effectively (in both single 
player and multiplayer).
- Tons of additions to alien ruins (traps, puzzles, non-flooded rooms).
- Improved AI (both the crew AI and the enemy AIs).
- NPC dialog (including random chatter and context-specific lines that make it easier to keep track of 
what the crew is doing).
- Most of the device interfaces have been redesigned to make them easier to use (and nicer to look at!).
- Many additions to the campaign mode (still a work in progress though).
- Overhauled the skill system: now every character can generally do anything (repair devices, fabricate 
new items, apply medical treatments), but characters with higher skill levels will do things more efficiently.
- Skill progression in the campaign mode: characters' skills gradually increase, making them more valuable with 
each completed round.
- New music composed specifically for the game.
- Overhauled audio.
- New monsters.
- New items (weapons, tools, medical items, alien items, crafting materials, etc).
- A completely remade tutorial.
- Too many bugfixes to count.
- Improved and much more stable ragdoll animations.
- Additional tools for modders (character editor, sprite editor, level editor, additions to the submarine editor).
- Steam functionality of course: full Workshop support, achievements, banning Steam IDs from servers...
- Improved translation support: it's possible to translate texts in item/job/etc configuration files without
breaking compatibility with existing subs or mods (see the EnglishVanilla file for some instructions).

---------------------------------------------------------------------------------------------------------
v0.8.2.3
---------------------------------------------------------------------------------------------------------

- Clients can now join servers that have an IPv6 address.
- Added "unban" and "unbanip" commands.
- Fixed a bunch of bugs that were causing "attempted to apply an invalid force/impulse to a physics body"
errors.
- Fixed a bunch of bugs that were causing "attempted to move a pulljoint extremely far" errors.
- Fixed DebugConsole selecting non-command lines if up/down is pressed when there are no commands in the 
console. 
- Fixed inventory syncing not working on the controlled character's inventory if the character is 
unconscious or wearing handcuffs.
- Verify that the launched exe belongs to the currently selected content package when starting up the game.
- Fixed console messages that have been created before initializing the debug console not being present
in crash logs. Made it difficult to diagnose crashes that occur immediately when the game starts.
- Additional error logging to diagnose SharpDX errors on startup.

---------------------------------------------------------------------------------------------------------
v0.8.2.2
---------------------------------------------------------------------------------------------------------

- Fixed clients not seeing explosions from items that explode on impact or when their condition reaches zero.
- Fixed conditionals being ignored on delayed status effects.
- Fixed clients staying in an unsynced state if they rejoin while their character is dead or unconscious,
causing the camera not to follow the character and preventing the player from giving up.
- Fixed LightComponent sprites and broken device sprites not being mirrored in mirrored subs.
- Fixed a few ragdoll animation bugs that caused "attempted to move pulljoint anchor extremely far" errors.
- Fixed AI characters (most often mantises) being able to attack through walls.
- Fixed alien ruins occasionally overlapping with each other or being above the upper boundary of the level.
- Docking ports automatically stretch the hulls between them to cover the area between the docked subs. 
Otherwise there may be areas uncovered by hulls if the docking port is positioned slightly outside the 
extents of the submarine's hulls, causing characters to implode or get thrown back when they try to pass 
from sub to another.
- Fixed client-side docking ports creating duplicate bodies on doors, causing characters to collide with 
an invisible door when trying to move between docked subs (until the server forces them through it).
- Fixed characters occasionally getting teleported outside the sub for a few frames when moving between 
docked subs.
- Fixed status effects that deplete oxygen affecting characters that don't need air to breathe.
- More error logging to diagnose syncing errors.
- Melee weapons can only hit one character per swing (makes stun batons and medical syringes less OP).
- Option to make RegEx component only send a signal when it receives a signal (not continuously according 
to the last received signal).
- Added FalseOutput property to RegEx components.

---------------------------------------------------------------------------------------------------------
v0.8.2.1
---------------------------------------------------------------------------------------------------------

- Husks or huskified humans don't gain health by attacking corpses.
- Fixed dragged characters occasionally getting launched away at a high speed when moving from sub to
another.
- Fixed dragged characters staying floating mid-air after they've been dragged up/down ladders.
- Attempt to fix items occasionally dropping client-side when moving them from an inventory to another.
- Fixed incorrect rotation of welding tools and other 2-handed items that are held in one hand when not 
aiming. The items were rotated according to the left hand, but positioned on the right hand.
- Spaces and exclamation marks are allowed in client names by default.
- Hitscan weapons like the revolver can hit targets outside the sub when firing from the inside and 
vice versa.
- Fixed crashing when attempting to clone linked submarines in the sub editor.
- Fixed crashing when attempting to clone items with non-default required items.
- Fixed autopilot being unable to navigate to the destination in mirrored levels.
- Ragdolls can't be dragged through walls or other colliders.
- Dropped flashlights don't consume and battery and turn off automatically.
- Oxygenite tanks can be stored in cabinets.

---------------------------------------------------------------------------------------------------------
v0.8.2.0
---------------------------------------------------------------------------------------------------------

Networking additions:
	- Added a server setting for selecting which symbols are allowed in client names (see 
	AllowedClientNameChars in the server settings file).
	- Custom servers can modify all editable item properties mid-round, not just in-game editable ones.
	- Clients can be given access to server logs.
	- Respawn durations can be changed mid-round.
	- Servers have the option to disable the disguise feature.
	- Increased midround syncing timeout.
	
Misc changes:
	- Levels are mirrored when travelling through the backwards in the campaign mode.
	- Added colliders to railguns (so they cannot go through walls or enemy subs anymore).
	- Melee weapons can hit multiple targets on one swing. Fixes weapons occasionally  not hitting 
	the target in tight spaces due to touching the ceiling/walls first.
	- The voltage required for a PowerTransfer item to take damage and the probability for a fire can be 
	configured in the item xmls.
	- Docking ports and hatches aren't damaged by excess voltage.
	- Added more color variants of wires.
	- Characters point the harpoon gun down when not aiming.
	- Added parameter autocompletion to the kill command.
	- Added a property that can be used to lock connection panels but still keep the panel rewireable 
	in the submarine editor.
	- Items outside the sub cannot be deattached from walls.
	- Fabricators show the list of required items even if the character does not have the skills to craft 
	the item.

Networking bugfixes:
	- Fixed file transfers failing if the client disconnects during an active transfer, rejoins and 
	attempts to receive the same file.
	- Fixed a bug in door syncing that caused the door states to differ between the server and clients 
	in some	subs with more complex door wiring setups.
	- Fixed clients being able to spam kick votes (duplicate votes were not counted but caused unnecessary 
	chat messages to be sent).
	- Fixed item conditions occasionally not matching exactly between the server and clients, causing 
	issues such as not clients not being able to fabricate items due to the condition being slightly 
	below the minimum condition at their end.

Bugfixes:
	- Added a workaround to a MonoGame bug that makes the screen turn white when alt-tabbing out of fullscreen.
	- Fixed docking ports flooding for no reason in some custom subs.
	- Fixed LightComponents staying active on broken items.
	- Fixed railguns and depth charge tubes being directly usable by characters (= they could be launched 
	simply by selecting them and left clicking, without the need to use a railgun controller).
	- Fixed items salvaged from ruins not being saved in the campaign mode.
	- Fixed LOS effect being brighter than the ambient light in some of the darker levels, causing 
	the player to see obstructed areas better than unobstructed ones.
	- Fixed severed limbs staying disabled when a dismembered character is revived using console commands.
	- Fixed characters holding non-aimable two-handed items such as railgun shells in one hand when aiming.
	- Fixed stereo sounds not being loaded correctly.
	- Fixed modified sprite colors not working correctly on worn items.
	- Fixed modified maximum recharge speeds of PowerContainers resetting to the default value after 
	saving and reloading.
	- Fixed handcuffed players being able to perform CPR and grab/drag bodies.
	- Fixed diving suit's damage modifiers being bypassed if the character gets hit in the waist.
	- Fixed clown costumes not hiding the torso of the wearer.

---------------------------------------------------------------------------------------------------------
v0.8.1.12
---------------------------------------------------------------------------------------------------------

- Fixed connectionpanel syncing (wires dropping client-side during rewiring).
- Characters stay alive for 30 seconds after a client disconnects, and if the client rejoins during that 
time they regain control of the character. 
- Changing the sprite color of an item also affects the color when the item is being worn.
- Cloned items keep the value of the "required items" field of the original item.
- Fixed crashes caused by gaps that are not connected to anything.
- Removed the unused and non-functional monitor item.
- Made medical and toxic cabinets waterproof (= potassium and other water-sensitive items inside them 
are not affected by water).
- Fixed docking ports causing flooding in some custom subs.
- Fixed medical items with an immediate effect (such as calyxanide) not working when a player uses them
on themselves in multiplayer.
- Made calyxanide more effective and usable without a medical syringe.
- Fixed engines trying to apply infinite force to the submarine if MinVoltage is set to zero.
- Fixed levels resetting their mission to the previous one if the game is exited after completing a mission
without selecting the level first.

---------------------------------------------------------------------------------------------------------
v0.8.1.11
---------------------------------------------------------------------------------------------------------

Networking fixes:
	- More error logging to diagnose "unknown object header" errors.
	- Fixed output inventory of fabricators and deconstructors not being synced between clients.
	- Fixed servers failing to write network events for wires with an excessive number of nodes, causing
	clients to get kicked due to desync.
	- Fixed client-side error messages when respawning without a respawn shuttle.
	- Fixed some issues in inventory and connection panel syncing when joining mid-round.
	- Fixed fabricated items always appearing to be in full condition client-side (e.g. oxygen tanks which 
	should be empty after being fabricated).
	- Fixed attachable items dropping on the ground client-side when deattaching them (but still staying 
	in the inventory of the character detaching them).
	- Fixed items occasionally dropping instead of being moved to another inventory client-side.
	- The "traitorlist" command is usable by clients who have the permission to use it.

Misc bugfixes:
	- Fixed characters occasionally going inside/through obstacle when leaving a submarine that's right 
	next to another submarine or a level wall.
	- More physics error checks and logging.
	- Railgun controllers can be used over wifi components.
	- Characters attach items to the walls at the position of their hand, not at the center of the body.
	- Wifi components can't communicate with the enemy sub in combat missions.
	- Fixed the previously selected location staying selected but start button staying disabled when 
	returning to the lobby screen in the single player campaign. Made it impossible to progress without 
	restarting if there were no other selectable locations.
	- Fixed holdable components reverting their RequiredItems back to the prefab values during loading.
	- Fixed wall-attached sections of a wire not rendering when the item is being rewired outside the sub.
    - Fixed artifacts occasionally spawning under the sea floor.

---------------------------------------------------------------------------------------------------------
v0.8.1.10
---------------------------------------------------------------------------------------------------------

- Fixed bugs in wall hole creation logic and docking port syncing which caused entity ID mismatches and 
"unknown object header" errors.
- Fixed errors when attempting to buy too many items of a given type to fit in one container.
- Fixed crashing when attempting to buy items that don't spawn in a container.
- Fixed crashing when attempting to generate hulls with the "autohull" command when there are no walls 
or doors in the sub.
- Fixed docking ports creating duplicate hulls and gaps during loading.
- Fixed missions resetting to the initial ones when loading a campaign.
- Increased revolver ammo capacity.
- Fires can break oxygen generators.
- Oxygenite tanks can be contained in plasma cutters and oxygen generators.

---------------------------------------------------------------------------------------------------------
v0.8.1.9
---------------------------------------------------------------------------------------------------------

- Fixed a bug in docking port syncing that caused entity ID mismatches and "unknown object header" errors.
- Fixed a bug that occasionally caused entity ID mismatches and "unknown object header" errors when 
a respawn shuttle got damaged before returning back to the starting location.
- Fixed error messages when attempting to use the console commands "\" or "\n".
- Fixed clients not syncing the position of their controlled character with the server when dead/unconscious.
- Fixed swimming ragdolls "dropping down" if the server freezes them due to a connection error.
- Fixed excessive "attempted to apply invalid velocity to a physics body" console errors.
- Fixed crashing when selecting a level seed that has no background portrait defined.
- Fixed crashing if the player clicks yes on the "download sub from the server" prompt after 
returning to the main menu.

---------------------------------------------------------------------------------------------------------
v0.8.1.8
---------------------------------------------------------------------------------------------------------

- Fixed "invalid cursor position" errors when a client attempts to use console commands in the server lobby.
- Fixed crashing if a character takes damage during the first frame of a round.
- Fixed crashing if suitable prop items are not found when generating alien ruins.
- Some ragdoll and physics optimization.
- More automatic error logging to help with debugging.
- Fixed errors when attempting to change the output type of an oscillator in multiplayer.
- Campaign store menu includes a quantity field which lets the player select how many items to buy instead
of showing each item individually.
- Fixed clients not seeing vote counts on submarines that the client doesn't have.
- Fixed crashing if a player attempts to use an item on themselves and the item has a status effect that
causes the item to be removed.

---------------------------------------------------------------------------------------------------------
v0.8.1.7
---------------------------------------------------------------------------------------------------------

- Fixed crashes when trying to load submarines in the sub editor.

---------------------------------------------------------------------------------------------------------
v0.8.1.6
---------------------------------------------------------------------------------------------------------

- Fixed a memory leak in submarine preview images which caused crashes in the server lobby screen and
submarine editor.
- Fixed clients not seeing the "vote to end the round" tickbox if they don't have a character assigned to
them (despite the server allowing voting if the client has had a character earlier during the round).
- Fixed clients being able to crash servers if they had the permission to use console commands that
use the position of the client's cursor.
- Fixed crashing if a wire is used by a statuseffect (for example if a detonator tries to trigger a wire
contained inside it).
- Fixed GameAnalytics being stopped if the dedicated server is restarted with the "restart" console command.- 
- Fixed wiring items outside the submarine.
- Fixed chatbox discarding the second chat message instead of the first one when the maximum number of
chat messages is reached.
- Some error checking and debug logging to diagnose and prevent a crash caused by doors pushing characters away.
- The spawnitem command doesn't require multi-word item names to be surrounded with quotes anymore.
- Added the option to make powered items immune to electromagnetic pulses.

---------------------------------------------------------------------------------------------------------
v0.8.1.5
---------------------------------------------------------------------------------------------------------

- Added the option to automatically send crash reports and anonymous usage statistics to the developers.
The usage statistics include information such as the selected game mode, selected submarine, causes of
death and mission outcomes. When the game is started for the first time, a message box prompts you to
select whether you want to send the information or not.
- Fixed a bug that caused clients to get desynced when purchasing items in the multiplayer campaign.
- Added a signal component that adds the received signals together.
- Devices outside the submarine can be rewired in-game (not just in the sub editor).
- Fixed a crash caused by vision obstruction logic.
- Fixed clients being unable to give non-permanent or range bans.
- Clients are allowed to vote to end the round if they have spawned at some point during the round, 
even if the character they controlled doesn't exist anymore.
- Dedicated servers can give clients the permission to use console commands that aren't available in
for dedicated server (e.g. los, lights, control)
- Banip, banid and kickid commands can be used by clients now (if they have the permission to do so).
- Spawnitem [item] inventory, ragdoll and kill commands target the character of the client using
the command instead of the host's character.
- Spawnitem can be used to spawn items in the inventory of a specific character.
- Fixed explosions with an EMP value only damaging reactors (when they should only ignore reactors).
- Fire can only explode oxygen tanks that are >25% full (otherwise the condition of the tank just drops 
to 0). Prevents infinite explosions when an oxygen generator is on fire with oxygen tanks inside.
- Fixed projectiles with a damage range of 0 not applying their structuredamage value to structures.
- Items with a physics body can be used as pumps, so now it's possible to make portable items that remove
water from inside the sub.
- Fixed traitor ratio setting being ignored and the minimum number of traitors being 2.
- Fixed crashes caused by custom characters with no AI configuration.
- Character head and gender settings are saved.

---------------------------------------------------------------------------------------------------------
v0.8.1.4
---------------------------------------------------------------------------------------------------------

- Fixed clients getting assigned random jobs regardless of job preferences.

---------------------------------------------------------------------------------------------------------
v0.8.1.3
---------------------------------------------------------------------------------------------------------

- Fixed server-side crashes during job assignment if a client hasn't sent any job preferences.
- Fixed crashing if the selected respawn shuttle doesn't have a navigation terminal or any other item 
with a Steering component.
- Fixed InWater status effects triggering when an item is fabricated, causing issues such as 
water-sensitive items to breaking/exploding immediately after being fabricated.
- Fixed motion sensors sending out signals even if the output is set to nothing.
- Fixed crashing when a round starts if the sub has been saved while a fabricator was running. 
- Fixed explosives not detonating inside railgun shells.
- Fixed characters spawning inside the respawn shuttle if no suitable spawnpoint is found inside the
main submarine.
- Fixed a timing bug in the dedicated server which prevented clients from ever timing out, AI characters
from fixing leaks and reactor usage from being logged.
- Changed the format of the server log filenames to make them more easily sortable.
- Increased assistant's skill levels.
- Added oxygenite tanks.
- Added a rearward facing variant of railgun controller.
- Added railgun loader variants with 1 shell capacity.
- Added railgun shell rack.
- Decreased the skill level requirements for fixing docking ports.

---------------------------------------------------------------------------------------------------------
v0.8.1.2
---------------------------------------------------------------------------------------------------------

- Fixed medicines not having an effect when injected with a medical syringe.

---------------------------------------------------------------------------------------------------------
v0.8.1.1
---------------------------------------------------------------------------------------------------------

- Fixed explosives going off when a character holds them in their hand and left clicks, causing a crash 
if done in the submarine editor.

---------------------------------------------------------------------------------------------------------
v0.8.1.0
---------------------------------------------------------------------------------------------------------

Items:
	- Added searchlights.
	- Explosives, chemicals and medical items disappear when their condition falls to 0 
	(i.e. when they're fully used).
	- Railguns cannot be fired when not being aimed.
	- Removed the need for batteries in diving suits. The light stays on as long as the suit is worn 
	by a living character.
	- Junction boxes only take damage underwater when they're powered up.

Bugfixes:
	- Fixed a bug that occasionally caused some characters to not be removed at the end of a round, causing 
	various bugs and crashes on successive rounds (the most common ones being server-side crashes and 
	constant "attempted to access a potentially removed ragdoll" console errors). 
	- Fixed camera shake continuing indefinitely if a character falls unconscious due to impact damage.
	- Fixed item removal by right clicking not being synced with clients.
	- Fixed being able to gain karma by welding fixed walls.
	- Fixed crashing caused by IndoorSteeringManager.
	- Fixed all loose items disappearing from respawn subs between respawns.
	- Fixed items in cloned/copypasted inventories not being saved.
	- Option to edit structure texture scales and offsets.
	- Fixed new log messages appearing in the server log even if the type of message has been filtered out.
	- Fixed the EndRound music clip occasionally looping forever after a round ends.
	- Fixed player-controlled creatures being able to damage themselves.
	- Fixed repair tools causing damage to the user regardless of the character's skills.
	- Attempt to fix characters occasionally getting launched out of the sub at lightspeed when the sub 
	crashes into something.
	- Fixed StatusEffects not working on child ItemComponents.
	- Wearables apply OnWearing StatusEffects in all the components of an item, not just the Wearable component.
	- Fixed Equals/NotEquals conditional comparisons.

Misc additions:
	- Added console commands for giving the clients ranks, showing their current permissions and 
	giving/revoking the permission to use specific console commands.
	- Option to set an automatic ban duration for vote kicked players.
	- Option to log debug console output into a text file.
	- Ladders can be climbed by holding up/down while standing next to them without having to select them first.
	- Name tags and healthbars are clamped inside the room a character is inside.

---------------------------------------------------------------------------------------------------------
v0.8.0.5
---------------------------------------------------------------------------------------------------------

- Optimized (and less glitchy) line of sight effect.
- Some lighting optimization.
- Added a light to diving suits.
- Attempting to equip an item by double-clicking when another item is already equipped swaps them.
- Syringes are recolored according to the color of the medical item inside them.
- Added a console command for changing the server password.
- Bunch of fixes to relay component logic.
- Fixed a bug in the entity event system that caused "trying to read past buffer size" errors and desync
when entities were removed mid-round.
- Fixed clients getting desynced if the server ends a campaign and starts a new one.
- Fixed the "campaign view" button staying visible in the server lobby after the campaign has ended.
- Fixed message boxes appearing behind the campaign setup menu in the server lobby.
- Fixed round summaries always showing the game over text in multiplayer if the submarine didn't progress 
to the next location.
- Fixed missing spark particles when welding/cutting a wall.
- Fixed plasma cutters not affecting hatches, alien doors or duct blocks.
- Fixed welders and cutters not doing damage to characters if the flame hits the collider of the character
instead of a limb.
- Fixed diving mask, headsets and other headgear being rendered in front of diving suits.
- Fixed crashing when attempting to perform CPR on a headless character or AS a headless character.
- Fixed attachable items being deattachable with the select key instead of the use key.
- Fixed clients being unable to open doors with crowbars.
- Fixed items attached mid-round by other clients or the host being impossible to interact with 
and occasionally being attached to an incorrect position.
- Fixed batteries not getting recharged in charging docks.
- Fixed monsters being able to spawn under the ocean floor in levels where the floor is high up.
- Fixed effects of the medical items not being stackable, meaning that successive usages of a medicine
did not have an effect until the effect of the first dose has worn off.
- Fixed items in itemcontainers (e.g. shells in railgun loaders, batteries in recharging docks) always 
being rendered with the default sprite color.
- Fixed crashing when clicking the "refreshing server list" text in the server list menu.
- Fixed dedicated servers not resetting votes when a round ends.
- Fixed interaction areas of some items being incorrect in the dedicated server.
- Fixed the removal of items that get deleted after being used not being synced.
- Ladder waypoint generation fix: waypoints are not just placed at the top and bottom of the ladders, 
but above every platform along the ladders (-> waypoints work correctly on ladders spanning through 
multiple floors).

---------------------------------------------------------------------------------------------------------
v0.8.0.4
---------------------------------------------------------------------------------------------------------

- Fixed "an item with the same key has already been added" exceptions when trying to start a server.

---------------------------------------------------------------------------------------------------------
v0.8.0.3
---------------------------------------------------------------------------------------------------------

- Another attempt to fix relay components: it should be now possible to use relays in series and pass
power to junction boxes through relays.
- Fixed creature disabling in server settings only taking character config files in the Content/Character
folder into account.
- Added ruin structure, particle and decal configuration files to content packages.

---------------------------------------------------------------------------------------------------------
v0.8.0.2
---------------------------------------------------------------------------------------------------------

- Doors can be opened with crowbars again.
- Improved fire extinguisher aiming logic which makes it much easier to put out fires.
- Fixed relays burning out when connected to a power grid that carries more power the relay can transfer.
- Fixed crashing when trying to store jumpsuits in themselves.
- Fixed "Text FabricatorRequiredCondition not found" errors when attempting to fabricate specific items.
- Fixed Linux and Windows builds calculating different MD5 hashes for the same content packages.
- Sound configuration files are included in content packages.
- Fixed "file not found" errors when a character is wearing footwear with no configured footstep sounds.
- MODDERS PLEASE NOTE: hit sounds on limbs and wearable items must now use tags instead of direct paths
to the sound file. New sound files and tags can be added by editing the sound configuration files. 

---------------------------------------------------------------------------------------------------------
v0.8.0.1
---------------------------------------------------------------------------------------------------------

- Fixed crashing when creating items with a PowerTransfer component mid-round (e.g. when fabricating 
a relay component)
- Fixed dead/spectator chatting in multiplayer.
- Chatboxes can be deselected with the chat hotkey again.
- Fixed railgun shells not detonating their contents on impact.
- Fixed clients failing to start a new round after downloading a missing submarine file from the server.
- Fixed ruin doors and hatches being possible to open with the select key.
- Unequipped headsets can't be used and don't consume batteries.
- Fixed depth charge tubes launching the depth charges up by default.
- Fixed some pre-placed items not appearing in mirrored subs in the combat missions.
- Fixed text overflows in round summaries with large amounts of text.
- Fixed crashing when attempting to save settings before player name has been set in the server list menu.

---------------------------------------------------------------------------------------------------------
v0.8.0.0
---------------------------------------------------------------------------------------------------------

- Made ambient lighting much darker and added a subtle glow around the player.
- Made partially damaged walls leak much more slowly.
- Nerfed wall damage. Crawlers, mantises, threshers and coelanths now take much more time to tear through 
the hull and collisions with the level cause less damage.
- Moved a bunch of hard-coded texts to an xml file "Content/Texts.xml". Full translation support is still 
in progress, but now it should be possible to translate most of the in-game texts without recompiling the game.
- Optimized rendering.
- More accurate endworm attack hit detection.
- Players can only see the names of characters that are in their field of view.
- Fixed submarines bouncing off monsters and other submarines that are laying against the ocean floor.
- Characters can be crushed between submarines and ice walls.
- Item names can be changed without breaking everything as long as the original name is included as an
alias of the item.
- Console command arguments can be autocompleted by hitting tab.
- Added a console command for automatic hull generation.
- Added a console command for killing a character.
- FPS counter can be enabled separately from DebugDraw.
- Option to display lighting in the submarine editor.
- Added a submarine preview window that displays a preview image and some extra information of the subs.
- Option to configure which content packages a submarine is compatible with.
- Names and health bars fade out when the cursor is not being hovered near the character.
- Added spark and smoke particle effects when welding or cutting something.
- Welding or cutting a door displays its health.
- Added a button for forcing the controlled character into ragdoll mode.
- Option to grab onto the torso of a dead/unconscious character.
- Dead/unconscious characters can be dragged up ladders.
- Improved CPR animations.
- Doing CPR on bleeding characters causes them to take damage.
- Characters can fall through holes in floors.
- Players can pick up corpses and eat them when controlling a monster.
- Husks don't attack huskified humans.
- Characters with severed limbs cannot be resurrected as a husk.
- The humanhusk.xml config file is found based on the name instead of the file path, making it possible
to use a custom config file without modifying the original one.
- More footstep sound variety.
- More gore particles!
- Added a conditional system to status effects. Allows creating status effects that only have an effect
when a specific condition is met (e.g. health above a specific level, charge of an item high enough).
- Option to prevent status effects from stacking.
- Option to make status effects cancel other status effects.

Items:
	- Added syringe guns and a bunch of new chemicals.
	- Added ducts, switches and motion detectors.
	- Added crowbars (can be used to open locked doors).
	- Chemicals and explosives can be thrown.
	- Made more items craftable and deconstructable.
	- Added sprites for broken doors, hatches and junction boxes.
	- Health Scanner HUD displays causes of death.
	- Health Scanner HUD only shows the status of the visible character that the cursor is closest to 
	prevent multiple characters from cluttering the screen
	- Added "smallitem" tag to revolver rounds (can be placed in cabinets and pockets now).
	- Option to determine which types of targets a projectile can stick to.
	- Improved revolver hitscan logic.
	- Item descriptions can be changed in the submarine editor.
	- Characters can hold flashlights in their mouths.
	- Added an inventory slot for ID cards.
	- If a character is wearing an item that obscures their face, the game will either hide their name or
	show the name that's in the ID card the character is wearing. 
	- The owner of an ID card is stated in the description of the card.
	- Fabricating items requires the ingredients to have a specific minimum condition (can't use 
	already-used consumables to craft something).
	- Deconstructing an item that's not in a full condition may prevent some deconstruction products from appearing.
	- Optimized electricity/signal logic.
	- Grenades can be triggered by detonators.
	- Bought cargo spawns in containers instead of being scattered across the floor.
	- Players can't use other items when a railgun controller is selected. Prevents accidentally firing 
	weapons or hitting people with something while using the railguns.
	- Item editing menus display color values as 0-255 instead of 0-1.
	- Reactor temperature has to be critical for 30 seconds before the reactor explodes, giving the crew 
	more time to deal with griefers or incompetent reactor operators. The reactors also have an output 
	connection	that sends out a signal when the temperature is critical.

Multiplayer additions:
	- Added an optional "karma system". Harming other players, damaging structures and blowing up the reactor 
	reduces karma, while repairing things causes it to increase. A too low karma level prevents the players 
	from choosing specific jobs
	- Clients can be given permission to use specific console commands.
	- Client permission presets: the clients can be assigned as moderators or admins which have specific
	pre-configured permissions. New presets can be added by editing Data/permissionpresets.xml.
	- Option to have more than one traitor. Traitors also now get a set of code words that can be used to 
	secretly identify other traitors.
	- Added an option to make players spawn directly in the main submarine instead of the respawn shuttle.
	- Keybinds are disabled when the chatbox is active. Now it's possible to use normal letter/number keys
	as the chat hotkey without accidentally deselecting the chatbox by typing a message.
	- Chat hotkey can also be used in the server lobby.
	- Added a [PM] tag to private chat messages.
	- Fixed game over/round end music not playing when a round ends.
	- Cutting and repairing walls is included in server logs.

Multiplayer bugfixes:
	- Fixed clients getting disconnected due to desync when a new monster is spawned mid-round by 
	a repeating	monster event.
	- Fixed modified clients being able to chat while unconscious due to the lack of server-side checks.
	- Fixed modified clients being able to disconnect locked wires due to the lack of server-side checks.
	- Fixed chat messages being assigned to the wrong sender when their bodies have been eaten.
	- Fixed crashing when setting a server filter while the game is refreshing the server list.
	- Fixed wires not being dropped server-side when a player drops a connected wire without dragging it 
	to their inventory first.
	- Fixed 5th server being impossible to select in the server list.
	- Improvements to character position syncing.
	- Re-enabled logic for preventing players from using visually similar names.
	- Fixed client-side null exception when the client is in the lobby and a round ends with the mission 
	successfully completed.
	- Fixed clients being able to votekick/kick/ban themselves in the server lobby.
	- Fixed "selected mode" and "mission type" settings not being saved.
	- Level seed randomization can be toggled on and off via the debug console.
	- Fixed dedicated server not randomizing the submarine or game mode even if randomization is enabled.
	- Lighting is forced back on when a client starts a round (-> can't disable lighting by using the 
	console command before joining a server).

Bugfixes:
	- Fixed wire connections being lost when copy-pasting in the submarine editor.
	- Fixed wire nodes being impossible to select in the wiring mode if the nodes are exactly at the same position.
	- Fixed artifact holders being occasionally placed inside ruin doors and hatches.
	- Fixed particles in water being drawn under ruin structures, making it seem as if plasma cutters and
	welders weren't working.
	- Fixed all ruin structures having a health of 100.
	- Fixed OnActive status effects not being applied on powered items that don't require any power.
	- Fixed damage modifiers being applied multiple times when wearing an item that takes up multiple slots.
	Meaning that items such as the diving suit gave the players an excessive protection against damage.
	- Messagebox overflow fixes.
	- Fixed status effects not being able to decrease stun timers.
	- Fixed anti-husk medicine being able to reduce husk infection state after the infection has reached
	the active state.
	- Fixed monsters being able to spawn right next to the spawnpoint of the sub.
	- Fixed hulls not being linked to gaps if the center of the gap is exactly at the edge of the adjacent
	hulls.
	- Miscellaneous crew AI fixes.
	- Fixes to fast projectiles going through walls.
	- Fixed structure damage sounds not being played when a structure is fully destroyed.
	- Fixed glass windows using wrong sound effects.
	- Fixed carrier's light falling off when it dies.
	- Fixed incorrect positioning of debug console question prompts.
	- Fixed being able to use a wrench on multiple items at the same time.
	- Fixed double-clicking items in corpses putting them in their hands instead of your own inventory.
	- Fixed some level seeds generating a tiny enclosed cave that makes it impossible to reach the destination.
	- Fixed opened and broken doors being ignored during waypoint generation, causing waypoint connections 
	to go through doors which prevented AI characters from opening them.
	- Fixed modified structure colors not being cloned.
	- Fixed modified wall colors only being visible in the submarine editor.
	- Fixed items being dropped when attempting to place them in an itemcontainer slot that's on a normal 
	inventory slot.
	- Fixed stack overflow exceptions caused by signal loops between junction boxes.
	- Fixed submarine editor crashing when attempting to use illegal characters in the filename.
	- Mouse clicks have to be <10 pixels apart to be considered a double click.
	- Fixed subinventory slots going outside the screen when highlighting an item such as a metal crate.
	- All creatures all cleared from the tutorial level to prevent any unintended monster attacks.
	- Fixed "constructing final path failed" pathfinding errors.
	- Fixed particles going through closed gaps (e.g. closed doors).
	- Fixed submarines being able to enter ruins.
	- Fixed collisions between a sub and the ruins not causing any damage to either the sub or the ruins.
	- Whitespace is ignored when calculating MD5 hashes for files.

---------------------------------------------------------------------------------------------------------
v0.7.0.1
---------------------------------------------------------------------------------------------------------

- Added console commands for modifying client permissions.
- Fixed content package setting not being saved in the settings menu.
- Item pickup sounds are only played when the controlled character picks up an item.
- Removed serverconfig.xml (the dedicated server now uses the same config file as the normal game).
- Updated the vanilla content package to version 0.7.
- Fixed entity linking in the submarine editor.
- Fixed railgun HUD crashing the game if the railgun is linked to an item that does not have an 
ItemContainer component (i.e. any item that can't contain other items).
- Fixed exceptions when the player dies in the tutorial.
- Fixed the start popup saying the host is the target if the host has been selected as the traitor.
- Fixed crashes when attempting to use a railgun controller that's not connected to anything.
- Fixed autorestart counter overlapping with the campaign map in the server lobby screen.
- Fixed characters receiving damage almost exclusively to their feet when wearing a diving suit.
- Armoring reduces damage by a certain percentage, not a fixed value. Now armor doesn't make characters
invulnerable to small amounts of damage.
- The effectiveness of different types of armor depends on the type of damage. For example, diving suits
provide fairly good protection against burn and slash damage, but aren't as affective against blunt damage.
- Fixed light sources attached to limbs not rotating with the limbs.

---------------------------------------------------------------------------------------------------------
v0.7.0.0
---------------------------------------------------------------------------------------------------------

- Multiplayer campaign mode!

Level changes:
	- Added ocean floors and hydrothermal vents.
	- The commonness of scripted events (monster and artifact spawns) varies between different level types -
	some monsters and artifacts now only spawn in specific types of levels.
	- Bunch of new level types.
	- Level wall color can be changed in level generation parameters.
	- Small caves/tunnels are more common now, and groups of monsters can spawn inside them.
	- Added salvage mission variants where the artifact is spawned inside a cave.

Submarine editor:
	- Entities can be nudged with arrow keys.
	- Structure sprite colors can be changed.

Particles:
	- Particles that are outside the sub don't get rendered inside the sub even if they're overlapping with it.
	- The emission rate of particle emitters can be set as particles per second (instead of particles per frame).
	- Minor particle optimizations.

Bugfixes:
	- Fixed the "DXGI_ERROR_DEVICE_REMOVED" crashes on specific GPUs when the loading reaches 80%.
	- Fixed crashes when projectiles stuck to items on dedicated server.
	- Fixed a bunch of bugs that caused crashes when a character was removed mid-round (for example when 
	a character turns into a husk).
	- Fixed a bug that occasionally caused swimming creatures to flip around constantly.
	- Fixed a bug that caused creatures to be able to sever limb joints that shouldn't be possible to sever,
	causing issues when attempting to sync the positions of the dead bodies.
	- Fixed vote count texts persisting in the server lobby after the host disables voting.
	- Fixed newly joined clients not receiving the latest voting status until someone votes for something.
	- Fixed vote count texts not being updated after a client disconnects and their vote is removed.
	- Fixed errors when attempting to save server logs with illegal characters in the server name.
	- Fixed AI characters becoming invincible when far enough from the main submarine in multiplayer.
	- Fixed AI characters never making any sounds in multiplayer.
	- Fixed inability to rebind keys to Mouse2 via the settings menu.
	- Fixed destroyed doors being impossible to repair.
	- Fixed creatures seeking towards an incorrect position when trying to eat something (causing larger 
	creatures like threshers and coelanths to swim around the target without ever reaching it).

Items:
	- Added battery recharge docks.
	- Added revolvers (the captain always spawns with one).
	- Added oscillators (a signal item that sends out a periodic pulse, a sine wave or a square wave).
	- Added "state_out" connections to relay components.
	- Added sprites for destroyed doors/hatches.
	- Added a HUD that shows the charge of the supercapacitors and the amount of shells left when using
	a railgun.
	- Inventory slots are be highlighted even if the cursor is within the empty space between them. Now 
	items can't be accidentally dropped by releasing the mouse button between the slots.
	- Sounds for picking up and dropping items.
	- Medical scanner displays husk infections.
	- New C4, detonator and grenade sprites.
	- Optimizations and minor visual changes to the sonar display.
	- Support for hitscan projectiles.
	- Fixed ranged weapons launching projectiles with an incorrect rotation.
	- The spread of ranged weapons can be adjusted (separate values for normal spread and spread when 
	the item is being used by a character with an inadequate skill level).
	- Heavier harpoon gun recoil and impulse when the spear hits something.

- Improved item editing UI:
	- Number input fields for numeric values.
	- Separate number input fields for the components of vector values (instead of one text input box)
	- Color input fields display a preview of the currently selected color.
	- Enum fields are displayed as dropdown menus.

Misc:
	- Flowing water pushes characters around much more heavily.
	- Warning texts when water pressure is increasing to dangerous levels and when running out of oxygen.
	- Made the damage range of limb attacks configurable (instead of having it always be half of the distance 
	at which the attack activates) and tweaked the damage ranges of all the creature attacks.
	- Option to filter the server list based on a bunch of criteria.
	- Added a radio chat hotkey.
	- Clients can be given a permission the select the submarine or the game mode.
	- Option for clients to spactate the game without respawning (assuming the server allows spectating).
	- The range and volume of sounds emitted by StatusEffects can be changed and the sounds can be looped.

---------------------------------------------------------------------------------------------------------
v0.6.1.4
---------------------------------------------------------------------------------------------------------

- Plasma cutters can cut alien ruins again.
- Fixed reactors staying operational after the fuel rods run out.
- Fixed spawning items at the cursor via the debug console.
- Fixed job assignment logic causing crashes if the maximum amount of players per job has been reached
on the top 3 preferences of a client (which can happen on modded servers that have several jobs with a 
player limit).
- Fixed errors during job assignment if a client or the host is controlling a non-human character.
- The server log menu remembers the state of the filters when toggling it.
- Fixed level generation errors in some specific seeds that caused the game to create ruin walls with
a negative width/height (example seed: cBLgZ2im).
- Fixed a submarine position syncing issue that caused erratic physics behavior on some specific 
multi-part subs, because the game only moved one part of the sub and the parts docked to it, not taking
into account that more parts may be docked to the docked parts.
- Handcuffed AI characters can't climb ladders.
- Fixed crashing when a huskified human is killed by an explosion.
- Added some GPU info to the crash reports and extra debug logging to hopefully diagnose the 
SharpDXExceptions during startup.

---------------------------------------------------------------------------------------------------------
v0.6.1.3
---------------------------------------------------------------------------------------------------------

- Fixed hulls not being rendered in the submarine editor.
- Crouching is synced between the server and the clients.
- Plasma cutters and welding tools ignore platforms and stairs - placing a platform on a wall doesn't 
prevent welding/cutting the wall anymore.
- Using the SetClientCharacter console command forces the client's line of sight effect back on.
- Fixed null reference exceptions when syncing docking ports that haven't been docked to anything.
- Fixed invisible diving suits in some of the respawn shuttles (specifically ones where the suits spawn
directly on the floor).

---------------------------------------------------------------------------------------------------------
v0.6.1.2
---------------------------------------------------------------------------------------------------------

- Dedicated servers can use autorestart.
- Fixed dedicated servers ignoring armor.
- Fixed console messages not appearing in the crash reports if the game crashes during loading.
- Attachable items (buttons, electrical components, etc) are automatically attached to walls when placed 
in the submarine editor.
- Fixed crashing if no matching character is found when using the SetClientCharacter console command.
- Fixed wires disconnecting from a connection panel when a player moves any of the wires.
- Tab doesn't autoselect the chatbox when the debug console is open.
- Fixed missing kick/ban buttons in the crew menu.
- Fixed a bug that caused ID mismatches in the hulls between docking ports. This caused, for example,
mysterious client-side fires around docking ports and "unknown object header" errors.

---------------------------------------------------------------------------------------------------------
v0.6.1.1
---------------------------------------------------------------------------------------------------------

- Fixed diving suits and masks not providing enough oxygen when in a low-oxygen room or outside the submarine.
- Fixed message boxes being impossible to close in the launcher.

---------------------------------------------------------------------------------------------------------
v0.6.1.0
---------------------------------------------------------------------------------------------------------

Multiplayer:
	- Dedicated server application.
	- Option to supply a reason for banning/kicking a client.
	- Option to set a duration for bans.
	- Respawning characters get ID card tags for both the shuttle and the main submarine, i.e. they are
	able to open shuttle doors that require a specific clearence.
	- Clients now get back control of their character if the server revives them using the debug commands.
	- Added a console command for changing the character a client is controlling.
	- Job preferences don't reset when quitting the game.
	- Added MessageBox chat message type. Allows custom servers to display custom message boxes to the clients.
	- Logging when a character throws an item.
	- Logging which items are contained inside items characters use on themselves (e.g. which meds are 
	inside a medical syringe).
	- Logging which type of projectile was launched from a railgun and which items were contained inside it.
	- More descriptive wiring logging: the logs don't list all the wires in a connection panel but only 
	the changes players do to the wiring.

Monsters: 
	- Some creatures can hunt for smaller creatures (including humans) and eat them.
	- Tweaked enemy AI to make their attacks less likely to miss.
	- Some creatures flee when their health decreases below a specific threshold.
	- Crawlers and mantises can attach to ice walls to "ambush" their prey.
	- Enemies don't always move at a fixed speed, now they move faster when attacking or fleeing.
	- Shooting watchers with a ranged weapon makes them attack.
	- Split tiger thresher's and charybdis' bodies into more parts to make them a bit more agile.
	- Option to make monster events spawn more monsters when previous ones are killed.
	- The camera zooms further out when controlling a large non-humanoid character.

Misc:
	- Improved item interaction logic: highlighting items is more precise, with items directly under 
	the cursor taking priority.
	- Characters can be dismembered by creatures and explosions.
	- New blood particles.
	- Blood, explosion and fire decals.
	- Added an artifact that attracts creatures. 
	- Detached buttons and electrical components can be picked up just like any other item, instead of 
	having to use a wrench and wait for the item to "detach".
	- Wires can't be connected to detached items.
	- Debug commands can be autocompleted using tab.
	- Added a debug command for creating explosions.
	
Bugfixes:	
	- Fixed "loading was interrupted due to an error" crashes on startup.
	- Fixed "destination array was not long enough" errors in AddToGUIUpdateList.
	- Fixed error messages when a character gets stunned for over 60 seconds in multiplayer.
	- Characters don't consume oxygen from rooms when wearing a diving mask or a diving suit.
	- Fixed occasionally seeing through walls when swimming outside a submarine.
	- Fixed crashes during map generation caused by very large wall cells near the entrance of the level.
	- When highlighting a wire in a connection panel, the physical wire and the items connected to it are 
	highlighted.
	- Fixed crashing when selecting a sonar monitor in a submarine with no hulls.
	- Fixed submarine/shuttle lists occasionally appearing empty after joining a server.
	- Fixed "received a position update for an item with no physics body" errors caused by detaching buttons
	or other electrical components from the walls.
	- Fixed a bug that caused characters to aim slightly off at the server's side when using a ranged weapon
	or other aimable item.

---------------------------------------------------------------------------------------------------------
v0.6.0.2
---------------------------------------------------------------------------------------------------------

- Fixed "maximum packet size exceeded" errors when clients join servers.
- Fixed a bug that caused non-interactable checkboxes to always appear unchecked.
- Skill level syncing fix: the syncing isn't dependent on the order of the characters skills anymore.
- IP addresses are included in all login error messages and the errors are also logged to the debug console.
- Servers end rounds if all players are either dead or unconscious when autorestart is on (instead of 
waiting for all players to die)
- Fixed nuclear shells and depth charges exploding immediately when launched.
- Fixed a bug that prevented any broken items from being repaired in the single player.
- Fixed items disappearing from inside copypasted items (e.g. cabinets).
- Added character teleporting console command.

---------------------------------------------------------------------------------------------------------
v0.6.0.1
---------------------------------------------------------------------------------------------------------

- Readded spam filter.
- Servers log the automatic temperature control setting of nuclear reactors.
- If a client fails to start a round (due to a missing sub file or an error, for example), their character 
is automatically killed. This prevents situations where a team can't win a combat mission due to a 
disabled, invisible character in the opposing team.
- Fixed clients occasionally displaying the "crew has been defeated" message immediately after a combat
mission starts.
- Fixed a bunch of bugs in the job assignment logic.
- Fixed errors if attempting to send radio messages without a radio in the inventory.
- Fixed "component doesn't have a GUIFrame component" errors when selecting an artifact holder.
- Disabled unnecessary server-side message ID logging.
- Option to enable additional network debug logging by enabling verbose logging in config.xml.

---------------------------------------------------------------------------------------------------------
v0.6.0.0
---------------------------------------------------------------------------------------------------------

Rewritten networking code:
	- much more robust syncing logic
	- proper authoritative servers (i.e. much more more hack-proof)
	- the server can transfer multiple files to a client simultaneously
	- having multiple submarines with the same name (but different MD5 hash) in the submarine folder
	doesn't prevent clients from loading the correct one
	- server logs can be viewed in the server lobby, not just in-game
	- logs can be filtered by message type
	- door, docking port and railgun usage are logged
	- the in-game log view isn't cleared when the log is written to a file
	- character skill levels are synced
	- clients can't vote multiple times by disconnecting and reconnecting

UI:
	- new UI graphics
	- smoothly scrolling listboxes
	- multi-line chat messages don't overlap

Items:
	- passive sonar: when not active, the sonar shows nearby sources of sound and a faint outline of the 
	structures around them. Now it's much easier to monitor how much noise the submarine is making and to
	hide from enemies.
	- new sonar visuals
	- texts in labels can be resized
	- alien weapons can be used as railgun ammo
	- nerfed oxygen and welding fuel tank explosions
	- buttons created in fabricators work now

Submarine editor:
	- items/structures that have been copy-pasted from another submarine don't disappear when saving and 
	loading the sub
	- fixed crashes when attempting to load a submarine with no walls
	- placing a resizable structure with a height/width of zero is not allowed
	- "are you sure" prompt when trying to delete subs
	- open menus are closed when opening another one (e.g. the save dialog box is automatically closed if
	the item selection menu is opened)
	- fixed crashes when switching to character or wiring mode after copypasting waypoints

Misc:
	- background ice formations with a parallax effect
	- the level generation algorithm doesn't place walls behind alien ruins
	- improved fire and smoke particles
	- water puts out fires more slowly
	- explosion damage is reduced if there are walls or other solid obstacles between and explosion and a character
	- heal and revive commands can also be used on other characters than the controlled one
	- fixed fires occasionally causing incorrect sound clips to loop continuously
	- AI controlled crew members are better at avoiding hazards such as water and fire
	- swimming animation fix: characters don't swim with their legs extended up over their shoulders 
	after a sharp turn

---------------------------------------------------------------------------------------------------------
v0.5.4.5
---------------------------------------------------------------------------------------------------------

- optimized light rendering
- switched fonts again, now to ones that support the cyrillic alphabet
- special symbols are allowed in player names again (unless there's already a player on the server
with a visually identical name)
- fixed monsters not appearing in the position indicated by the sonar in monster missions (or being desynced
whenever they did)
- fixed the game process staying active in the background after a crash
- players can't use headsets that are in the inventory
- the warning message about unlinked vents is only shown once when saving a sub (not for each vent)
- another attempt to fix AddToGUIUpdateList and SetTransformIgnoreContacts errors

---------------------------------------------------------------------------------------------------------
v0.5.4.4
---------------------------------------------------------------------------------------------------------

- new fonts
- spectators see indicators for both subs during combat missions
- fixed saves becoming corrupted if the player saves and quits in the "map view"
- fixed "OpenAL not found" errors if trying to run the game with no enabled audio devices
- fixed OpenAL errors when quitting a round
- fixed unconscious/dead characters falling through floors
- the server list accepts multiple servers from the same IP (assuming they're running on different ports)
- fixed autorestart and the start button getting stuck if the server fails to load the respawn shuttle
- fixed server failing to start a round if the cargo spawnpoint has been placed outside the submarine
- fixed AddToGUIUpdateList errors
- fixed SetTransformIgnoreContacts errors
- tickboxes work again in the item UIs in wiring/character mode
- fixed characters standing in an incorrect position when using railgun controllers in a mirrored sub
- spawning a scorpion (an old placeholder enemy) doesn't crash the game anymore
- submarine editor shows a warning if there are structures/items way outside the sub

---------------------------------------------------------------------------------------------------------
v0.5.4.3
---------------------------------------------------------------------------------------------------------

- a new enemy
- some new sound effects by Omniary
- some structure-specific damage sounds
- the size of docked subs is taken into account when determining the spawn position of the sub (large 
multi-part subs shouldn't spawn inside walls anymore)
- explosion damage is calculated based on the distance to the closest surface of a limb instead of the
center position of the limb (i.e. large monsters can be damaged by smaller explosions)
- added an Undertow Games splash screen
- updated to a newer version of the NVorbis sound library
- fixed a null reference exception caused by wires
- fixed an issue in the way items in alien ruins are initialized, which occasionally caused ID mismatches
(and desync) in items and characters created after generating the ruins
- fixed some item properties not being saved if changed in the editor (e.g. battery recharge speed)
- fixed characters turning into husks when they die, even if the infection has been cured
- fixed docking ports being disconnected in the mirrored subs in the combat missions
- unconscious characters collide with stairs when they're being dragged up
- fixed characters sinking/floating away when using railgun controllers underwater

---------------------------------------------------------------------------------------------------------
v0.5.4.2
---------------------------------------------------------------------------------------------------------

- fixed crashes when removing nodes from a wire (i.e. right clicking with a wire equipped)
- fixed inventory not being drawn in the correct position if switching to a character who's been 
dragged/grabbed by some other character
- fixed wires becoming disconnected when copypasting them
- wire nodes can't be moved when connecting wires to a connection panel
- fixed repeating crash messageboxes if the game fails to resolve a SharpDX exception on startup
- fixed crashing when switching to wiring mode while editing some value of an item
- fixed keyboard focus staying in textboxes after the textbox has been hidden (for example, 
the input fields in the submarine saving prompt)
- fixed error message spam if a docking port is linked to another port in the same sub
- submarine lists in the editor, main menu and server menu are updated when new subs are saved/received
- fixed item editing menu staying on the screen when loading another sub in the editor
- ruins cant span above the top of the level anymore
- the size of the docked subs is taken into account when generating the level
- fixed autorestart timer not resetting at the clients' end if the server fails to start a shift and
resets the timer
- docked subs are forced to correct positions during loading (subs won't get stuck inside each other 
even if the submarines are slightly overlapping in the editor)

- all sounds are paused when switching to submarine editor
- replaced the solid black color inside ice walls with a proper texture
- the background ice texture loops better

---------------------------------------------------------------------------------------------------------
v0.5.4.1
---------------------------------------------------------------------------------------------------------

Bugfixes:
	- copypasted items are now correctly aligned to the "grid"
	- cabinets can be copypasted from a sub to another without the items inside disappearing
	- placing explosives inside an item and that item inside another item doesn't prevent explosions
	- fixed a bug that occasionally caused crashing when the game happens to generate a very small level

Sub editor:
	- structures/items that are behind something else can be selected using a listbox that appears 
	when hovering the cursor over them	
	- wires have to be selected by clicking before any of the points can be moved (makes it possible 
	to move	the correct wire even if it's overlapping with other wires)
	- the selected wire is renderer over all structures
	- points can be added to wires by clicking while holding ctrl
	- disabled music

Misc:
	- some rendering optimization	
	- pathfinding and waypoint generation improvements
	- made mantises more aggressive
	- water flows more slowly through partially damaged walls	

---------------------------------------------------------------------------------------------------------
v0.5.4.0
---------------------------------------------------------------------------------------------------------

Submarine editor:
	- copy, paste and cut functionality
	- items/structures can be copied by holding ctrl while dragging
	- it's possible to move a wire by moving both items it's connected to (without having to move each 
	individual point of the wire separately)
	- "hull volume helper" which makes it easier to select a suitable ballast tank size and 
	NeutralBallastLevel setting in the navigation terminal
	- equipped items are removed when switching from wiring mode to character mode or vice versa
	- no need to wait when deattaching items from the walls with a wrench	


Bugfixes:
	- wires are now positioned correctly in mirrored subs
	- UI elements (buttons, textboxes, etc) can't be clicked through each other anymore
	- fixed a bug that caused crashes when deattaching items from walls
	- fixed a game-crashing particle bug
	- fixed respawned characters getting assigned to a different team than the rest of the characters 
	(causing them to be displayed separately in the crew menu)
	- pathfinding/autopilot fixes

Misc:
	- server hosts can give players special privileges (kick, ban, end round)	
	- saving the contents of the server info box and the traitor setting
	- changes to battery logic: they can now be used to cover the entire power consumption of the 
	electrical grid	(assuming their maximum output is high enough)
	- added "artifact holders" to alien ruins (which can also be used for turning artifacts into power 
	sources if installed in a sub)
	- changes to character collider behavior: crouching changes the size of the collider and it's 
	easier to step over small obstacles


---------------------------------------------------------------------------------------------------------
v0.5.3.4
---------------------------------------------------------------------------------------------------------

- fixed screen turning black in the tutorial
- the moloch attack in the tutorial is now much easier to survive
- servers readd themselves to the master server if they have been removed from the server list
- fixed a bug that caused lights to flicker even if there's enough power
- fixed items disappearing when dropping them in the submarine editor

---------------------------------------------------------------------------------------------------------
v0.5.3.3
---------------------------------------------------------------------------------------------------------

- fixed a bug that caused crashes after a husk-infected player died
- disabled the "zoom effect" when under pressure as a huskified human
- only a limited number of messages are kept in the debug console (prevents performance issues if large 
amounts of messages are added)
- some item and electricity logic optimization
- fixed "sprite tigerthresher not found" errors in the Linux version

---------------------------------------------------------------------------------------------------------
v0.5.3.2
---------------------------------------------------------------------------------------------------------

- fixed character colliders occasionally getting stuck inside walls when switching from swimming to
walking or standing up after being unconscious
- wires can be dragged outside the sub in the editor without disconnecting them
- easier to climb over small obstacles
- combat missions don't reset the "allow respawn" setting
- submarines outside the camera view aren't rendered
- coelanth collider fix

---------------------------------------------------------------------------------------------------------
v0.5.3.1
---------------------------------------------------------------------------------------------------------

- fixed monster movement!

---------------------------------------------------------------------------------------------------------
v0.5.3.0
---------------------------------------------------------------------------------------------------------

Multiplayer:
	- submarine vs submarine missions
	- server hosts can disable spawning of certain characters
	- server hosts can have subs spawn with additional items

Changes to ragdoll movement/animation logic:
	- movement is now controlled by a single invisible physics body which the rest of the ragdoll follows
	- character position syncing is now more accurate and there's less "teleporting"
	- characters are less likely to take impact damage by stumbling in stairs
	- (+ makes working on the new improved netcode much easier)
	- ladders can be slid down by holding the sprint key
	
Submarine Editor:
	- zoom now works relative to the mouse's position rather than the center of the screen
	- fixed selection rectangle not being visible when dragging from bottom right to top left
	- rectangles now have line widths dependent on the camera zoom (lines are still visible after zooming out)

Items:
	- added a particle trail to railgun shells
	- added dim emergency lights which require no power
	- a "glow effect" when moving items between inventory slots
	- option to select which location the autopilot should navigate to
	- fabricator UI shows item descriptions and items that can't be fabricated are grayed out
	
Bugfixes:
	- attempt to fix "DXGI_ERROR_NOT_CURRENTLY_AVAILABLE" errors on startup
	- fixed water flow sounds taking up all the audio channels and preventing other sounds from playing
	when the sub is heavily flooded
	- the start button in the server lobby is re-enabled and autorestart countdown is reset if starting
	a new round fails for whatever reason
	- the colliders of the ice walls match the shape of the walls more accurately
	- player-controlled monsters can damage the submarine from the outside
	- waypoint generation and pathfinding bugfixes

Misc:
	- improved line of sight effect (instead of a solid black "fog of war", a faint image of the 
	surrounding rooms can be seen through walls)
	- less ambient light, and it gets darker when diving deeper
	- a hull-specific ambient light system: light sources increase the amount of light inside rooms, 
	preventing shadows from looking unnaturally dark in fully lit submarines
	- option to disable vsync
	- added a near-indestructible alien ruin wall variant - breaking through the walls with a railgun 
	or a plasma cutter is not always an option anymore
	- added a parallax effect to the particles floating in the ocean

---------------------------------------------------------------------------------------------------------
v0.5.2.0
---------------------------------------------------------------------------------------------------------

Level generation improvements:
	- customizable level generation parameters (see Content/Map/LevelGenerationParameters.xml)
	- different "level types" - each uses a different set of parameters, resulting in more varied levels
	- more vegetation and other decorative background sprites
	- the entrances and exits of the levels have more variety (not always straight vertical tunnels)

Improved MiniMap (now called "Status Monitor"):
	- shows hull integrity and oxygen levels
	- can be configured to only show oxygen/water levels if the rooms have detectors installed

- improved wall damage visuals
- the single player map shows which locations have been visited and the passageways that have been used
- minor visual improvements to the single player campaign menus
- huskification bugfixes
- oxygen isn't distributed through gaps or vents that are underwater (i.e. air pockets can form when the 
sub is flooding)
- molochs (or other large creatures) can't push the sub around as easily anymore

---------------------------------------------------------------------------------------------------------
v0.5.1.3
---------------------------------------------------------------------------------------------------------

- server whitelists
- a new monster
- improved autopilot
- background sprites and creatures can be customized via Content Packages
- Linux clients can connect to Windows servers again (and vice versa)
- fixed the upper boundary of the level occasionally being possible to pass through
- textboxes can't be selected through other UI elements anymore

---------------------------------------------------------------------------------------------------------
v0.5.1.2
---------------------------------------------------------------------------------------------------------

- hacked clients can't join a full server or change the name of their character anymore
- option to choose which character to control using the "control" command when there are multiple 
characters/creatures with the same name
- a console command for spawning items
- the server logs show who sent each chat message

---------------------------------------------------------------------------------------------------------
v0.5.1.1
---------------------------------------------------------------------------------------------------------

- fixed non-password protected servers being impossible to join to
- some more security checks

---------------------------------------------------------------------------------------------------------
v0.5.1.0
---------------------------------------------------------------------------------------------------------

- getting attacked by a husk will slowly turn the victim into a husk

- spam filter
- added server options to the ingame HUD
- fixed tiger thresher spawning on Linux
- a more secure password authentication method (again)
- ingame players can't receive messages from lobby players anymore
- more server-side security checks

- medical doctors always have a high enough medical skill to fabricate any drug
- ai-controlled crew can be spawned using the console in multiplayer
- it's possible to manually attack when controlling a creature
- randomly spawned artifacts are spread out better throughout the level
- characters won't let go of a person they're dragging when entering/exiting the sub
- respawned players get the same ID card tags they would've gotten if they had spawned inside the main sub
- highlighted characters glow in the dark

---------------------------------------------------------------------------------------------------------
v0.5.0.3
---------------------------------------------------------------------------------------------------------

- fixed "submarine not found" errors when starting a round after downloading a shuttle from the server
- console command for banning
- a more secure password authentication method
- fixed players with a space in their name being impossible to kick/ban via the console
- banlist is saved immediately after banning someone instead of when shutting down the server
- IP addresses are visible in netstats
- client names are sanitized
- bunch of miscellaneous anti-cheat measures
- fixed docking ports leaking if multiple vessels dock to the main sub
- cargo is always spawned in the main sub even if there are cargo spawnpoints in the docked vessels

---------------------------------------------------------------------------------------------------------
v0.5.0.2
---------------------------------------------------------------------------------------------------------

- more server-side sanity checks to prevent (desynced or hacking) players from doing things their 
characters shouldn't be able to do
- fixed collision issues at docking ports (such as shooting up in the air when trying to drop down into
a docked shuttle while shuttle hatch is closed)
- fixed crashing when commanding a crew member to use a railgun in the single player mode
- fixed chatbox staying disabled after being stunned (and reappearing when being stunned again)

---------------------------------------------------------------------------------------------------------
v0.5.0.1
---------------------------------------------------------------------------------------------------------

- selecting the same sub as the respawn shuttle and the main submarine works now
- fixed the ''end round'' tickbox not appearing if joining and spawning mid-round
- ruin walls/doors can be cut again

---------------------------------------------------------------------------------------------------------
v0.5.0.0
---------------------------------------------------------------------------------------------------------

Support for multiple submarines (no full-fledged submarine vs submarine battles yet, but they're coming
in future updates!):
	- Submarine files can be "merged", i.e. submarines can consist of multiple separate parts which can
	be docked into each other
	- the multiplayer mode has a "respawn shuttle" which transports respawned players from the entrance
	to the main submarine
	- parts of the submarine and characters inside them can be left behind in the single player mode
	(and later salvaged if you wish to do so)

Multiplayer:
	- fixed a bunch of bugs that caused entity IDs not to match between the clients and the server (which
	caused severe syncing issues)
	- fixed monster inventory syncing (i.e. husk inventory syncing)
	- fixed server description box not being synced with clients
	- search bar for server logs
	- more server options
	- fixed the occasional "queue empty" error messages when attempting to send submarine files to players
	- characters can't be freely named anymore - they'll have the same name as the client

Items:
	- items can be equipped/unequipped by double clicking
	- longer railgun view distance
	- changes to the logic that determines which item is being highlighted - now it's much easier to
	select specific items in cramped subs
	- highlighted items glow (so it's easier to see which item you're targeting in the dark)
	- fixed an electricity bug that sometimes caused parts of the grid to not carry any power after 
	a junction box has been broken and repaired
	- option to choose the output of a signal check component when the signal doesn't match
	- fixed fire extinquishers
	- item search bar in the submarine editor
	- fixed cargo items spawning in incorrect positions (which occasionally caused some serious problems 
	if the item happened to be a crate full of nitroglycerin)
	- flares burn longer
	- fixed flashes from explosions/sparks/flares occasionally ''staying on''
	- cameras: can be connected to a railgun controller (or any other selectable controller) to remotely
	view rooms or areas around the sub

Submarines:
	- the mass of a submarine depends on its size - larger submarines require more force to move around
	(custom subs may need some modifications to get the top speeds of the smaller/larger subs back to a
	steerable level)
	- changes to depth damage logic: structures with more health need more pressure before they start taking
	damage (i.e. submarines with thicker walls and no windows can go deeper)

Misc:
	- stunned characters can't move items in their inventory
	- characters can run while grabbing/dragging someone
	- fixed a bug that made it impossible to spawn characters through the console in the Linux version
	- NPCs won't close doors/hatches on themselves and are better at handling stairs/ladders
	- pathfinding bugfixes


---------------------------------------------------------------------------------------------------------
v0.4.1.6
---------------------------------------------------------------------------------------------------------

- vote kicking
- fixed reverting back to the first sub on the list after each round when using manual submarine selection
- fixed lights "bleeding" through walls
- fixed crashing if the submarine contains hulls far away from the rest of the submarine
- corricodone is slightly more effective
- battery charge can be set higher than the default capacity of 2000 (assuming the capacity is set higher)
- job assignment bugfixes
- head sprites can be given tags (e.g. customhead[tag].png) which will make the game select body sprites
with a matching tag (e.g. customtorso[tag].png) for the character
- some new head sprites
- pathfinding errors (which may be caused by missing or incorrectly placed waypoints in custom subs)
don't cause the debug console to pop up
- added missing music clips to the Linux build

---------------------------------------------------------------------------------------------------------
v0.4.1.5
---------------------------------------------------------------------------------------------------------

- fixed oxygen distribution through vents not being calculated correctly
- fixed another bug that caused ''object reference not set to an instance of object'' error messages
when starting a new round
- fulgurium batteries can be put in flashlights and sonars
- more powerful oxygen generators in vanilla subs (small rooms aren't deathtraps anymore)

Linux version:
- fixed ''unable to load coelanth.png'' error messages
- fixed non-matching content packages between the Linux and Windows versions

---------------------------------------------------------------------------------------------------------
v0.4.1.4
---------------------------------------------------------------------------------------------------------

- fixed clients failing to select submarines in their "Submarines/Downloaded" folder

---------------------------------------------------------------------------------------------------------
v0.4.1.3
---------------------------------------------------------------------------------------------------------

- fixed errors when updating the submarine list if the host is has selected the "play yourself" option

---------------------------------------------------------------------------------------------------------
v0.4.1.2
---------------------------------------------------------------------------------------------------------

- fixed the ''queue empty'' error messages when attempting to download a sub from the server

---------------------------------------------------------------------------------------------------------
v0.4.1.1
---------------------------------------------------------------------------------------------------------

- changes to connection panel layout: less wire overlap, making it easier to select individual wires

- fixed missions not appearing in single player

- clients see the submarines the host has instead of their own subs in the server lobby
- clients can vote for subs they don't have
- servers check whether all the clients have the selected submarine file before starting a round, and if not,
give them some time to start downloading it

- item sprites are visible in fabricator menus
- some new wall sprites
- fixed small walls being impossible to fix after they've broken
- ruin walls look slightly different from normal walls on sonar
- cargo is placed at the cargo spawnpoint instead of a random position within the hull it's inside
- fixed light emitted by flares not disappearing after the flare burns out
- flares won't stop burning if picked up and placed in the inventory
- minor changes to the lighting - small lights aren't ''skewed''
- fixed the ''CastShadows'' parameter of light components not being saved
- fixed fires using up all the sound channels and preventing other sounds from playing

- fixed the ''blood overlay'' still being visible when starting a new round or switching characters
- fixed fractal guardians occasionally killing themselves by slamming against the walls
- enemies use pathfinding inside the submarine

---------------------------------------------------------------------------------------------------------
v0.4.1.0
---------------------------------------------------------------------------------------------------------

- alien ruins and some special monsters/items that only spawn inside them
- improved lighting
- flashlights and flares
- depth charges
- items can be moved from the inventory to cabinets/containers by double clicking
- option to choose mission type in multiplayer
- fixed crashes when using medical syringes in multiplayer
- fixed characters occasionally ''exploding'' or being launched to a random direction when
entering/exiting the sub
- fixed long map seeds always generating the same map
- fixed item loading issues when playing the game on a PC using the Turkish locale (and most likely some
other locales with special uppercase/lowercase rules)

---------------------------------------------------------------------------------------------------------
v0.4.0.3
---------------------------------------------------------------------------------------------------------

- stun syncing bugfix
- fixed dead/unconscious characters being impossible to select in the info menu
- fixed crashes when detonating nitroglyserine by injecting it
- oxygen level deteriorates more slowly when unconscious
- instructions for dealing with broken junction boxes in the tutorial

---------------------------------------------------------------------------------------------------------
v0.4.0.2
---------------------------------------------------------------------------------------------------------

- fire doesn't affect items in characters' inventories (e.g. holding a thermal artifact won't blow up
oxygen tanks in your inventory)
- handheld sonars only consume power when they're on
- cargo missions are more common
- fix for endworms (and possibly other large monsters) teleporting partially inside the sub
- some more chemicals/drugs
- doctor's clothes have some extra slots for chemicals

---------------------------------------------------------------------------------------------------------
v0.4.0.1
---------------------------------------------------------------------------------------------------------

- radio messages are visible to spectators
- added a bunch of handheld sonars to the vanilla subs
- junction boxes take more time to break in water
- moved the junction boxes inside Nehalennia's ballast tanks to a drier location

---------------------------------------------------------------------------------------------------------
v0.4.0.0
---------------------------------------------------------------------------------------------------------

DOCTORS:
	- medical doctors (can fabricate various drugs/chemicals and give CPR to unconscious characters)
	- changes to the dying logic: characters will be unconscious when their health or oxygen goes below 0, 
	and die when it drops to -100
	- medical syringes can be used on other characters
	- any chemicals can be inserted in medical syringes

Items:
	- handheld sonars
	- crates, small medical/chemical cabinets
	- junction boxes, sonar monitors, navigation terminals and engines break if they're underwater long enough
	- reactor cools down if it's underwater (multiple fuel rods are required to bring the temperature back up)
	- forces are applied to items (not just characters) when the submarine hits something
	- changes to the logic for distributing oxygen through vents: the oxygen generator pushes more oxygen 
	to larger rooms instead of dividing the oxygen output equally between vents

	- autopilot bugfixes
	- the amount of oxygen/battery left is visible in the inventory slot of the ''parent item''
	- new inventory slot for masks, headsets, etc

	- fixed ''signal loops'' crashing the game
	- OR gates work properly now
	- AND/OR gates can be set to send out a signal when the input conditions aren't met

	- fabricating items may require some specific skill levels

	- a bunch of new sprites

Multiplayer:
	- fixed a bug that caused the server to resend a ton of messages to a client who's been temporarily 
	disconnected, causing syncing issues to every player
	- fixed syncing issues related to items breaking (eg junction boxes being broken only for some players)
	- fixed dead monsters occasionally ''teleporting'' inside the sub in multiplayer
	- fixed missions not matching between Linux and Windows builds
	- fixed traitor messages reappearing at the start of a new round after disabling traitors
	- mid-round chat messages have a limited range
	- players are equipped with a headset which can be used for remote communication (and making
	voice-controlled devices/systems)
	- speech bubble icon is displayed next to the character when speaking in multiplayer

Misc:
	- level generation improvements: small cave systems, more vegetation, more varied layouts
	- option to spawn characters/monsters near, inside or outside the sub
	- crouching
	- cargo missions
	- borderless windowed mode (aka fake fullscreen)
	- option to enable some additional debug logging (by setting ''verboselogging'' to true in the config file)
	- a menu that shows the mission description mid-round
	- game settings can be changed mid-round
	- submarine descriptions
	- fixed characters getting stuck inside a wall when trying to get inside the sub through a hole

---------------------------------------------------------------------------------------------------------
v0.3.6.0
---------------------------------------------------------------------------------------------------------

- bunch of crew AI improvements and bugfixes: they are now much better at keeping themselves alive and
fixing leaks
- crew AI can be toggled on and off using "DisableCrewAi" and "EnableCrewAi" commands
- fixed crashing when switching from wiring mode to character mode
- inventory is visible in wiring mode
- several wiring bugfixes
- emergency sirens and alarm buzzers
- fixed light components throwing errors when receiving an invalid color value to the "set_color" input
- fixed bright lights making it impossible to see whether a light component is on or off
- relay components break if too much power is directed through them
- relay components are active by default and they can be toggled on/off in the editor
- wires can be created in fabricators
- label text color can be changed
- boolean (true/false) properties are displayed as checkboxes in the editor

---------------------------------------------------------------------------------------------------------
v0.3.5.1
---------------------------------------------------------------------------------------------------------

- fixed unclickable buttons/checkboxes in the launcher
- fixed battery cells not reloading when placed inside a battery

---------------------------------------------------------------------------------------------------------
v0.3.5.0
---------------------------------------------------------------------------------------------------------

- items float and can be moved around by flowing water
- wiring mode which makes wiring more convenient in the editor
- networking bugfixes and improvements
- changes to the logic that determines how far the monsters can see/hear the submarine from - now it's 
possible to evade some monsters by turning off noisy devices and/or stopping the submarine
- invisible entities (items inside cabinets, hulls/gaps when they've been hidden) can't be highlighted 
or selected in the editor
- fixed monster/item spawnpoints being placed in unreachable locations
- relay and delay components
- fixed lights not being positioned correctly on moving items
- added a ''set_color'' connection to light components
- ladders outside the sub can be climbed
- changes to drowning/suffocation logic: amount of oxygen drops at a fixed rate instead of effects 
"stacking" (e.g. when wearing a diving suit with no oxygen tank in a room with low oxygen)
- fixed projectiles not colliding with the submarine when shot from the outside

---------------------------------------------------------------------------------------------------------
v0.3.4.2
---------------------------------------------------------------------------------------------------------

- fixed characters passing through walls/windows that have already been repaired
- fixed the spawn command in Linux version
- fixed clients being able to join servers with the wrong password

---------------------------------------------------------------------------------------------------------
v0.3.4.1
---------------------------------------------------------------------------------------------------------

- fixed a major bug in the networking code, which caused the server to incorrectly determine the order 
of messages received from different clients and discard valid messages
- fixed levels with the same seed appearing different between the Linux and Windows versions
- creatures spawned using the console are synced with clients
- password prompt for password-protected private servers
- holes in the walls can be seen through
- bleeding gradually slows down - making an enemy bleed isn't a guaranteed kill anymore
- mantises don't bleed
- fixed crashing when swapping some specific equipped items with another item in the inventory
- fixed deconstructor, fabricator and railgun connection panels closing immediately after opening

---------------------------------------------------------------------------------------------------------
v0.3.4.0
---------------------------------------------------------------------------------------------------------

Multiplayer:
- missing submarine files can be downloaded from the server host
- player syncing bugfixes (aiming is visible to other players, smoother movement in water)
- creature syncing bugfixes (less teleporting around)
- fixed the server lobby displaying wrong numbers of votes at the client's side
- fixed the server list displaying 16/16 players as 0/16
- saving server settings

Other:
- skyholder artifacts consume oxygen
- thermal artifacts catch fire even if they're not being held
- placed items/structures can be resized in the editor
- items in the inventory can be swapped between slots by dragging them on top of each other
- cyrillic character support
- slower underwater scooters
- fixed pressure building up in enclosed rooms full of water, even if there were no hull breaches
- an indicator which shows the direction of the sub when spectating
- fixed crashing when loading a submarine with no hulls

---------------------------------------------------------------------------------------------------------
v0.3.3.1
---------------------------------------------------------------------------------------------------------

- fixed the chatbox obstructing other player's inventory when grabbing/dragging a character
- fixed characters randomly letting go of bodies they're dragging
- the keybinds configured in the options menu are used when moving the camera as a spectator

---------------------------------------------------------------------------------------------------------
v0.3.3.0
---------------------------------------------------------------------------------------------------------

- more visible indicators when taking damage, running out of oxygen or being crushed by pressure
- handcuffs
- changes in the welding/cutting targeting logic: it's now possible to target "corners" of the hull
even if the section of the wall is obstructed by adjacent walls
- fixed submarines spawning in a wrong position (e.g. inside walls) if the submarine has been built
far away from the coordinates (0,0)
- fixed a memory leak caused by item sprites
- character/inventory syncing bugfixes
- fixed spectators not seeing their own chat messages
- scrollable list of clients in the network statistics view
- small changes to the vanilla subs
- fixed the water brightness in Linux version

---------------------------------------------------------------------------------------------------------
v0.3.2.6
---------------------------------------------------------------------------------------------------------

- fixed the broken password box
- maximum number of players per server increased to 16 (note that none of the vanilla subs have been
designed for a crew that large)
- junction boxes and power sources can be connected with multiple parallel wires without multiplying
the power output
- velocity and depth readings on navigation terminals
- location types and missions are included in content packages

---------------------------------------------------------------------------------------------------------
v0.3.2.5
---------------------------------------------------------------------------------------------------------

- fixed null reference exception when starting a client

---------------------------------------------------------------------------------------------------------
v0.3.2.4
---------------------------------------------------------------------------------------------------------

- fixed crashing when highlighting a dead husk
- fixed the unclickable checkboxes in server settings
- sending messages to specific players using ''d; [message]'' and ''name; [message]'' (messages can be
sent to players with spaces in their names now)
- more descriptive log messages when taking items from cabinets or other players

---------------------------------------------------------------------------------------------------------
v0.3.2.3
---------------------------------------------------------------------------------------------------------

- fixed characters dropping items when a spectator joins
- fixed any selected textbox in the server lobby accepting keyboard input after a round starts
- praise the honkmother

---------------------------------------------------------------------------------------------------------
v0.3.2.2
---------------------------------------------------------------------------------------------------------

- clearing the server log after saving!
- saving the log after every round (even if it isn't full)

---------------------------------------------------------------------------------------------------------
v0.3.2.1
---------------------------------------------------------------------------------------------------------

- fixed words missing from chat messages
- the server log UI doesn't scroll to the bottom when new lines appear, making it easier to read it during
a round

---------------------------------------------------------------------------------------------------------
v0.3.2.0
---------------------------------------------------------------------------------------------------------

- server logs 
- server admins have the option to send messages only to dead players and spectators (/d [message]) or 
to one specific player (/name [message])
- more reliable door syncing
- railgun syncing bugfixes
- longer view distance when outside
- deattaching items takes some time
- welders and cutters do damage to players/enemies again
- a new enemy
- molochs can do damage to players

---------------------------------------------------------------------------------------------------------
v0.3.1.5
---------------------------------------------------------------------------------------------------------

- fixed projectiles/weapons not colliding with characters

---------------------------------------------------------------------------------------------------------
v0.3.1.4
---------------------------------------------------------------------------------------------------------

- fixed items ''floating'' in some of the custom subs
- fuel rods can't be turned back to uranium/incendium bars if they've been used

---------------------------------------------------------------------------------------------------------
v0.3.1.3
---------------------------------------------------------------------------------------------------------

- round end votes can be toggled off
- less confusing way of displaying the number of votes (yes/no instead of yes/number of voters)

---------------------------------------------------------------------------------------------------------
v0.3.1.2
---------------------------------------------------------------------------------------------------------

- players can vote to end a round in multiplayer
- fixed fabricator syncing
- fixed hulls being invisible in the editor
- spectators can only speak to dead players
- minor changes to the map generation algorithm: there's now more variety in the cavern shapes
- added a new type of railgun shell
- diving suits wont protect from the water pressure in the abyss anymore
- added some spare buttons to Vellamo

---------------------------------------------------------------------------------------------------------
v0.3.1.1
---------------------------------------------------------------------------------------------------------

- fixed a major bug that caused item/monster ID mismatches between the server and the clients, which 
accounted for many of the monster/inventory/item syncing issues
- improved player position syncing

---------------------------------------------------------------------------------------------------------
v0.3.1.0
---------------------------------------------------------------------------------------------------------

- batteries have separate power_in and power_out connections, which allows recharging and powering devices
simultaneously and using separate recharge circuits
- using supercapacitors as a substitute for batteries now longer works: they have a very low energy storage
capacity and are only suitable for providing short high-energy power surges
- improved connection panel graphics
- fixed a bug that caused the submarine to swoop to a random direction when a character enters it
- fixed crashed caused by EntityGrid.GetEntites()

---------------------------------------------------------------------------------------------------------
v0.3.0.5
---------------------------------------------------------------------------------------------------------

- fixed autopilot crashing the game
- fixed reactor not catching fire when going above the configured ''fire temperature''
- fixed a duplicate "Play yourself" checkbox appearing in the lobby screen after rounds

---------------------------------------------------------------------------------------------------------
v0.3.0.4
---------------------------------------------------------------------------------------------------------

- submarine editor can be used without the console now
- autopilot can be set to maintain the current position of the sub
- monster syncing bugfixes
- ladder syncing bugfixes
- fixed server randomly stunning the players
- fixed "submarine not found" errors which occurred in multiplayer if the filename didn't match the
name of the submarine
- fixed new structures not lining up with existing ones if switching to editor while a round is running
- fixed a bug in shadow rendering which caused memory leaks 
- the autoupdater only checks the Content folder when deleting files that don't belong to the latest version
(i.e. the autoupdater won't delete your mods as long as they aren't saved in the Content folder)
- molochs and endworms are immune to bleeding!

---------------------------------------------------------------------------------------------------------
v0.3.0.3
---------------------------------------------------------------------------------------------------------

- fixed selecting stairs and items outside the sub in editor
- fixed crashing when pressing the ''start'' button while no route is chosen in single player 
- fixed fire syncing
- fixed another bug that crashed the game if in the lobby when a round ends 
- camera keeps moving with the sub when typing into chatbox in spectator mode

---------------------------------------------------------------------------------------------------------
v0.3.0.2
---------------------------------------------------------------------------------------------------------

- fixed crashing when picking up a thermal artifact outside the sub
- fixed clients crashing if in the lobby when a round ends
- fixed crashing when attempting to join a password-protected server
- camera position is set at the position of the sub when entering spectator mode
- AI crew equips a diving suit before going outside the sub


---------------------------------------------------------------------------------------------------------
v0.3.0.1
---------------------------------------------------------------------------------------------------------

- fixed inventory not being visible when using character mode in the editor
- adding hulls and gaps works properly when switching to editor after a round has been started
- fixed item selecting when switching to character mode after a round has been started
- fixed a bug that made it impossible to fix broken walls after saving and reloading
- fixed crashing when trying to place ladders when no submarine has been loaded
- trying to generate waypoints for an empty sub won't crash the game anymore
